#include <stdio.h>

#include <grp.h>
#include <iostream.h>
#include <pwd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>   // gettimeofday
#include <sys/types.h>
#include <unistd.h>

#include "action_forms_aux.h"
#include "browser.h"
#include "browser_menu.h"
#include "cb_fkey.h"
#include "cb_key.h"
#include "client_msg.h"
#include "colour_forms_aux.h"
//#include "cwd_forms_aux.h"
#include "dir_menu.h"
#include "display_forms_aux.h"
#include "error_notifier_forms_aux.h"
#include "flspecial.h"
#include "global.h"
#include "gl_utility.h"
#include "help_forms_aux.h"
#include "make.h"
#include "menu.h"
#include "options_forms_aux.h"
#include "panel.h"
#include "pathnames.h"
#include "sort_forms_aux.h"
#include "fork_pipe.h"
#include "status_forms_aux.h"
#include "utility.h"
#include "wm_forms_aux.h"


/* fun globals for the menu. */

void do_colours(int){
    tool_do_colours();
}

static void do_display(int){
    //cerr << "do_display !\n";
    display_show_form();
}

static void do_set_target(int){
    SetTargetCB(NULL, 0);
}

void do_sorting(int){
    //cerr << "do_sorting !\n";
    sort_show_form();
}

static void do_global(int){
    OptionsButtonCB(NULL,0);   
}

void do_clone(int){
    //cerr << "do_clone !\n";
    BrowserCloneButtonCB(NULL, 0);
}

void do_kill(int){
    //cerr << "do_kill !\n";
    BrowserKillButtonCB(NULL, 0);
}

void do_reread(int){
    PadVirguleKeyCB(NULL, 0);
}

void do_forward(int){
    if(source_browser){
	source_browser->forward_selection();
    }
}

void do_target_forward(int){
    if(target_browser){
	target_browser->forward_selection();
    }
}

void do_get_shell(int){
#ifndef SGI
    safe_system("xterm &");
#else
    safe_system("/usr/sbin/xwsh &");  // needs paths.
#endif
}

void do_chdir(int){
    //cerr << "do_chdir !\n";
//    cwd_show_form();
}

void browser_make_menu_cb(FL_OBJECT *, long){
    long makefile_menu = get_makefile_menu();
    if(makefile_menu > 0){
	do_pup(makefile_menu);
    }
}

void browser_selection_event_cb(FL_OBJECT *panel, long){
    // static int new_mouse_key = 0, old_mouse_key = 0;
    //   cerr << "brws selection event cb." << endl;
    if(!source_browser){
	program_unstable("no source browser ?");
	return;
    }
    tool_set_source(panel->form);
    int line = fl_get_panel(panel);

    if(line > 0){
	// only bother to check for dotdotif selection event ...
/*	
#ifdef NEED_SWEEP_KLUDGE
	const char *fname = source_browser->extract_filename(line);
	if(!fname){
	    program_unstable(" NULL fname in b_s_event_cb");
	    return;
	}
	int do_toggle_flag = FALSE;
	if(strcmp(fname, ".") == 0){
	    //timed_error_notifier("You cannot select the current directory `.'", notifier_secs);
	    do_toggle_flag = TRUE;
	} else if(strcmp(fname, "..") == 0){
	    //timed_error_notifier("You cannot select the parent directory `..'", notifier_secs);
	    do_toggle_flag = TRUE;
	}
	if(do_toggle_flag){
	    fl_deselect_browser_line(browser, line);
	} else {
	    update_selection_state();
	}
#endif
*/
        source_browser->freeze();
        source_browser->deselect_file("."); 
        source_browser->deselect_file(".."); 
        source_browser->unfreeze();
        update_selection_state(TRUE);
    } else if(line < 0){
        update_selection_state(TRUE);
	// just in case
    } else {
	// line == 0, we almost know it's a middle mouse/move current event.
    }
}

static void do_search(int){
    source_browser->search_event_cb();
    // fl_qenter(BROWSER_SEARCH_CMSG, 1);
}

void browser_menu_event_cb(FL_OBJECT *, long){
    static int first = TRUE;
    static long options_menu, actions_menu;
    // we know that the source browser is valid.
    //cerr << "menu requested" << endl;
    // let's have a little browser specific pop-up.
    if(first){
	first = FALSE;
	
	options_menu = new_pup();
	add_to_pup(options_menu, "Options %t", 0);
	add_to_pup(options_menu, "Colours %f", (long) do_colours, "Cc");
	add_to_pup(options_menu, "Display %f", (long) do_display, "Dd");
	add_to_pup(options_menu, "Global %f",  (long) do_global,  "Gg");
	add_to_pup(options_menu, "Sorting %f", (long) do_sorting, "Ss");

	actions_menu = new_pup();
	add_to_pup(actions_menu, "Actions %t", 0);
	add_to_pup(actions_menu, "Clone this browser%f",           (long) do_clone,          "Cc");
	add_to_pup(actions_menu, "Kill this browser (Alt-q, Esc-q)%f",    (long) do_kill,           "Kk");
	add_to_pup(actions_menu, "Forward Selection (Alt-f, Esc-f)%f",    (long) do_forward,        "Ff");
	add_to_pup(actions_menu, "Forward Target Slctn (Alt-F, Esc-F)%f", (long) do_target_forward, "");
	add_to_pup(actions_menu, "Search (Ctrl-s)%f",              (long) do_search,         "Ss");
	add_to_pup(actions_menu, "Set Target (Ctrl-t)%f",          (long) do_set_target,     "Tt");
	add_to_pup(actions_menu, "Re-Read Dir (Keypad-/)%f",       (long) do_reread,         "Rr");
	//add_to_pup(actions_menu, " %f",          (long) do_,       "");
	//add_to_pup(actions_menu, "Get Shell %f",     (long) do_get_shell, "lL");
    }

    long pup = new_pup();

    char buf[64];
    sprintf(buf, "Browser #%d (F2)%s", source_browser->get_ID(), "%t");
    add_to_pup(pup, buf, 0);
    add_to_pup(pup, "Actions %m",    actions_menu,  "Aa");


    long dir_menu = get_dir_menu();
    if(dir_menu > 0){
	add_to_pup(pup, "Directory %m", dir_menu,     "Dd");
    }
    long makefile_menu = get_makefile_menu();
    if(makefile_menu > 0){
	add_to_pup(pup, "Make %m",   makefile_menu, "Mm");
    }
    add_to_pup(pup, "Options %m",   options_menu, "Oo");
    long windows_menu = get_windows_menu();
    if (windows_menu > 0){
	add_to_pup(pup, "Windows %m",   windows_menu, "Ww");
    }

    do_pup(pup);
    free_pup(pup);
}

static int grp_flag = FALSE;

static int chown_single_many_files(const char *fname, const char *source_dir){
    if(!source_dir || !chown_path || !chgrp_path) return FALSE;
    int ask_dir_flag = FALSE;
    if(fname){
	ask_dir_flag = source_browser->line_is_dir(-1, fname);
    } else {
	int line;
	const char *name_buf = source_browser->get_first_selection(line);
	while(name_buf && !ask_dir_flag){
	    ask_dir_flag = source_browser->line_is_dir(line, name_buf);
	    //ask_dir_flag = source_browser->line_is_dir(-1, name_buf);
	    name_buf = source_browser->get_next_selection(line);
	}
    }
    
    char new_owner_buf[64];

    if(grp_flag){
	gid_t gid = getegid();
	struct group *g_ent = getgrgid(gid);
	if(g_ent){
	    const char *result = OKCancel("Please give a group ID:", g_ent->gr_name);
	    if(!result) return FALSE;
	    strcpy(new_owner_buf, result);
	} else {
	    cerr << "UC: unable to get your group name.\n";
	    return FALSE;
	}
    } else {
	uid_t uid = geteuid();
	struct passwd *pw_ent = getpwuid(uid);
	if(pw_ent){
	    const char *result = OKCancel("Please give an owner ID:", pw_ent->pw_name);
	    if(!result) return FALSE;
	    strcpy(new_owner_buf, result);
	} else {
	    cerr << "UC: unable to get your login name.\n";
	    return FALSE;
	}
    }

    int n_selected = source_browser->get_n_selected();  
    int n_args = 4; // name, flag, new owner, NULL, and files.
    if(n_selected > 0){
	n_args += n_selected;
    } else {
	n_args++;
    }
    char **chown_argv = (char **) fl_calloc(n_args, sizeof(char *));
    int argc = 0;

    if(grp_flag){
	chown_argv[argc] = strdup("chgrp");
    } else {
	chown_argv[argc] = strdup("chown");
    }
    argc++;

    if(ask_dir_flag){
	if(ask_question(FALSE, "Apply change recursively to all subdirectories ?")){
	    chown_argv[argc] = strdup("-R");
	    argc++;
	}
    }

    chown_argv[argc] = strdup(new_owner_buf);
    argc++;

    if(n_selected > 0){
	const char *name_buf = source_browser->get_first_selection();
	while(name_buf){
	    chown_argv[argc] = strdup(name_buf);
	    argc++;
	    name_buf = source_browser->get_next_selection();
	}
    } else {
	chown_argv[argc] = strdup(fname);
	argc++;
    }
    chown_argv[argc] = NULL;

    int retval = do_fork_cmd((grp_flag ? chgrp_path : chown_path), (const char**)chown_argv);

    // crashes ! why ? possibly delete vs free
    // this new version should be good.
    for(int i=0; i<n_args; i++){
	if(chown_argv[i]){
	    fl_free(chown_argv[i]);
	    chown_argv[i] = NULL;
	}
    }
    if(chown_argv){
#ifdef SUN    
	fl_free((char *)chown_argv);
#else    
	fl_free(chown_argv);
#endif    
	chown_argv = NULL;
    }
    return retval;
}

static int chown_many_files(const char *source_dir){
    return chown_single_many_files(NULL, source_dir);
}

static int chown_single_file(const char *fname, const char *source_dir){
    return chown_single_many_files(fname, source_dir);
}

void do_change_owner(int){
    source_dir_action(chown_single_file, chown_many_files,
		      (grp_flag ? "Change group of" : "Change owner of"),
		      TRUE, TRUE, NULL, TRUE, FALSE);
}

static void do_select_deselect(int select_flag){
    char owner_buf[64];

    if(grp_flag){
	gid_t gid = getegid();
	if(source_browser->show_symbolic_flag){
	    struct group *g_ent = getgrgid(gid);
	    if(g_ent){
		strcpy(owner_buf, g_ent->gr_name);
	    } else {
		cerr << "UC: unable to get your group name.\n";
		return;
	    }
	} else {
	    sprintf(owner_buf, "%d", gid);
	}
    } else {
	uid_t uid = geteuid();
	if(source_browser->show_symbolic_flag){
	    struct passwd *pw_ent = getpwuid(uid);
	    if(!pw_ent){
		cerr << "couldn't get login name.\n";
		return;
	    }
	    strcpy(owner_buf, pw_ent->pw_name);
	} else {
	    sprintf(owner_buf, "%d", uid);
	}
    }

    const char *result = NULL;

    if(select_flag){
	result = OKCancel((grp_flag ?
			   "Select all files whose group matches:" :
			   "Select all files owned by:"),
			  owner_buf
	);
    } else {
	result = OKCancel((grp_flag ?
			   "Deselect all files whose group matches:" :
			   "Deselect all files owned by:"),
			  owner_buf
	);
    }
    if(result){
	if(select_flag){
	    source_browser->select_all_item_matches(result, (grp_flag ? group_e : owner_e));
	} else {
	    source_browser->deselect_all_item_matches(result, (grp_flag ? group_e : owner_e));
	}	    
	update_selection_state();
    }
}

void do_deselect_by_owner(int){
    do_select_deselect(FALSE);
}

void do_select_by_owner(int){
    do_select_deselect(TRUE);
}

void do_main_sort_owner(int){
    source_browser->new_fst_sort(grp_flag ? group_e : owner_e);
}

void do_aux_sort_owner(int){
    source_browser->new_snd_sort(grp_flag ? group_e : owner_e);
}

void do_numeric(int){
    source_browser->show_symbolic_flag = FALSE;
    display_form_sync();
    source_browser->update(TRUE);
}

void do_symbolic(int){
    source_browser->show_symbolic_flag = TRUE;
    display_form_sync();
    source_browser->update(TRUE);
}

void do_hide_owner(int){
    if(grp_flag){
	source_browser->show_group_flag = FALSE;
	status_msg(1, "Use F2-Options-Display to get the group column back.");
    } else {
	source_browser->show_owner_flag = FALSE;
	status_msg(1, "Use F2-Options-Display to get the owner column back.");
    }
    display_form_sync();
    source_browser->update(TRUE);
}

static void group_owner_cb(void){
    long pup = new_pup();
    if(grp_flag){
	add_to_pup(pup, "Group (Alt-g, Esc-g)%t", 0);
	add_to_pup(pup, "Select by Group%f",   (long)  do_select_by_owner,   "Ss");
	add_to_pup(pup, "Deselect by Group%f", (long)  do_deselect_by_owner, "Dd");
    } else {
	add_to_pup(pup, "Owner (Alt-o, Esc-o)%t", 0);
	add_to_pup(pup, "Select by Owner%f",   (long)  do_select_by_owner,   "Ss");
	add_to_pup(pup, "Deselect by Owner%f", (long)  do_deselect_by_owner, "Dd");
    }
    if(grp_flag){
	if(source_browser->fst_sort != group_e){
	    add_to_pup(pup, "Set as Main Sort%f",   (long)  do_main_sort_owner,   "Mm");
	} else {
	    add_to_pup(pup, "(Group is Main Sort)%f",  (long)  do_main_sort_owner,   "Mm");
	}
	if(source_browser->snd_sort != group_e){
	    add_to_pup(pup, "Set as Aux. Sort%f",   (long)  do_aux_sort_owner,    "Aa");
	} else {
	    add_to_pup(pup, "(Group is Aux. Sort)%f",   (long)  do_aux_sort_owner,    "Aa");
	}
    } else {   
	if(source_browser->fst_sort != owner_e){
	    add_to_pup(pup, "Set as Main Sort%f",   (long)  do_main_sort_owner,   "Mm");
	} else {
	    add_to_pup(pup, "(Owner is Main Sort)%f",  (long)  do_main_sort_owner,   "Mm");
	}
	if(source_browser->snd_sort != owner_e){
	    add_to_pup(pup, "Set as Aux. Sort%f",   (long)  do_aux_sort_owner,    "Aa");
	} else {
	    add_to_pup(pup, "(Owner is Aux. Sort)%f",   (long)  do_aux_sort_owner,    "Aa");
	}
   }

    if(source_browser->show_symbolic_flag){
	add_to_pup(pup, "Show Numeric ID %f", (long) do_numeric,  "Nn");
    } else { 
	add_to_pup(pup, "Show Symbolic ID %f", (long) do_symbolic, "bB");
    }
    add_to_pup(pup, (grp_flag ? "Change Group%f" : "Change Owner%f"), (long) do_change_owner, "Cc");
    add_to_pup(pup, "Hide %f",         (long) do_hide_owner, "Hh");
    do_pup(pup);
    free_pup(pup);

//  add_to_pup(pup, " %f", (long) do_, "");
}

static void check_update(int &flag){
    if(!flag){
	flag = TRUE;
	source_browser->freeze();
	source_browser->update(TRUE);
	//source_browser->redraw();
	source_browser->unfreeze();
	display_form_sync();
    }
}

void browser_owner_menu_cb(FL_OBJECT *, long){
    grp_flag = FALSE;
    check_update(source_browser->show_owner_flag);
    group_owner_cb();
}

void browser_group_menu_cb(FL_OBJECT *, long){
    grp_flag = TRUE;
    check_update(source_browser->show_group_flag);
    group_owner_cb();
}

void do_main_sort_size(int){
    // kiss principle.
    source_browser->new_fst_sort(size_e, TRUE);
}

void do_aux_sort_size(int){
    source_browser->new_snd_sort(size_e, TRUE);
}

static void do_hide_size(int){
    source_browser->show_size_flag = FALSE;
    status_msg(1, "Use F2-Options-Display to get the size column back.");
    display_form_sync();
    source_browser->update(TRUE);
}

static void select_deselect_by_size_cb(int action, int select_flag){
    const char *size_buf = source_browser->extract_item(fl_get_panel_current(source_browser->panel), size_e);
    if(!size_buf){
	cerr << "cannot extract size item.\n";
	return;
    }
    source_browser->freeze();
    if(action == 1){
	const char *result = OKCancel((select_flag ?
				 "Select all files whose size is equal to:" :
				 "Deselect all files whose size is equal to:"),
				 size_buf);
	if(result){
	    if(select_flag){
		source_browser->select_all_item_matches(result, size_e);
	    } else {
		source_browser->deselect_all_item_matches(result, size_e);
	    }
	}
    } else {
	const char *result = NULL;
	if(select_flag){
	    result = OKCancel((action ?
			       "Select all files whose size is bigger than:" :
			       "Select all files whose size is smaller than:"),
			      size_buf);
	} else {
	    result = OKCancel((action ?
			       "Deselect all files whose size is bigger than:" :
			       "Deselect all files whose size is smaller than:"),
			      size_buf);
	}
	
	if(result){
	    int maxline = fl_get_panel_maxline(source_browser->panel);
	    long the_size = atol(result), a_size;
	    const char *item = NULL;
	    for(int line=1; line <= maxline; line++){
		item = source_browser->extract_item(line, size_e);
		if(item){
		    a_size = atol(item);
		    M_warn("size", "extracting %s, val %d, bound %d", item, a_size, the_size);
		    if((action && a_size > the_size) || (!action && a_size < the_size)){
			if(select_flag){
			    fl_select_panel_line(source_browser->panel, line);
			} else {
			    fl_deselect_panel_line(source_browser->panel, line);
			}
		    }
		} else {
		    cerr << "cannot extract size item.\n";
		}
	    }
	}
    }
    if(select_flag){
	source_browser->deselect_first_name_match(".");
	source_browser->deselect_first_name_match("..");
    }
    source_browser->unfreeze(TRUE);
    update_selection_state();
}

static void do_deselect_by_size_cb(int action){
    select_deselect_by_size_cb(action, FALSE);
}

static void do_select_by_size_cb(int action){
    select_deselect_by_size_cb(action, TRUE);
}

void browser_size_menu_cb(FL_OBJECT *, long){
    check_update(source_browser->show_size_flag);
    
    long pup = new_pup();
    add_to_pup(pup, "Size (Alt-s, Esc-s)%t", 0);

    static int first = TRUE;
    static long deselect_menu, select_menu;
    if(first){
	first = FALSE;
	select_menu = new_pup();
	add_to_pup(select_menu, "Select by Size %t", 0);
	add_to_pup(select_menu, "<: all smaller than%x0",   (long)  do_select_by_size_cb, "s<S");
	add_to_pup(select_menu, "=: all equal to%x1",       (long)  do_select_by_size_cb, "e=E");
	add_to_pup(select_menu, ">: all bigger than%x2",    (long)  do_select_by_size_cb, "b>B");

	deselect_menu = new_pup();
	add_to_pup(deselect_menu, "Deselect by Size %t", 0);
	add_to_pup(deselect_menu, "<: all smaller than%x0",   (long)  do_deselect_by_size_cb, "s<S");
	add_to_pup(deselect_menu, "=: all equal to%x1",       (long)  do_deselect_by_size_cb, "e=E");
	add_to_pup(deselect_menu, ">: all bigger than%x2",    (long)  do_deselect_by_size_cb, "b>B");
    }
    add_to_pup(pup, "Select by Size%m",   (long) select_menu,   "Ss");
    add_to_pup(pup, "Deselect by Size%m", (long) deselect_menu, "Dd");

    if(source_browser->fst_sort != size_e){
	add_to_pup(pup, "Set as Main Sort%f",   (long)  do_main_sort_size,   "Mm");
    } else {
	add_to_pup(pup, "(Size is Main Sort)%f",   (long)  do_main_sort_size,   "Mm");
    }	
    if(source_browser->snd_sort != size_e){
	add_to_pup(pup, "Set as Aux. Sort%f",   (long)  do_aux_sort_size,    "Aa");
    } else {
	add_to_pup(pup, "(Size is Aux. Sort)%f",   (long)  do_aux_sort_size,    "Aa");
    }
    add_to_pup(pup, "Hide %f",                  (long) do_hide_size, "Hh");
    do_pup(pup);
    free_pup(pup);
}

void do_main_sort_inode(int){
    source_browser->new_fst_sort(inode_e, TRUE);
}

void do_aux_sort_inode(int){
    source_browser->new_snd_sort(inode_e, TRUE);
}

static void do_hide_inode(int){
    source_browser->show_inode_flag = FALSE;
    status_msg(1, "Use F2-Options-Display to get the inode column back.");
    display_form_sync();
    source_browser->update(TRUE);
}

void browser_inode_menu_cb(FL_OBJECT *, long){
    check_update(source_browser->show_inode_flag);
    long pup = new_pup();
    add_to_pup(pup, "Inode (Alt-i, Esc-i)%t", 0);

    if(source_browser->fst_sort != inode_e){
	add_to_pup(pup, "Set as Main Sort%f",   (long)  do_main_sort_inode,   "Mm");
    } else {
	add_to_pup(pup, "(Inode is Main Sort)%f",   (long)  do_main_sort_inode,   "Mm");
    }
    if(source_browser->snd_sort != inode_e){
	add_to_pup(pup, "Set as Aux. Sort%f",   (long)  do_aux_sort_inode,    "Aa");
    } else {
	add_to_pup(pup, "(Inode is Aux. Sort)%f",   (long)  do_aux_sort_inode,    "Aa");
    }
    add_to_pup(pup, "Hide %f",                  (long) do_hide_inode, "Hh");
    do_pup(pup);
    free_pup(pup);
}

void do_main_sort_nlinks(int){
    source_browser->new_fst_sort(nlinks_e, TRUE);
}

void do_aux_sort_nlinks(int){
    source_browser->new_snd_sort(nlinks_e, TRUE);
}

static void do_hide_nlinks(int){
    source_browser->show_nlinks_flag = FALSE;
    status_msg(1, "Use F2-Options-Display to get the nlinks column back.");
    display_form_sync();
    source_browser->update(TRUE);
}

void browser_nlinks_menu_cb(FL_OBJECT *, long){ 
    check_update(source_browser->show_nlinks_flag);
    long pup = new_pup();
    add_to_pup(pup, "nLinks (Alt-l, Esc-l)%t", 0);

    if(source_browser->fst_sort != nlinks_e){
	add_to_pup(pup, "Set as Main Sort%f",   (long)  do_main_sort_nlinks,   "Mm");
    } else {
	add_to_pup(pup, "(Nlinks is Main Sort)%f",   (long)  do_main_sort_nlinks,   "Mm");
    }
    if(source_browser->snd_sort != nlinks_e){
	add_to_pup(pup, "Set as Aux. Sort%f",   (long)  do_aux_sort_nlinks,    "Aa");
    } else {
	add_to_pup(pup, "(Nlinks is Aux. Sort)%f",   (long)  do_aux_sort_nlinks,    "Aa");
    }
    add_to_pup(pup, "Hide %f",                  (long) do_hide_nlinks, "Hh");
    do_pup(pup);
    free_pup(pup);
}

static void do_main_sort_filetype(int){
    source_browser->new_fst_sort(filetype_e);
}

static void do_aux_sort_filetype(int){
    source_browser->new_snd_sort(filetype_e);
}

static void do_hide_filetype(int){
    source_browser->show_filetype_flag = FALSE;
    status_msg(1, "Use F2-Options-Display to get the filetype column back.");
    display_form_sync();
    source_browser->update(TRUE);
}

static void do_select_deselect_filetype(int action, int select_flag){
    char *result;
    switch(action){
    case 0: result = "b"; break;
    case 1: result = "c"; break;
    case 2: result = "d"; break;
    case 3: result = "l"; break;
    case 4: result = "-"; break;
    case 5: result = "p"; break;
    case 6: result = "s"; break;
    default:
	cerr << "UC: invalid filetype in switch.\n";
	return;
    }
    if(select_flag){
	source_browser->select_all_item_matches(result, filetype_e);
    } else {
	source_browser->deselect_all_item_matches(result, filetype_e);
    }	    
    update_selection_state();
}

void do_deselect_by_filetype(int action){
    do_select_deselect_filetype(action, FALSE);
}

void do_select_by_filetype(int action){
    do_select_deselect_filetype(action, TRUE);
}

void browser_filetype_menu_cb(FL_OBJECT *, long){ 
    check_update(source_browser->show_filetype_flag);
    long pup = new_pup();
    add_to_pup(pup, "File Type (Alt-t, Esc-t)%t", 0);

    static int first = TRUE;
    static long deselect_menu, select_menu;
    if(first){
	first = FALSE;
	select_menu = new_pup();
	add_to_pup(select_menu, "Select by Type %t", 0);
	add_to_pup(select_menu, "all Block special files%x0", (long) do_select_by_filetype, "Bb");
	add_to_pup(select_menu, "all Char special files%x1",  (long) do_select_by_filetype, "Cc");
	add_to_pup(select_menu, "all Directories%x2",         (long) do_select_by_filetype, "Dd");
	add_to_pup(select_menu, "all Links%x3",               (long) do_select_by_filetype, "Ll");
	add_to_pup(select_menu, "all Normal files%x4",        (long) do_select_by_filetype, "Nn");
	add_to_pup(select_menu, "all Pipes/fifos%x5",         (long) do_select_by_filetype, "Pp");
	add_to_pup(select_menu, "all Sockets%x6",             (long) do_select_by_filetype, "Ss");

	deselect_menu = new_pup();
	add_to_pup(deselect_menu, "Deselect by Type %t", 0);
	add_to_pup(deselect_menu, "all Block special files%x0", (long) do_deselect_by_filetype, "Bb");
	add_to_pup(deselect_menu, "all Char special files%x1",  (long) do_deselect_by_filetype, "Cc");
	add_to_pup(deselect_menu, "all Directories%x2",         (long) do_deselect_by_filetype, "Dd");
	add_to_pup(deselect_menu, "all Links%x3",               (long) do_deselect_by_filetype, "Ll");
	add_to_pup(deselect_menu, "all Normal files%x4",        (long) do_deselect_by_filetype, "Nn");
	add_to_pup(deselect_menu, "all Pipes/fifos%x5",         (long) do_deselect_by_filetype, "Pp");
	add_to_pup(deselect_menu, "all Sockets%x6",             (long) do_deselect_by_filetype, "Ss");
    }
    add_to_pup(pup, "Select by Type%m",   (long) select_menu,   "Ss");
    add_to_pup(pup, "Deselect by Type%m", (long) deselect_menu, "Dd");

    if(source_browser->fst_sort != filetype_e){
	add_to_pup(pup, "Set as Main Sort%f",   (long)  do_main_sort_filetype,   "Mm");
    } else {
	add_to_pup(pup, "(Type is Main Sort)%f",   (long)  do_main_sort_filetype,   "Mm");
    }
    if(source_browser->snd_sort != filetype_e){
	add_to_pup(pup, "Set as Aux. Sort%f",   (long)  do_aux_sort_filetype,    "Aa");
    } else {
	add_to_pup(pup, "(Type is Aux. Sort)%f",   (long)  do_aux_sort_filetype,    "Aa");
    }
    add_to_pup(pup, "Hide %f",                  (long) do_hide_filetype, "Hh");
    do_pup(pup);
    free_pup(pup);
}    

/*
static void do_main_sort_perms(int){
    source_browser->new_fst_sort(perms_e);
}

static void do_aux_sort_perms(int){
    source_browser->new_snd_sort(perms_e);
}
*/

static void do_hide_perms(int){
    source_browser->show_perms_flag = FALSE;
    status_msg(1, "Use F2-Options-Display to get the perms column back.");
    display_form_sync();
    source_browser->update(TRUE);
}

static void do_select_deselect_perms(int action, int select_flag){
    const char
	*result0 = NULL, *result1 = NULL, *result2 = NULL,
	*result3 = NULL, *result4 = NULL, *result5 = NULL,
	*perms_buf
    ;
    switch(action){
    case 0: result0 = "r*"; result1 = "???r*"; result2 = "*r??"; break;
    case 1: result0 = "?w*"; result1 = "????w*"; result2 = "*w?"; break;
    case 2: result0 = "??x*"; result1 = "*x???"; result2 = "*x"; 
	    result4 = "??s*"; result5 = "*s???"; result5 = "*t";
	    break;
    case 3: result0 = "??S*"; result1 = "*S???"; //result2 = "*T"; 
	    result4 = "??s*"; result5 = "*s???"; //result5 = "*t";
	    break;
    case 4: perms_buf = source_browser->extract_item(
	        fl_get_panel_current(source_browser->panel), perms_e
	    );
	    if(!perms_buf) return;
	    result0 = OKCancel((select_flag ?
				"Supply a wildcard permission selection expression:" :
				"Supply a wildcard permission deselection expression:"),
			        perms_buf);
	    if(!result0) return;
	    break;
    default:
	cerr << "UC: invalid perms in switch.\n";
	return;
    }
    if(select_flag){
	if(result0) source_browser->select_all_item_matches(result0, perms_e);
	if(result1) source_browser->select_all_item_matches(result1, perms_e);
	if(result2) source_browser->select_all_item_matches(result2, perms_e);
	if(result3) source_browser->select_all_item_matches(result3, perms_e);
	if(result4) source_browser->select_all_item_matches(result4, perms_e);
	if(result5) source_browser->select_all_item_matches(result5, perms_e);
    } else {
	if(result0) source_browser->deselect_all_item_matches(result0, perms_e);
	if(result1) source_browser->deselect_all_item_matches(result1, perms_e);
	if(result2) source_browser->deselect_all_item_matches(result2, perms_e);
	if(result3) source_browser->deselect_all_item_matches(result3, perms_e);
	if(result4) source_browser->deselect_all_item_matches(result4, perms_e);
	if(result5) source_browser->deselect_all_item_matches(result5, perms_e);
    }	    
    update_selection_state();
}

static void do_deselect_by_perms(int action){
    do_select_deselect_perms(action, FALSE);
}

static void do_select_by_perms(int action){
    do_select_deselect_perms(action, TRUE);
}

static int chmod_cmd(const char *arg){
    if(!arg || !chmod_path){
	cerr << "chmod_cmd: NULL arg or path!\n";
	return FALSE;
    }
    action_work_noform();
    int retval = source_browser->selection_cmd(chmod_path, "chmod", arg);
    if(retval){
	tool_update_matching_dirs(source_browser->get_cwd(), TRUE);
    }
    return retval;
}

static void do_make_writeable(int which){
    /* ugoa coded via 0123.
     * we want a /usr/bin/chmod ugo+rwx [files]
     */
    switch(which){
    case 0:  chmod_cmd("u+w"); return;
    case 1:  chmod_cmd("g+w"); return;
    case 2:  chmod_cmd("o+w"); return;
    case 3:  chmod_cmd("go+w"); return;
    case 4:  chmod_cmd("ugo+w"); return;
    default: cerr << "invalid switch in do_make_writeable.\n"; return;
    }
}

static void do_make_readable(int which){
    switch(which){
    case 0:  chmod_cmd("u+r"); return;
    case 1:  chmod_cmd("g+r"); return;
    case 2:  chmod_cmd("o+r"); return;
    case 3:  chmod_cmd("go+r"); return;
    case 4:  chmod_cmd("ugo+r"); return;
    default: cerr << "invalid switch in do_make_readable.\n"; return;
    }
}

static void do_make_executable(int which){
    switch(which){
    case 0:  chmod_cmd("u+x"); return;
    case 1:  chmod_cmd("g+x"); return;
    case 2:  chmod_cmd("o+x"); return;
    case 3:  chmod_cmd("go+x"); return;
    case 4:  chmod_cmd("ugo+x"); return;
    default: cerr << "invalid switch in do_make_executable.\n"; return;
    }
}

static void do_make_unwriteable(int which){
    switch(which){
    case 0:  chmod_cmd("u-w"); return;
    case 1:  chmod_cmd("g-w"); return;
    case 2:  chmod_cmd("o-w"); return;
    case 3:  chmod_cmd("go-w"); return;
    case 4:  chmod_cmd("ugo-w"); return;
    default: cerr << "invalid switch in do_make_unwriteable.\n"; return;
    }
}

static void do_make_unreadable(int which){
    switch(which){
    case 0:  chmod_cmd("u-r"); return;
    case 1:  chmod_cmd("g-r"); return;
    case 2:  chmod_cmd("o-r"); return;
    case 3:  chmod_cmd("go-r"); return;
    case 4:  chmod_cmd("ugo-r"); return;
    default: cerr << "invalid switch in do_make_unreadable.\n"; return;
    }
}

static void do_make_unexecutable(int which){
    switch(which){
    case 0:  chmod_cmd("u-x"); return;
    case 1:  chmod_cmd("g-x"); return;
    case 2:  chmod_cmd("o-x"); return;
    case 3:  chmod_cmd("go-x"); return;
    case 4:  chmod_cmd("ugo-x"); return;
    default: cerr << "invalid switch in do_make_unexecutable.\n"; return;
    }
}

static void perms_error(char c){
    char buf[1024];
    sprintf(buf, "Permission expression contains unknown character: %c", c);
    timed_error_notifier(buf);
}

static void do_set_perms(int){
    char *perms_buf =
	source_browser->extract_item(fl_get_panel_current(source_browser->panel), perms_e)
    ;
    if(!perms_buf) return;
    const char *result = OKCancel("Give perm's string (example: rwxr-xr-?, use `?' for don't care)", perms_buf);
    if(!result)	return;
    char buf[128];
    buf[0] = '\0';
    int len=strlen(result);
    if(len < 9){
	timed_error_notifier("Permission expression too short !");
	return;
    } else if(len > 9){
	timed_error_notifier("Permission expression too long !");
	return;
    }
    for(int i=0; i<9; i++){
	char *who = "u";
	if(i>2) who = "g";
	if(i>5) who = "o";
	if(result[i] != '?'){
	    switch(i%3){
	    case 0:
		strcat(buf, who);
		switch(result[i]){
		case 'r': strcat(buf, "+r,"); break;
		case '-': strcat(buf, "-r,"); break;
		default:  perms_error(result[i]); return;
		}
		break;
	    case 1:
		strcat(buf, who);
		switch(result[i]){
		case 'w': strcat(buf, "+w,"); break;
		case '-': strcat(buf, "-w,"); break;
		default:  perms_error(result[i]); return;
		}
		break;
	    case 2:
		strcat(buf, who);
		switch(result[i]){
		case 'x': strcat(buf, "+x,"); break;
		case 's': strcat(buf, "+s,"); break;
		case '-':
		    strcat(buf, "-x,");
		    strcat(buf, who);
		    strcat(buf, "-s,");
		    break;
		default:  perms_error(result[i]); return;
		}
		break;
	    }
	}
    }
    len = strlen(buf);
    buf[len-1] = '\0';  // remove last coMma
    // cerr << buf;
    chmod_cmd(buf);
}

void browser_perms_menu_cb(FL_OBJECT *, long){ 
    check_update(source_browser->show_perms_flag);
    long pup = new_pup();
    add_to_pup(pup, "Permissions (Alt-p, Esc-p)%t", 0);

    static int first = TRUE;
    static long
	deselect_menu, select_menu,
	addto_menu, remove_menu,
	exec_menu, read_menu, write_menu,
	unexec_menu, unread_menu, unwrite_menu
    ;
    
    
    if(first){
	first = FALSE;
	// de-/select
	select_menu = new_pup();
	add_to_pup(select_menu, "Select by Perm's %t", 0);
	add_to_pup(select_menu, "all Readable files%x0",   (long) do_select_by_perms, "Rr,");
	add_to_pup(select_menu, "all Writable files%x1",   (long) do_select_by_perms, "Ww");
	add_to_pup(select_menu, "all eXecutable files%x2", (long) do_select_by_perms, "Xx");
	add_to_pup(select_menu, "all SUID/SGID files%x3",  (long) do_select_by_perms, "Ss");
	add_to_pup(select_menu, "all Custom ...%x4",       (long) do_select_by_perms, "Cc");

	deselect_menu = new_pup();
	add_to_pup(deselect_menu, "Deselect by Perm's %t", 0);
	add_to_pup(deselect_menu, "all Readable files%x0",   (long) do_deselect_by_perms, "Rr");
	add_to_pup(deselect_menu, "all Writable files%x1",   (long) do_deselect_by_perms, "Ww");
	add_to_pup(deselect_menu, "all eXecutable files%x2", (long) do_deselect_by_perms, "Xx");
	add_to_pup(deselect_menu, "all SUID/SGID files%x3",  (long) do_deselect_by_perms, "Ss");
	add_to_pup(deselect_menu, "all Custom ...%x4",       (long) do_deselect_by_perms, "Cc");

	// add
	write_menu = new_pup();
	add_to_pup(write_menu, "Make Writable %t", 0);
	add_to_pup(write_menu, "User%x0",        (long) do_make_writeable, "Uu");
	add_to_pup(write_menu, "Group%x1",       (long) do_make_writeable, "Gg");
	add_to_pup(write_menu, "Other%x2",       (long) do_make_writeable, "Oo");
	add_to_pup(write_menu, "Group&Other%x3", (long) do_make_writeable, "&");
	add_to_pup(write_menu, "All%x4",    (long) do_make_writeable, "Aa");

	read_menu = new_pup();
	add_to_pup(read_menu, "Make Readable %t", 0);
	add_to_pup(read_menu, "User%x0",   (long) do_make_readable, "Uu");
	add_to_pup(read_menu, "Group%x1",  (long) do_make_readable, "Gg");
	add_to_pup(read_menu, "Other%x2",  (long) do_make_readable, "Oo");
	add_to_pup(read_menu, "Group&Other%x3", (long) do_make_readable, "&");
	add_to_pup(read_menu, "All%x4",    (long) do_make_readable, "Aa");
	
	exec_menu = new_pup();
	add_to_pup(exec_menu, "Make Executable %t", 0);
	add_to_pup(exec_menu, "User%x0",   (long) do_make_executable, "Uu");
	add_to_pup(exec_menu, "Group%x1",  (long) do_make_executable, "Gg");
	add_to_pup(exec_menu, "Other%x2",  (long) do_make_executable, "Oo");
	add_to_pup(exec_menu, "Group&Other%x3", (long) do_make_executable, "&");
	add_to_pup(exec_menu, "All%x4",    (long) do_make_executable, "Aa");
	
	addto_menu = new_pup();
	add_to_pup(addto_menu, "Add to Perm's %t", 0);
	add_to_pup(addto_menu, "Make Writable%m",   (long) write_menu, "Ww");
	add_to_pup(addto_menu, "Make Readable%m",   (long) read_menu, "Rr");
	add_to_pup(addto_menu, "Make eXecutable%m", (long) exec_menu, "Xx");

	// remove
	unwrite_menu = new_pup();
	add_to_pup(unwrite_menu, "Make Unwritable %t", 0);
	add_to_pup(unwrite_menu, "User%x0",   (long) do_make_unwriteable, "Uu");
	add_to_pup(unwrite_menu, "Group%x1",  (long) do_make_unwriteable, "Gg");
	add_to_pup(unwrite_menu, "Other%x2",  (long) do_make_unwriteable, "Oo");
	add_to_pup(unwrite_menu, "Group&Other%x3", (long) do_make_unwriteable, "&");
	add_to_pup(unwrite_menu, "All%x4",    (long) do_make_unwriteable, "Aa");

	unread_menu = new_pup();
	add_to_pup(unread_menu, "Make Unreadable %t", 0);
	add_to_pup(unread_menu, "User%x0",   (long) do_make_unreadable, "Uu");
	add_to_pup(unread_menu, "Group%x1",  (long) do_make_unreadable, "Gg");
	add_to_pup(unread_menu, "Other%x2",  (long) do_make_unreadable, "Oo");
	add_to_pup(unread_menu, "Group&Other%x3", (long) do_make_unreadable, "&");
	add_to_pup(unread_menu, "All%x4",    (long) do_make_unreadable, "Aa");
	
	unexec_menu = new_pup();
	add_to_pup(unexec_menu, "Make Unexecutable %t", 0);
	add_to_pup(unexec_menu, "User%x0",   (long) do_make_unexecutable, "Uu");
	add_to_pup(unexec_menu, "Group%x1",  (long) do_make_unexecutable, "Gg");
	add_to_pup(unexec_menu, "Other%x2",  (long) do_make_unexecutable, "Oo");
	add_to_pup(unexec_menu, "Group&Other%x3", (long) do_make_unexecutable, "&");
	add_to_pup(unexec_menu, "All%x4",    (long) do_make_unexecutable, "Aa");
	
	remove_menu = new_pup();
	add_to_pup(remove_menu, "Remove Perm's %t", 0);
	add_to_pup(remove_menu, "Make unWritable%m",   (long) unwrite_menu, "Ww");
	add_to_pup(remove_menu, "Make unReadable%m",   (long) unread_menu,  "Rr");
	add_to_pup(remove_menu, "Make uneXecutable%m", (long) unexec_menu,  "Xx");

    }
    add_to_pup(pup, "Select by Perm's%m",   (long) select_menu,   "Ss");
    add_to_pup(pup, "Deselect by Perm's%m", (long) deselect_menu, "Dd");
    add_to_pup(pup, "Add to Perm's%m",      (long) addto_menu,    "Aa");
    add_to_pup(pup, "Remove Perm's%m",      (long) remove_menu,   "Rr");
    add_to_pup(pup, "Set Perm's%f",         (long) do_set_perms,  "tT");

    /*
    if(source_browser->fst_sort != perms_e){
	add_to_pup(pup, "Set as Main Sort%f",   (long)  do_main_sort_perms,   "Mm");
    }
    if(source_browser->snd_sort != perms_e){
	add_to_pup(pup, "Set as Aux. Sort%f",   (long)  do_aux_sort_perms,    "Aa");
    }
    */
    add_to_pup(pup, "Hide %f",                  (long) do_hide_perms, "Hh");
    do_pup(pup);
    free_pup(pup);
}    

static void do_main_sort_name(int){
    source_browser->new_fst_sort(name_e);
}

static void do_aux_sort_name(int){
    source_browser->new_snd_sort(name_e);
}

static void do_select_by_name(int){
    SelectButtonCB(NULL, 0);
}

static void do_deselect_by_name(int){
    DeselectButtonCB(NULL, 0);
}

static void do_type_char(int){
    toggle_flag(source_browser->show_type_char_flag);
    display_form_sync();
    source_browser->update(TRUE);
}

static void do_rename(int){
	RenameButtonCB(NULL, 0);
}

void browser_name_menu_cb(FL_OBJECT *, long){
    // name always shown.
    long pup = new_pup();
    add_to_pup(pup, "Name (Alt-n, Esc-n)%t", 0);
    add_to_pup(pup, "Select by Name%f",   (long) do_select_by_name,   "Ss");
    add_to_pup(pup, "Deselect by Name%f", (long) do_deselect_by_name, "Dd");

    if(source_browser->fst_sort != name_e){
	add_to_pup(pup, "Set as Main Sort%f",   (long)  do_main_sort_name,   "Mm");
    } else {
	add_to_pup(pup, "(Name is Main Sort)%f",   (long)  do_main_sort_name,   "Mm");
    }	
    if(source_browser->snd_sort != name_e){
	add_to_pup(pup, "Set as Aux. Sort%f",   (long)  do_aux_sort_name,    "Aa");
    } else {
	add_to_pup(pup, "(Name is Aux. Sort)%f",   (long)  do_aux_sort_name,    "Aa");
    }
    if(source_browser->show_type_char_flag){
	add_to_pup(pup, "Hide Type Char%f",      (long)  do_type_char,    "Tt");
    } else {
	add_to_pup(pup, "Show Type Char%f",      (long)  do_type_char,    "Tt");
    }
	add_to_pup(pup, "Rename%f",   			(long)  do_rename,    "Rr");
    do_pup(pup);
    free_pup(pup);
}

void do_main_sort_access(int){
    source_browser->new_fst_sort(access_e, TRUE);
}

void do_aux_sort_access(int){
    source_browser->new_snd_sort(access_e, TRUE);
}

static void do_hide_access(int){
    source_browser->show_access_flag = FALSE;
    status_msg(1, "Use F2-Options-Display to get the access time column back.");
    display_form_sync();
    source_browser->update(TRUE);
}

static void do_touch(int){
    action_work_noform();
    if(!touch_path) return;
    int retval = source_browser->selection_cmd(touch_path, "touch", NULL);
    if(retval){
	tool_update_matching_dirs(source_browser->get_cwd(), TRUE);
    }
}

void browser_access_menu_cb(FL_OBJECT *, long){ 
    check_update(source_browser->show_access_flag);
    long pup = new_pup();
    add_to_pup(pup, "Access Time (Alt-a, Esc-a)%t", 0);

    if(source_browser->fst_sort != access_e){
	add_to_pup(pup, "Set as Main Sort%f",   (long) do_main_sort_access, "Mm");
    } else {
	add_to_pup(pup, "(Access is Main Sort)%f", (long) do_main_sort_access, "Mm");
    }
    if(source_browser->snd_sort != access_e){
	add_to_pup(pup, "Set as Aux. Sort%f",   (long) do_aux_sort_access,  "Aa");
    } else {
	add_to_pup(pup, "(Access is Aux. Sort)%f", (long) do_aux_sort_access,  "Aa");
    }
    add_to_pup(pup, "Touch %f", (long) do_touch, "Tt");
    add_to_pup(pup, "Hide %f",  (long) do_hide_access, "Hh");
    do_pup(pup);
    free_pup(pup);
}

void do_main_sort_modific(int){
    source_browser->new_fst_sort(modific_e, TRUE);
}

void do_aux_sort_modific(int){
    source_browser->new_snd_sort(modific_e, TRUE);
}

static void do_hide_modific(int){
    source_browser->show_modific_flag = FALSE;
    status_msg(1, "Use F2-Options-Display to get the modific. time column back.");
    display_form_sync();
    source_browser->update(TRUE);
}

void browser_modific_menu_cb(FL_OBJECT *, long){ 
    check_update(source_browser->show_modific_flag);
    long pup = new_pup();
    add_to_pup(pup, "Modification Time (Alt-m, Esc-m)%t", 0);

    if(source_browser->fst_sort != modific_e){
	add_to_pup(pup, "Set as Main Sort%f",   (long)  do_main_sort_modific,   "Mm");
    } else {
	add_to_pup(pup, "(Modific. is Main Sort)%f",   (long)  do_main_sort_modific,   "Mm");
    }
    if(source_browser->snd_sort != modific_e){
	add_to_pup(pup, "Set as Aux. Sort%f",   (long)  do_aux_sort_modific,    "Aa");
    } else {
	add_to_pup(pup, "(Modific. is Aux. Sort)%f",   (long)  do_aux_sort_modific,    "Aa");
    }
    add_to_pup(pup, "Touch %f", (long) do_touch, "Tt");
    add_to_pup(pup, "Hide %f",  (long) do_hide_modific, "Hh");
    do_pup(pup);
    free_pup(pup);
}

