/*
 * interface functions and objects.
 * extra functionality must be explicitly added/included via cwdForms.h.
 */

#ifndef ERRORNOTIFIERFORMSAUX_H
#define ERRORNOTIFIERFORMSAUX_H

#include "forms.h"

extern double notifier_secs;

/* say something */
void timed_notifier(const char *text);
void timed_notifier(const char *text, double secs);	
void timed_notifier(const char *text_line_0, const char *text_line_1);
void timed_notifier(const char *text_line_0, const char *text_line_1, double secs);

/* bark */
void timed_error_notifier(const char *text);
void timed_error_notifier(const char *text, double secs);
void timed_error_notifier(const char *text_line_0, const char *text_line_1);
void timed_error_notifier(const char *text_line_0, const char *text_line_1, double secs);

/* add a line containing strerror(errno) */
void timed_strerror_notifier(const char *text);
void timed_strerror_notifier(const char *text, double secs);

void error_notifier(const char *text);				
void error_notifier_forms_aux_create(void);
void error_notifier_create_the_forms();

void fl_error_msg(const char *fmt, ...);				

#endif // ERRORNOTIFIERFORMSAUX_H
