
/* Encapsulate fork only process control.
 * Target: - Decouple command operation from GUI operation.
 *         - continue to redraw GUI while working
 *         - allow GUI to interrupt the command
 *         - give feedback to indicate progress
 */

#ifndef FORK_PIPE_H
#define FORK_PIPE_H

int do_fork_cmd(
    const char *file,    // not full pathname, only file name. we're not SUID.
    const char **argv    // full ! argument vector., with argv[0] and trailing NULL.
);

#endif  // FORK_PIPE_H

