

#ifndef FORMS_AUX_H
#define FORMS_AUX_H

#include "forms.h"

extern int fl_default_curname;

/* Set/reset a cursor in all forms windows */
void fl_set_global_cursor(int cursor);
void fl_reset_global_cursor(void);

/* works even if the form is deactivated several times: */
void fl_activate_form_always(FL_FORM *form);

/* Returns the form, if any, in which the pointer is. This can be
 * different from the focus form or window.
 */
FL_FORM *fl_find_pointer_form(void);
FL_FORM *fl_find_pointer_form(FL_Coord *x, FL_Coord *y, unsigned int *keymask);

void fl_set_form_label(FL_FORM *form, const char *label);

/* The following routine is preferred, because it unsets any spurious
 * other return buttons.
 */
void set_to_ret_button    (FL_OBJECT *button);

FL_OBJECT *find_return_button(FL_FORM *form);

int adjust_return_button(FL_FORM *form, XEvent *xev, int override_flag = FALSE);
void correct_slider_size(FL_OBJECT *ob, double &slsize);
void fl_set_form_position_direct(FL_FORM *, FL_Coord, FL_Coord);

/* some helper menus */
long make_fsize_menu (long user_cb = 0);  // canonical fontsize menu
long make_fstyle_menu(long user_cb = 0);  // can. style menu.

/* misc */
void set_window_icon(Window window, Pixmap pixmap);
int CheckPeekWindowEvent(Display *display, Window window, long event_type);

/* stub function, not supported in XForms anymore */
void fl_set_browser_leftslider (FL_OBJECT *, int dontcare);

#endif
