#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/errno.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>

#include "action_forms_aux.h"
#include "browser.h"
#include "cb.h"
#include "cb_fkey.h"
#include "colour_forms_aux.h"
//#include "cwd_forms_aux.h"
#include "display_forms_aux.h"
#include "dir_menu.h"
#include "edit_forms_aux.h"
#include "error_notifier_forms_aux.h"
#include "file_utility.h"
#include "fkeybar_forms.h"
#include "fkeybar_forms_aux.h"
#include "flspecial.h"
#include "forms.h"
#include "ghelp_forms_aux.h"
#include "global.h"
#include "gl_utility.h"
#include "help_forms_aux.h"
#include "help_text.h"
#include "license_forms_aux.h"
#include "menu.h"
#include "toolbox_forms.h"
#include "toolbox_forms_aux.h"
#include "tree_forms_aux.h"
#include "options_forms_aux.h"
#include "status_forms_aux.h"
#include "utility.h"
#include "sort_forms_aux.h"
#include "tree_colour_forms_aux.h"
#include "tree_forms_aux.h"
#include "wm_forms_aux.h"
#include "xshell.h"

long double_click_msecs_max = 300;
int tool_number_of_browsers = 2,
    tool_bw_flag	    = FALSE,
    toolop_cancelled_flag   = FALSE,
    tool_debug_flag	    = FALSE,
    tool_cmsg		    = 0,
    tool_cp_minusp_flag	    = FALSE,
    tool_ctrl_on_flag	    = FALSE,
    tool_du_auto_flag	    = FALSE,
    tool_du_sort_flag	    = TRUE,
    tool_editor_info_shown_flag = FALSE,
    tool_escape_flag	    = FALSE,
    tool_focus_on_startup_flag = TRUE, 
#if defined(HP) || defined(SUNOS)
    tool_fontsize	    = FL_MEDIUM_SIZE,
#else
    tool_fontsize	    = FL_NORMAL_SIZE,
#endif
    tool_fontstyle	    = FL_TIMES_STYLE,
    tool_menu_fontsize	    = tool_fontsize,
    tool_menu_fontstyle	    = FL_TIMES_STYLE,

    tool_got_event_flag	    = FALSE,
    tool_looser_flag	    = FALSE,
    tool_max_ww		    = 600,    // VGA, just in case
    tool_max_wh		    = 400,
    tool_source_colour	    = FL_GREEN,
    tool_target_colour	    = FL_YELLOW,
    tool_dir_timeout_secs   = 5,  
    tool_file_timeout_secs  = 1,
    tool_startup_msg_flag   = TRUE,
#ifdef SUN
    sun_keyboard_flag	    = TRUE
#else
    sun_keyboard_flag	    = FALSE
#endif
;

// default mask for making directories: (drwxr-xr-x) (#include <sys/types.h>)
//mode_t mkdir_mode_mask = S_IRWXU;  // testing
mode_t mkdir_mode_mask = S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH;

//static int dbg_flag = TRUE;
static int dbg_flag = tool_debug_flag;

const char *tool_dnd_op_str = "<no op>";

char default_editor[MAXPATHLEN+1];	   // necessary for save-ability
char *tool_default_fname = NULL;	   // for database.
char *tool_gdefault_dir = NULL;		   // global config dir. Overriden by any $HOME.
char *tool_ldefault_dir = NULL;		   // local config dir.
char *tool_host_string	= NULL;		   // for wintitles

#if   defined(AIX)
char *version_os = "IBM-AIX-4.1";  // 3.2.5
#elif defined(DEC_ALPHA)
char *version_os = "DEC-OSF-4.0";
#elif defined(FREEBSD)
char *version_os = "FreeBSD-2.2";
#elif defined(HP)
char *version_os = "HP-UX-PA9.0";
#elif defined(LINUX)
char *version_os = "Linux-2.2.10";
//char *version_os = "Linux-1.0.8";
#elif defined(OPENBSD)
char *version_os = "OpenBSD-2.1";
#elif defined(SCO)
char *version_os = "SCO-OS5.0.2";
#elif defined(SGI_IRIX4)
char *version_os = "Irix-4.0.5F";  
#elif defined(SGI_IRIX6)
char *version_os = "Irix64-6.0.1";  
#elif defined(SGI_IRIX62)
char *version_os = "SGI-Irix6.2";  
#elif defined(SGI)
char *version_os = "SGI-Irix5.3"; 
#elif defined(SINIX)
char *version_os = "Sinix-V5.43";
#elif defined(SOLARIS)
char *version_os = "Solaris-2.5";
#elif defined(SUNOS)
char *version_os = "SunOS-4.1.1";
#elif defined(__ultrix)
char *version_os = "Ultrix-4.3A";
#elif defined(UNIXWARE)
char *version_os = "UnixWare2.0";
#else
char *version_os = "Oops-OS";
#endif

#if defined(SUNOS)
char *version_date  = "Nov 01 2000";	// note fixed length!!
#else
char *version_date  = __DATE__;
#endif

char *version_major = "3";
char *version_minor = "012";

browser_c
    *source_browser = NULL,
    *target_browser = NULL
;

save_on_exit_state_et
    save_config_on_exit_state = ask_e,
    save_tree_on_exit_state = ask_e
;    

void make_standard_cancel_shortcut(FL_OBJECT *obj){
    char buf[8];
    buf[0] = 'C';
    buf[1] = 'n';
    buf[2] = 'N';
    buf[3] = 'c';
    buf[4] = '\033';  // esc (as in ascii)
    if(obj->type == FL_RETURN_BUTTON || obj->type == FL_HIDDEN_RET_BUTTON){
	buf[5] = '^';
	buf[6] = 'M';
	buf[7] = '\000';  // terminate string correctly.
    } else {
	buf[5] = '\000';  // terminate string correctly.
    }
//  buf[1] = '\177';  // delete

    fl_set_object_shortcut(obj, buf, TRUE);
}

void make_standard_ok_shortcut(FL_OBJECT *obj){
    fl_set_object_shortcut(obj, "GgyY^M", TRUE);
}

void make_standard_shortcut(FL_OBJECT *obj){
    char buf[8];
    buf[0] = '\033';  // esc (as in ascii)
    buf[1] = '\000';  // terminate string correctly.
//    buf[1] = '\177';	// delete

    fl_set_button_shortcut(obj, buf, TRUE);
}

void tool_mung_callbacks(void){
    FL_OBJECT *obj;
    XEvent xev;
    while((obj = fl_check_forms())){	
	if(obj == FL_EVENT){	
	    if(fl_XNextEvent(&xev)){
		callback_table.execute_xev(&xev);
	    }
	}
    }
}

int tool_mung_forms(int do_nap_flag){
    M_debug("tool_mung_forms", "do nap: %d", do_nap_flag);
    // important to kill all events when they are available.
    // nap when the queue is empty. Return FALSE if the cancel
    // button (padperiod) was pressed. (we would like to get rid of
    // the release event, but that clashes with the PADPERIOD old-
    // style forms).
    // GLFORMS: I am just gobbling up the events in X, like in mung events.
    FL_OBJECT *obj;
    XEvent xev;
    while((obj = fl_check_forms())){
	M_trace("tool_mung_forms", "checking true");
	if(obj == FL_EVENT){
	    M_trace("tool_mung_forms", "event true");
	    fl_XNextEvent(&xev);
	    if(xev.type == KeyPress){
		M_trace("tool_mung_forms", "keypress true");
		KeySym keysym;
		char keybuf[1];
		XLookupString((XKeyEvent *) &xev, keybuf, sizeof(keybuf), &keysym, 0);
		if(keysym == XK_Escape){
		    M_debug("tool_mung_forms","found escape.");
		    return FALSE;
		}
	    }
	}
    }
    if(do_nap_flag){
	sginap(1);
    }
    return TRUE;
}

void tool_mung_events(void){
    // kill all events when they are available.
    FL_OBJECT *obj;
    XEvent xev;
    while((obj = fl_check_forms())){
	if(obj == FL_EVENT){
	    fl_XNextEvent(&xev);
	}
    }
}

void program_unstable(char *msg){
    if(msg) timed_error_notifier(msg, 10.0);
    if(ask_question(TRUE, "Program internals unstable. Confirm continue:")){
	return;
    } else {
	cerr << "UC internal:data structures corrupted. Exiting ..." << endl;
	exit(-99);
    }
}

void malloc_unstable(char *pMsg){
    char msg[2048];
    if (pMsg && strlen(pMsg) < 2000) {
	sprintf(msg, "%s: Memory allocation failed.", pMsg);
    } else {
	strcpy(msg, "Memory allocation failed.");
    }
    program_unstable(msg);
}

int source_is_stable(void){
    if(!source_browser){
	program_unstable("no source browser ?");
	return FALSE;
    } else {
	return TRUE;
    }
}

int target_is_stable(void){
    if(!target_browser){
	program_unstable("no target browser ?");
	return FALSE;
    } else {
	return TRUE;
    }
}

int source_target_are_stable(void){
    if(source_is_stable()){
	return target_is_stable();
    } else {
	return FALSE;
    }
}

void toggle_flag(int &flag){
    flag = !flag;
}

/*
 * tool-level functions.
 *
 * change directory, remember to set all browser internal buffers, and
 * to keep the window titles up2date, and to keep the change dir form
 * up2date. Don't do the buffers if not needed, e.g. on call from inside
 * the browser_c.
 * if failure, attempt changing up. Suppose you have /foo/bar. cd /foo/bar
 * fails. attempt cd /foo. fails. attempt cd /.
 */

static char crash_path[MAXPATHLEN+1] = "";

int tool_change_dir(
    const char *fname, 
    int set_current_flag,
    int update_browser_bufs_flag,
    int update_tree_flag,
    int update_xshell_flag,
    int attempt_root_flag
){
    const int cwd_bufsize = MAXPATHLEN+1;
    static int failure_flag = FALSE;
    char cwd_buf[cwd_bufsize];
    if(!fname){
	program_unstable("NULL pointer in change dir.");
	return FALSE;
    }
    if(strlen(fname) == 0){
	timed_error_notifier("Cannot change to directory with empty name.");
	return FALSE;
    }
    if(!source_browser){
	error_msg("Warning: No source browser in change dir.");
	return (safe_chdir(fname) == 0);
    }
    // are we already there ? (shortcut)
    if(!getcwd(cwd_buf,cwd_bufsize)){
	// this is not as bad as it looks. E.g., after rename in the tree,
	// the CWD may be invalid (ENOENT), but the whole point of the
	// routine then is to fix that. So, don't bark about it.
	if (errno == ENOENT) {
	    status_msg(2, "Fixing directory to `%s'...", fname);
	} else {
	    timed_strerror_notifier("UC: Couldn't get current directory !");
	}
	// simply continue here, don't fail yet. the new cd may work.
    } else {
	if(strcmp(cwd_buf, fname) == 0){
	    const char *tmp_buf = source_browser->get_cwd();
	    if(strcmp(tmp_buf, fname) == 0){
		// ok, I believe it now that it is valid.
		return TRUE;
	    }
	}
    }

    int retval = safe_chdir(fname);
    /* 
     * after changing down to the new dir, position the bar on the ..,
     * so that we can change up immediately after it.
     * if we changed up, we want to be positioned on the name of
     * the old dir, so that we can go down immediately again.
     */
    char errbuf[1024], lookbuf[1024];
    if(retval != 0){
	sprintf(errbuf, "#%d: Can't change directory to `%s'.",
	    source_browser->get_ID(), fname
	);
	timed_strerror_notifier(errbuf, notifier_secs);
	source_browser->time_stamp();

	strcpy(lookbuf, fname);	     // avoid a BAD pointer aliasing here.
	strcpy(crash_path, lookbuf);  
	char *tmp_ptr = strrchr(crash_path, '/');
	if(tmp_ptr){
	    *tmp_ptr = '\0'; // so that we can step up.
	    if(strlen(crash_path) > 0){
		return tool_change_dir(crash_path, FALSE, TRUE, TRUE, TRUE, TRUE);   
	    }
	}

	if(attempt_root_flag){
	    status_msg(0, "Attempting to change dir to root...");
	    if(!failure_flag){
		failure_flag = TRUE;
		return tool_change_dir("/", FALSE, TRUE, TRUE, TRUE, FALSE);	// attempt it once.
	    }
	}
	return FALSE;
    }
    if(set_current_flag){
	if(strcmp(fname, "..") == 0){
	    /* need the last item of the cwd. `/' is separator. */
	    char *tmp_ptr = strrchr(source_browser->get_cwd(), '/');
	    if((!tmp_ptr) || (!(tmp_ptr+1)) ){
		strcpy(lookbuf, "..");
	    } else {
		strcpy(lookbuf, (tmp_ptr+1));
	    }
	} else {
	    strcpy(lookbuf, "..");
	}
    }
    /*
     * fname is valid, so we'd like to stick with it to avoid the 
     * automounter bug. doesn't work, though - it could be a relative
     * pathname. We loose !
     * update the browser fields if necessary.
     */
    if(!getcwd(cwd_buf,cwd_bufsize)){
	timed_strerror_notifier("UC: Couldn't get current directory - attempting root.");
	safe_chdir("/");
	if(!getcwd(cwd_buf,cwd_bufsize)){
	    program_unstable("After retry: Couldn't get current directory !");
	    return FALSE;
	}
    }
    failure_flag = FALSE;
    source_browser->freeze();
    if(update_browser_bufs_flag){
	source_browser->set_cwd_buf(cwd_buf);
	source_browser->update();
    }
    // tell the update machinery.
    source_browser->time_stamp();
    /* set a current line if desired. */
    if(set_current_flag){
	source_browser->set_current_fname(lookbuf, TRUE);
    }
    source_browser->unfreeze();
    dir_menu_remember_last(cwd_buf);
    if(update_tree_flag){
	tree_form_sync();
    }

    if(update_xshell_flag){
	xshell_cd(cwd_buf);
    }
    xshell_sync_title();

    static char pwd_buf[MAXPATHLEN+64];
    sprintf(pwd_buf, "PWD=%s", cwd_buf);
    putenv(pwd_buf);

    return TRUE;
}

int tool_change_target_dir(
    const char *fname, 
    int update_browser_bufs_flag,
    int update_tree_flag
){
    if(source_browser == target_browser){
	return tool_change_dir(fname, TRUE, update_browser_bufs_flag, update_tree_flag, TRUE, FALSE);
    }
    const int cwd_bufsize = MAXPATHLEN+1;
    char cwd_buf[cwd_bufsize];
    if(!fname){
	program_unstable("NULL pointer in change dir.");
	return FALSE;
    }
    if(strlen(fname) == 0){
	timed_error_notifier("Cannot change to directory with empty name.");
	return FALSE;
    }
    if(!target_browser){
	error_msg("Warning: No target browser in change target dir.");
	return (safe_chdir(fname) == 0);
    }
    // are we already there ? (shortcut)
    if(strcmp(target_browser->get_cwd(), fname) == 0){
	return TRUE;
    }
    int retval = safe_chdir(fname);
    /* 
     * after changing down to the new dir, position the bar on the ..,
     * so that we can change up immediately after it.
     * if we changed up, we want to be positioned on the name of
     * the old dir, so that we can go down immediately again.
     */
    if(retval != 0){
	timed_strerror_notifier("New target directory invalid!", notifier_secs);
	// restart
	target_browser->time_stamp();
	return FALSE;
    }

    /*
     * fname is valid, so we'd like to stick with it to avoid the 
     * automounter bug. doesn't work, though - it could be a relativ
     * pathname. We loose !
     * update the browser fields if necessary.
     */
    if(!getcwd(cwd_buf,cwd_bufsize)){
	program_unstable("Couldn't get current directory !");
	return FALSE;
    }
    if(update_browser_bufs_flag){
	target_browser->set_cwd_buf(cwd_buf);
	target_browser->update();
    }

    target_browser->time_stamp();

    if(update_tree_flag)tree_form_sync();

    // restore tool dir.
    retval = safe_chdir(source_browser->get_cwd());
    if(retval != 0){
	timed_strerror_notifier("Old source directory invalid!", notifier_secs);
	return FALSE;
    }
    return TRUE;
}

void tool_update_matching_dirs(
    const char *dir_buf, 
    int keep_selection_current_flag
){
    if(!dir_buf || !source_browser){
	program_unstable("tool_update_matching_dirs: NULL ptrs.");
    }
    browser_c *tmp_browser = source_browser;
    do {
	if(strcmp(tmp_browser->get_cwd(), dir_buf) == 0){
	    tmp_browser->update(keep_selection_current_flag);
	}
	tmp_browser = tmp_browser->next_browser;
    } while(tmp_browser != source_browser);
}

void tool_update_all_dirs(int keep_selection_current_flag){
    if(!source_is_stable()) return;
    browser_c *tmp_browser = source_browser;
    do {
	tmp_browser->update(keep_selection_current_flag);
	tmp_browser = tmp_browser->next_browser;
    } while(tmp_browser != source_browser);
}


void tool_do_colours(void){
    colours_show_form();
}

int tool_set_target(browser_c *a_browser){
    if(!a_browser || !target_browser){
	program_unstable("NULL ptr in tool_set_target.");
	return FALSE;
    }
    if(a_browser == target_browser){
	return FALSE;
    } else {
	target_browser = a_browser;
	target_browser->set_target(TRUE);
    }
    browser_c *tmp_browser = target_browser->next_browser;
    while(tmp_browser != target_browser){
	tmp_browser->set_target(FALSE);
	tmp_browser = tmp_browser->next_browser;
    }
    tree_form_sync();
    return TRUE;
}

static void source_focus_sync(browser_c *a_browser, int move_focus_flag){
    if(!a_browser) return;
    if (!toolbox_tree_flag) {
	toolbox_attach(FALSE);
    }
    if(move_focus_flag){
	//tool_focus_move(a_browser->form, a_browser->panel);
	tool_focus_set(a_browser->form, a_browser->panel);
    }
}

static void tool_set_source_sync(int move_focus_flag){
    /* adjust all tool state influenced by having a new
     * source browser. This includes moving the mouse. 
     */
    colours_form_sync();
    display_form_sync();
    sort_form_sync();
    tree_form_sync();
    source_focus_sync(source_browser, move_focus_flag);
}

static int tool_set_source_special2(browser_c* a_browser, int move_focus_flag){
    // this assumes that we don't need to call tool_set_target,
    // and that there are no side effects in that function !!!
    source_browser = a_browser;
    source_browser->set_source_target(TRUE, FALSE);
    target_browser = source_browser->next_browser;
    target_browser->set_source_target(FALSE, TRUE);
    tool_set_source_sync(move_focus_flag);
    return TRUE;
}

// master backend version of the set_source family:
//
int tool_set_source(browser_c *a_browser, int move_focus_flag){
    if(!source_browser || !a_browser){
	program_unstable("NULL ptr in tool_set_source.");
	return FALSE;
    }
    if(a_browser == source_browser){
	// even here, sync mouse if necessary (e.g., direct access) 
	source_focus_sync(source_browser, move_focus_flag);   
	return FALSE;
    }
    /* test for the special case of 2 browsers.
     * in that case, we always want one as target, one as
     * source. 
     */
    if(browser_c::next_ID == 3){
	return tool_set_source_special2(a_browser, move_focus_flag);
    }

    source_browser = a_browser;
    source_browser->set_source(TRUE);

    browser_c *tmp_browser = source_browser->next_browser;
    while(tmp_browser != source_browser){
	tmp_browser->set_source(FALSE);
	tmp_browser = tmp_browser->next_browser;
    }

    tool_set_source_sync(move_focus_flag);
    return TRUE;
}

int tool_set_source(int new_id, int move_focus_flag){
    if(new_id <= 0 || new_id >= browser_c::next_ID){
	cerr << "invalid ID requested in tool_set_source: " << new_id << endl;
	return FALSE;
    }
    browser_c *tmp_browser = source_browser;
    while(new_id != tmp_browser->get_ID()){
	tmp_browser = tmp_browser->next_browser;
	if(tmp_browser == source_browser){
	    // safeguard against ringbuffer corruption.
	    return FALSE;
	}
    }
    return tool_set_source(tmp_browser, move_focus_flag);
}

int tool_set_source(FL_FORM *a_form, int move_focus_flag){
    return tool_set_source(tool_find_browser(a_form), move_focus_flag);
}

static int
    tool_ctrl_enabled_flag = TRUE,
    tool_meta_enabled_flag = TRUE
;

void tool_disable_ctrl(void){
    tool_ctrl_enabled_flag = FALSE;
}

void tool_enable_ctrl(void){
    tool_ctrl_enabled_flag = TRUE;
}    

int tool_get_ctrl (XEvent *xev){
    if(!tool_ctrl_enabled_flag) return FALSE;
    if(tool_ctrl_on_flag){
	tool_ctrl_on_flag = FALSE;
	return TRUE;
    }
    if(xev){
	int state = 0;
	switch(xev->type){
	case KeyPress:
	case KeyRelease:
	    state = (*xev).xkey.state; break;
	case ButtonPress:
	case ButtonRelease:
	    state = (*xev).xbutton.state; break;
	case EnterNotify:
	case LeaveNotify:
	    state = (*xev).xcrossing.state; break;
	case MotionNotify:
	    state = (*xev).xmotion.state; break;
	default:
	    return FALSE;
	}
	return state & ControlMask;
    } else {
	/*
	int flag = controlkey_down(fl_keymask);
	cerr << "getctrl1: " << flag << endl;
	FL_Coord x, y;
	fl_get_mouse(&x, &y, &fl_keymask);
	cerr << "getctrl2: " << controlkey_down(fl_keymask) << endl;
	return flag;
	*/
	return controlkey_down(fl_keymask);
    }
}

int tool_get_alt(void){
    return (fl_keymask & Mod1Mask);
    /*
    return ((fl_keymask & Mod1Mask) || 
	    (fl_keymask & Mod2Mask) ||
	    (fl_keymask & Mod3Mask));
    */
}

int tool_get_esc(void){
    if (tool_escape_flag) {
	if (!fl_keysym_pressed(XK_Escape)) {
	    //cerr << "Bad X-Server: escape flag on, but key not pressed.\n";
	    tool_escape_flag = FALSE;
	    return FALSE;
	} else {
	    return TRUE;
	}
    }
    return FALSE;
}
    
int tool_get_shift(void){
    return shiftkey_down(fl_keymask);
}

void tool_disable_meta(void){
    tool_meta_enabled_flag = FALSE;
}

void tool_enable_meta(void){
    tool_meta_enabled_flag = TRUE;
}    

int tool_get_meta(XEvent *xev){
    if (dbg_flag) cerr << "tool_get_meta...\n";
    if (!tool_meta_enabled_flag) return FALSE;
    if (tool_get_ctrl(xev)) {
	if (dbg_flag) cerr << "tool_get_ctrl true.\n";
	return TRUE;
    }
    if (fl_keymask & Mod1Mask) {
	if (dbg_flag) cerr << "Mod1Mask true.\n";
	return TRUE;
    }
    if (tool_get_esc()) {
	if (dbg_flag) cerr << "Escape true.\n";
	return TRUE;
    }
    /*
    if (shiftkey_down(fl_keymask)) {
	if (dbg_flag) cerr << fl_keymask << "shiftkey down true.\n";
	return TRUE;
    }
    */
    if (dbg_flag) cerr << "tool_get_meta: FALSE\n";
    return FALSE;
}


void tool_set_ctrl(void){
    tool_ctrl_on_flag = TRUE;
}

void tool_focus_move(FL_FORM *form){
    if(!form) return;
    focus_move(form->x + form->w/2, form->y + form->h/2, form->window);
}

void tool_focus_move(FL_FORM *form, FL_OBJECT *obj){
    tool_focus_move(form, obj, 0, 0);
}

void tool_focus_move(
    FL_FORM *form, 
    FL_OBJECT *obj, 
    FL_Coord x_offset, 
    FL_Coord y_offset
){
    if(!form) return;
    if(!form->visible) return;
    if(!obj || !obj->visible){
	tool_focus_move(form);
	return;
    }

    focus_move(
	form->x + obj->x + obj->w/2 + x_offset, 
	form->y + obj->y + obj->h/2 + y_offset, 
	form->window
    );
}

void tool_focus_set(FL_FORM *form){
    if(!form) return;
    focus_clear();
    focus_set(form->x + form->w/2, form->y + form->h/2, form->window);
}

void tool_focus_set(FL_FORM *form, FL_OBJECT *obj) {
    if(!form) return;
    if(!form->visible) return;
    if(!obj || !obj->visible){
	tool_focus_set(form);
	return;
    }

    focus_clear();
    focus_set(
	form->x + obj->x + obj->w/2,
	form->y + obj->y + obj->h/2,
	form->window
    );
}

void tool_sync_defaults(void){
    M_info("global::", "tool_sync_defaults.");
    xshell_sync_defaults();   // first
    status_sync_defaults();   // old first, now next.
    display_form_sync();
    options_sync_defaults();
    toolbox_sync_defaults();
    tree_colour_sync_defaults();
    tree_sync_defaults();
    edit_sync_defaults();
    action_sync_defaults();
    wm_sync_defaults();
}

static void close_it(FL_FORM *form, void_func_pt close_func){
    if(close_func){
	close_func();
    } else {
	if(form->visible){
	    focus_restore_start();
	    fl_hide_form(form);
	    focus_restore_finish();
	}
    }
}

int standard_form_event_cb(
    FL_FORM *form,
    XEvent *xev,
    void_func_pt close_func,
    void_func_pt help_func
){
    if(!form || !xev) return FALSE;
    if(!form->visible) return FALSE;
    XEvent *xevent = (XEvent *) xev;
    KeySym keysym;

    switch(xevent->type){
    case KeyPress:
	tool_got_event_flag = TRUE;
	if(dbg_flag) cerr << "standard form event cb: found an X key press event.\n";
	keysym = XKeycodeToKeysym(fl_display, (*xevent).xkey.keycode, 0);
	switch(keysym){
	case XK_q:
	case XK_Q:
	    if (tool_get_esc() || tool_get_alt()) {
		close_it(form, close_func);
		return TRUE;
	    }
	    return FALSE;
	case XK_Escape:
	    //cerr << "standard got Escape.\n";
	    close_it(form, close_func);
	    tool_escape_flag = TRUE;
	    return TRUE;
	case XK_F1:
	    //cerr << "standard got F1.\n";
	    help_event_cb(help_func);
	    return TRUE;
	case SunXK_F37: if(!sun_keyboard_flag) return FALSE;
	case XK_F12:
	    ExitButtonCB(NULL, 0);
	    return TRUE;
	default:
	    if(dbg_flag) cerr << "ignoring keysym .\n";
	    break;
	}
    case KeyRelease:
	keysym = XKeycodeToKeysym(fl_display, (*xevent).xkey.keycode, 0);
	if (keysym == XK_Escape) {
	    tool_escape_flag = FALSE;
	    // return here?
	}
	break;
    case ClientMessage:
	if(is_delete_window(form->window, (XClientMessageEvent *) xev)){
	    tool_got_event_flag = TRUE;
	    close_it(form, close_func);
	    return TRUE;
	}
	return FALSE;
    default:
	if(dbg_flag)cerr << "standard event unprocessed.\n";
    }
    return FALSE;
}

int standard_options_event_cb(
    FL_FORM *form,
    XEvent *xev,
    void_func_pt options_func,
    int //allow_rmouse_flag			      
){
    if(!form || !xev) return FALSE;
    if(!form->visible) return FALSE;
    XEvent *xevent = (XEvent *) xev;

    switch(xevent->type){
    case KeyPress:
	tool_got_event_flag = TRUE;
	KeySym keysym;
	keysym = XKeycodeToKeysym(fl_display, (*xevent).xkey.keycode, 0);
	switch(keysym){
	case XK_F2:
	    if(tool_get_meta() || !options_func){
		OptionsButtonCB(NULL,0);		
	    } else {
		options_func();
	    }
	    return TRUE;
	default:
	    return FALSE;
	}
    }
    return FALSE;
}

void help_event_cb(void_func_pt help_func){
    if(tool_get_meta()){
	info_show_form();
    } else {
	//cerr << "external context sensitive form help request." << endl;
	if(help_func){
	    help_func();
	} else {
	    timed_notifier("Sorry, no context sensitive help available for this topic.", notifier_secs);
	}
    }
}

int tool_default_actions(void){
    return TRUE;
}

void fl_qenter(int cmsg, int){
    if(tool_cmsg != 0){
	cerr << "tool message stack overflow.\n";
    }
    tool_cmsg = cmsg;
}

void dummy(int, int){
    cerr << "X: .\n";
}

browser_c* tool_find_browser_id(int id){
    if(id <= 0) return NULL;
    browser_c *tmp_browser = source_browser;
    while(id != tmp_browser->get_ID()){
	tmp_browser = tmp_browser->next_browser;
	if(tmp_browser == source_browser){
	    // safeguard.
	    return NULL;
	}
    }
    return tmp_browser;
}

browser_c* tool_find_browser(FL_FORM *a_form){
    if(!a_form) return NULL;
    browser_c *tmp_browser = source_browser;
    while(a_form != tmp_browser->form){
	tmp_browser = tmp_browser->next_browser;
	if(tmp_browser == source_browser){
	    // safeguard.
	    return NULL;
	}
    }
    return tmp_browser;
}

void add_free_obj(FL_FORM* form, FL_HANDLEPTR func, int){
    if(!form || !func){
	cerr << "standard: cannot add NULL func to NULL form.\n";
    } else {
	char buf[2];
	buf[0] = '\033';  // esc (as in ascii)
	buf[1] = '\0';
	fl_addto_form(form);
	FL_OBJECT *obj = fl_add_free(FL_INPUT_FREE,0,0,1,1,"",func);
	obj->input = TRUE;
	fl_set_object_shortcut(obj, buf, TRUE);
	fl_end_form();
    }
}

void center_form(FL_FORM *form){
    if(!form) return;
    if(form->visible) return;
    form->x = (fl_scrw - form->w) / 2;
    form->y = (fl_scrh - form->h) / 2;
    if (form->x > fl_scrw - form->w - 0)
      form->x = fl_scrw - form->w - 0;

    if (form->x < 0)
      form->x = 0;
    
    if (form->y > fl_scrh - form->h - 0)
      form->y = fl_scrh - form->h - 0;
    
    if (form->y < 0)
      form->y = 0;
}

const char *blocks_to_string(ulong n_blocks, ulong bsize){
    static char string_buf[128];
    if(!n_blocks || !bsize) return "-1";
    n_blocks = (ulong) ( ((double) n_blocks) * ( ((double) bsize) / 1024.0) );

    //cerr << n_blocks << endl;
    
    ulong rem, val, count = 0, div = 1;
    do {
	val = n_blocks / div;
	rem = n_blocks % div;
	div *= 1024;
	count++;
    } while (val >= 1024 && count < 7 && div != 0);

    // now, val < div. Want three digits + a dot or four digits.
    if(count <= 1){
	// exception for kbytes, no fraction.
	sprintf(string_buf, "%lu k", val);
    } else {
	sprintf(string_buf, "%lu", val);
	int len = strlen(string_buf);
	if(len < 3){
	    sprintf(string_buf, "%lu.%lu", val, rem);
	    string_buf[4] = '\0';
	}
	switch(count){
	case 2:	 strcat(string_buf, " M"); break;
	case 3:	 strcat(string_buf, " G"); break;
	case 4:	 strcat(string_buf, " T"); break;
	case 5:	 strcat(string_buf, " P"); break;
	case 6:	 strcat(string_buf, " ?"); break;
	default: strcat(string_buf, " ?"); break;
	}
    }
    return string_buf;
}

const char *bytes_to_string(llong_t bytes){
    static char string_buf[128];
    if(bytes < 0) return "-1";

    llong_t rem, val, count = 0, div = 1;
    do {
	val = bytes / div;
	rem = bytes % div;
	div *= 1024;
	count++;
    } while (val >= 1024 && count < 7);

    // now, val < div. Want three digits + a dot or four digits.
    if(count <= 1){
	// exception for bytes, no fraction.
	sprintf(string_buf, "%ld b", (long) val);
    } else {
	sprintf(string_buf, "%ld", (long) val);
	int len = strlen(string_buf);
	if(len < 3){
	    sprintf(string_buf, "%ld.%ld", (long) val, (long) rem);
	    string_buf[4] = '\0';
	}
	switch(count){
	case 2:	 strcat(string_buf, " k"); break;
	case 3:	 strcat(string_buf, " M"); break;
	case 4:	 strcat(string_buf, " G"); break;
	case 5:	 strcat(string_buf, " T"); break;
	case 6:	 strcat(string_buf, " P"); break;
	default: strcat(string_buf, " ?"); break;
	}
    }
    return string_buf;
}

int is_browser_window(Window window){
  browser_c *tmp_browser = source_browser;
  do {
    if (tmp_browser->form->window == window) return TRUE;
    tmp_browser = tmp_browser->next_browser;
  } while (tmp_browser != source_browser);
  return FALSE;
}

int safe_system(const char *cmd) {
    int status;
    if (!cmd) return -1;
    pid_t pid = fork();

    switch(pid) {
    case -1:
	// error
	timed_strerror_notifier("Can't fork:");
	return FALSE;
    case 0: 
	// child
#if defined(GENERICBSD)
	setpgrp(0,0);
#else
	setpgrp(); // should be equivalent to setpgid above.
#endif
	system(cmd);
	// no cleanup
	_exit(0);
    default:
	// we always gotta wait (darn!!)
	waitpid(pid, &status, 0);
	return TRUE;
    }
    return TRUE;
}
#ifndef SGI
void sginap(unsigned long nap_ticks){
    fl_msleep(nap_ticks * 10);	
}

#endif

#if defined(SUNOS)
/* compiles fine on 4.1.1... it has strerror.
const char *strerror(int errno){
    if(errno < sys_nerr){
	return sys_errlist[errno];
    } else {
	return "Sorry: unknown error.";
    }
} 
*/
#endif

#if defined(HP)
int gethostid(void){
  return 0;
}
#endif

// can't use libucb.a on Sinix. Therefore, define gethostid to return 0.
#if defined(SINIX) || defined(SCO)
extern "C" {
long int gethostid(void){
  return 0;
}
}
#endif

#if defined(SCO)
extern "C" int gettimeofday(struct timeval *tp);

int gettimeofday(struct timeval *tp, struct timezone *){
    return gettimeofday(tp);
}
#endif

