#include <stdio.h>
#include "global.h"
#include "help_text.h"

//   01234567879012345678790123456787901234567879012345678790123456787901234567 70

const char *arg_required_help_text[] = {
    "",
    "The action you selected specifies several arguments of type ${UC_Argument} in",
    "the special UC makefile ~/.uc/ucmk. You need to supply these arguments in order",
    "to run the action. Otherwise, cancel the operation.",
    "",
    NULL
};

const char *action_multi_help_text[] = {
    "",
    "You have 4 options to answer this question. First, as default, you can",
    "confirm the question using the return button (or, as usual, the `Enter'-key).",
    "This confirms the question, e.g. overwriting, for this particular file, but",
    "not for _all_ files. You can also select the `ALL'-option in order to auto-",
    "matically confirm the question again for all files worked upon during this ",
    "operation. Under this condition, you will NOT be asked again for that kind",
    "of question. So, especially when confirming something like `Overwrite ALL',",
    "make sure you know what will happen with your files.",
    "To cancel the question for the particular file, select `Cancel File' (or use",
    "the `Escape'-key). To cancel the whole operation, select `Cancel ALL'.",
    "",
    NULL
};
    
const char *browser_help_text[] = {
    "",
    "- Source Browser:",
    "  Always one browser is the `Source', the focus of current user activity. It",
    "  is used as primary directory for all unary operations like `Delete'. If a",
    "  browser is the source browser, a small green light is shown in its top left",
    "  corner, and the window header shows the string `Source' after the browsers",
    "  numeric ID. To change the source browser, use the `Tab' key (shift tab key)",
    "  to cycle forwards (backwards) through the browsers, or click a mouse button",
    "  in the desired browser.",
    "",
    "- Target Browser:",
    "  A second browser is the `Target', used as secondary directory for binary ",
    "  operations like `Copy' or `Move'. The target browser is identified by a ",
    "  yellow light in its top left corner and the string `Target' in its window",
    "  header. If source and target browsers (or directories) are the same, you",
    "  will be prompted to select a new target directory with the tree for binary",
    "  operations.",
    "  To make a browser the target, use `Ctrl-t', or `Ctrl-Pad5' on the numeric",
    "  keypad, or select Action->Set Target from the browser menu (F2). Browsers",
    "  who are neither target nor source are `Passive'.",
    "  ",
    "- Scrolling:",
    "  ",
    "  The specially coloured `current line' in the source browser is usually the",
    "  focus of your (and UC's)  activity, because it is the primary tool to select",
    "  a file that you want to work with or upon. Use the scrollbar, up/down arrows",
    "  and the page up/down and home/end keys. There are also emacs-like shortcuts",
    "  for the same purpose:",
    "  ",
    "  Scroll action: <-> Associated keyboard shortcuts:",
    "  ",
    "  a line down        down arrow, pad down arrow, Ctrl-n",
    "  a line up          up arrow, pad up arrow, Ctrl-p",
    "  a page down        page down, pad page down, Ctrl-v",
    "  a page up          page up, pad page up, Alt-v, Esc-v",
    "  go to first line   Home, pad Home, Alt-<, Esc-<, Ctrl-a",
    "  go to last line    End, pad End, Alt->, Esc->, Ctrl-e",
    "  center line        pad-5, Ctrl-l      ",
    "  ",
    "- Mouse:",
    "  ",
    "  Use the left mouse button for scrolling, middle mouse for selection (sweep ",
    "  up and down are possible) and right mouse for menu. Double-clicking the left",
    "  is equivalent to pressing enter, which activates/executes the current file",
    "  (see below for file type rules).",
    "  ",
    "- File Type Rules:",
    "",
    "  A mouse doubleclick or Enter activates a file. If the file name has a suffix",
    "  like `.rgb', the suffix is looked up in the make file ~/.uc/ucsfx. If it exists",
    "  in the suffix file, the action specified there for this suffix is executed.",
    "  If the file has no suffix, or no suffix rule was found, it is either executed",
    "  (if it is an executable), or just viewed (if it is a normal file). You can",
    "  customize the file ~/.uc/ucsfx to reflect your particular preferences. Look ",
    "  into the file for more details (if it doesn't exist, it will be automagically",
    "  created the first time you run uc).",
    "  If the ucsfx file doesn't exist in your home/.uc directory, just run UC once",
    "  to generate it. Note that you have to restart UC (or load the configuration)",
    "  in order to reload the suffix file into the tool.",
    "",
    "- Menu `Make' Interface:",
    "  ",
    "  The `Make' submenu lists all the make targets found in the file ~/.uc/ucmk.",
    "  If the targets in that file (look into the file for details) are properly",
    "  set up, you can select a target, for example `compress', from the menu, and",
    "  that particular action will be executed on the browser selection. This is a",
    "  very powerful customization mechanism.",
    "  If the ucmk file doesn't exist in your home/.uc directory, just run UC once",
    "  to generate it. Note that you have to restart UC (or load the configuration)",
    "  in order to reload the makefile into the tool.",
    "  ",
    "- Search Mode:",
    "  ",
    "  Use `ctrl-s' to search. There is more context sensitive help available while",
    "  you have activated the search mode.",
    "",
    "- Selection Forwarding:",
    "",
    "  Use the `alt-f' shortcut to forward the browser selection to the shell. ",
    "  The names of the selected files are forwarded to the shell, separated by",
    "  spaces. If nothing is selected, the name of the current file is taken. This",
    "  shortcut is rather useful, as it allows you to execute any Unix command with",
    "  any leading and/or trailing arguments on the selection.",
    "",
    "- Cloning and Killing Browsers:",
    "",
    "  Browsers can be conveniently cloned via the `clone'-option in the browser",
    "  menu. This creates a new browser inheriting all features from its parent,",
    "  including window size, colours, font, current directory and so on. The new",
    "  browser is inserted into the browser ringbuffer after its parent, and then",
    "  displayed slightly offset from it. It can then be used as usual.",
    "  It is also possible to destroy existing browsers, which is quite useful if",
    "  the screen gets cluttered or repeated cycling through browsers gets tiring.",
    "  Just select the `kill'-option from the browser menu.",
    "",
    "- Browser Options:",
    "  ",
    "  Browsers are very customizable, both in appearance and information content.",
    "  All the browser options are accessed via the F2 browser menu, which pops up",
    "  extra windows. Customization applied only to the source browser. If you wish",
    "  to have all browsers in a same particular style, don't change them indivi-",
    "  dually. Rather, create one and then clone it, so that its clones will inherit",
    "  the desired style. ",
    "  You can save the option settings into the defaults database. This can be done",
    "  by selecting `Save Configuration' on the `Meta-F2' global options form.",
    "  ",
    "  ",
    NULL
};

const char *dirinfo_help_text[] = {
    "  ",
    "The directory info panel is an information window that shows you various data",
    "and statistics about a directory.",
    "  ",
    "Use the `Disc Use'-button to get a new window with du (1) like information  ",
    "about the directory. Use the `Auto'-button to toggle wether this window should",
    "be automatically shown whenever you F5-view a directory, and the `Sort'-button",
    "to toggle the sorting behaviour. If you don't sort, you'll see output from du",
    "straight away, otherwise, you'll have to wait until du finishes. This makes a",
    "difference for large directories.  ",
    "  ",
    NULL
};

    
const char *colours_help_text[] = {
    "",
    "- The Colour Editor allows you to customize the colours of the browser line ",
    "  display. The colours displayed are from the source browser, and changes you",
    "  make affect the source browser only. Thus, it is possible to have different",
    "  colour schemes in different browsers at the same time. Clone the browser to",
    "  get another one of the same colour, or use the `Sync All' button to make all",
    "  browser colours the same.",
    "",
    "- There are a few predefined colour schemes in the `Predefined'-menu.",
    "",
    "- There are 2x2x2 = 8 possible state combinations for displayed lines: ",
    "  current and not current, selected and not selected, fore- and background;",
    "",
    "- in practice, only 4 different colours are needed: In this example, yellow ",
    "  for selected foreground, white for deselected foreground, grey for current",
    "  line background & black for non-current (normal) line background;",
    "",
    "- Be careful when creating your own colour scheme ! It can be very confusing",
    "  if you don't stick with these conventions. ",
    NULL
};

const char *options_help_text[] = {
    "",
    "The Options Panel (Meta-F2):",
    "",
    "The options panel allows to set some options global to the tool. It is",
    "divided into five sections.",
    "",
    "- the `Configuration' section:",
    "",
//   01234567879012345678790123456787901234567879012345678790123456787901234567 70
    "  This is the interface machinery for saving and restoring the defaults",
    "  base. You can save the current configuration, load the old one, or restore",
    "  the factory defaults.",
    "",
    "- the `Configuration at Exit' section:",
    "",
    "  Here, you can set the behaviour of the tool at exit. It is possible to ",
    "  always save the configuration at exit, to have UC ask for it each time, ",
    "  or to never save.",
    "",
    "- the `Tree Data at Exit' section:",
    "",
    "  This is analogous to the prior section, except that it applies to the tree",
    "  database.",
    "",
    "- the `Defaults' section:",
    "",
    "  Switch AutoRaise on if you want the source browser window to automatically",
    "  pop to the top whenever something important in the source browser happens.",
    "  This is on by factory default.",
    "",
    "  Switch AutoMouse on if you want the mouse pointer to automatically be moved",
    "  by the tool, for example when showing a new form. If you don't like the ",
    "  mouse to be manipulated by a program, switch it off. This is also on by ",
//   01234567879012345678790123456787901234567879012345678790123456787901234567 70
    "  factory default, as it is necessary to allow fast keyboard-only interaction.",
    "",
    "  If you press the `Editor'-button, you will be prompted to supply the (pre-",
    "  ferably full) pathname of your favourite editor. By default, this is set to",
#ifndef SGI
    "  `/usr/bin/X11/xedit'.",
#else    
    "  `/usr/sbin/jot'.",
#endif
    "",
    "- the `Extra Windows' section:",
    "",
    "  Here, you can switch some of UC's auxiliary windows on and off. ",
    "",
    NULL
};

const char *display_help_text[] = {
    "",
    "The Display Options form allows you to change the amount of information",
    "displayed about each file shown by the browsers. The options are changed",
    "for each browser individually. To change them for all browsers, press the",
    "`Sync All'-button to propagate the changes.",
    "",
    "- On/Off Toggle Buttons:",
    "  The following status buttons toggle the printing of specific information",
    "  for each file on and off:",
    "",
    "  - Owner:    owner; ",
    "  - Group:    group; ",
    "  - Size:     size in bytes;",
    "  - Perm's:   permissions in symbolic form; ",
    "  - # Links:  number of hard links; ",
    "  - Access:   time of last _access_;",
    "  - Modific.: time of last _modification_;",
    "  - Inode:    inode number;",
    "  - FileType: file type",
    "              -: normal file",
    "              b: block special device",
    "              c: character special device",
    "              d: directory",
    "              l: link",
    "              p: FIFO",
    "              s: socket",
    "  - TypeChar: tag the file names with a type character.",
    "",
    "- Modification Toggle Buttons:",
    "  The remaining status buttons modify the printing format:",
    "  - Years:    Add the year when printing dates (worth omitting, for brevity);",
    "  - Seconds:  Add the second when printing times (omit for b.);",
    "  - ID's:     use symbolic (`root') or numeric (`0') owner/group ID's;",
    "",
    "- Fontsize and -style:",
    "  The Fontsize and style are menus to adjust the font style and size used in",
    "  the browser display. Small, normal fonts tend to be good for lots of infor-",
    "  mation in small windows. Large, bold fonts are good if you have more space.",
    "",
    "- Symbolic Links:",
    "  When you enable the `Follow'-option, symbolic links will be followed. That",
    "  means that the link target information is displayed, not the information",
    "  about the link itself.",
    "  ",
    "",
    "- Factory Defaults:",
    "  Use the `Defaults'-button to restore the display factory defaults.",
    "",
    NULL
};

const char *edit_help_text[] = {
    "",
    "With the F6 Edit button, you can edit files in the UC default editor. If you",
    "you have no files selected, the file given by the current line is edited. If",
    "you have exactly one file selected, that file is edited. If you have several",
    "files selected, there are two options.",
    "",
    "First, you can invoke a new copy of the editor for each of the files. This is",
    "the normal behaviour.",
    "",
    "Second, if you hold down the `Ctrl'-key while pressing F6, only ONE copy of",
    "the editor is invoked, with all the selected files as its argument. This is",
    "useful for editors (such as GNU emacs) that can edit several files at once.",
    "",
    NULL
};

const char *license_help_text[] = {
    "",
    "This open source software is distributed under the GNU Public License.",
    "The only thing that is prohibited is to say you wrote it :)!",
    "",
    "No warranty of any kind is given for this software. See the license legalese",
    "below. IF YOU DON'T AGREE ON THE TERMS BELOW, DO NOT USE THE SOFTWARE AND ",
    "REMOVE THE SOFTWARE FROM YOUR FILE SYSTEMS.",
    "",
    "LIMITED WARRANTY AND DISCLAIMER OF WARRANTY; LIMITATION OF LIABILITY.",
    "",
    "IMPORTANT:    The software is provided to the Licensee on an",
    "\"AS IS\" basis, and Henrik Klagges makes no other warranty of any kind, express or",
    "implied, with regard to the software licensed hereunder. Henrik Klagges does not",
    "warrant or represent that the software will operate uninterrupted or error",
    "free or that all defects in the software are correctable or will be corrected.",
    "UNIX11 DISCLAIMS, ALL OTHER WARRANTIES, EXPRESS OR IMPLIED, INCLUDING, WITHOUT",
    "LIMITATION, ANY WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.",
    "Some states do not allow the exclusion of implied warranties, so the",
    "exclusion above may not apply to Licensee. This warranty gives the Licensee",
    "specific legal rights, and the Licensee may have other rights which vary ",
    "from state to state.",
    "IN NO EVENT SHALL HENRIK KLAGGES BE LIABLE TO LICENSEE FOR ANY",
    "SPECIAL, CONSEQUENTIAL, INCIDENTAL OR INDIRECT DAMAGES OF ANY KIND (INCLUDING",
    "WITHOUT LIMITATION LOSS OF PROFITS OR DATA AND PERSONAL INJURY), WHETHER OR",
    "NOT UNIX11 HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH LOSS, HOWEVER CAUSED",
    "AND ON ANY THEORY OF LIABILITY, ARISING OUT OF THIS AGREEMENT. THESE ",
    "LIMITATION SHALL APPLY NOTWITHSTANDING THE FAILURE OF THE ESSENTIAL PURPOSE",
    "OF ANY LIMITED REMEDY.",
    "In no event will Mr. Klagges be liable for any claim against Licensee by a third",
    "party, and the Licensee hereby agrees to indemnify and hold Mr. Klagges harmless",
    "for any claims for cost, damage, expense or liability arising out of or in",
    "connection with the installation, use and performance of the software",
    "licensed hereunder, whether alone or in combination with any other product",
    "or service.",
    "Some states do not allow the limitation or exclusion of liability for ",
    "incidental or consequential damages, so the limitation above may not apply",
    "to the Licensee.",
    "",
    "The Unix Cockpit was written 1989-2000 by Henrik Klagges. Distributed under GPL.",
   "",
    NULL
};

//   01234567879012345678790123456787901234567879012345678790123456787901234567 70

const char *copy_rename_help_text[] = {
    "",
    "Copy-Rename is a combined operation that allows you to give a new name to a ",
    "file while copying it to a different target directory. This useful if you need",
    "to both copy and rename a file, and can be very handy if naming conflicts ",
    "would arise from doing the operations individually (for example, the new name",
    "could exist in the source directory, so you cannot rename first, and the old",
    "name could exist in the target directory, so you cannot copy first). ",
    "A big OK/Cancel form is popped up which has an input field for the full new",
    "path. The old name is shown as a `preselected default' name, while the target",
    "directory's name is not preselected; for your convenience. Note that you will",
    "be prompted to confirm if the copy-rename operation would overwrite a file in",
    "the target directory.",
    "",
    "Copy-rename is invoked via `Meta-F10 Copy'. It only works if the source and ",
    "target browsers and directories are different. Otherwise, you will be prompted",
    "to select a new target directory using the tree.",
    "",
    NULL
};

const char *move_rename_help_text[] = {
    "",
    "Move-Rename is a combined operation that allows you to give a new name to a ",
    "file while moving it to a different target directory. This useful if you need",
    "to both move and rename a file, and can be very handy if naming conflicts ",
    "would arise from doing the operations individually (for example, the new name",
    "could exist in the source directory, so you cannot rename first, and the old",
    "name could exist in the target directory, so you cannot move first). ",
    "A big OK/Cancel form is popped up which has an input field for the full new",
    "path. The old name is shown as a `preselected default' name. Note that you will",
    "be prompted to confirm if the move-rename operation would overwrite a file in",
    "the target directory.",
    "",
    "Move-rename is invoked via `Meta-F8 Move'. It only works if the source and ",
    "target browsers and directories are different. Otherwise, you will be prompted",
    "to select a new target directory using the tree.",
    "",
    NULL
};

const char *rename_general_help_text[] = {
    "",
    "Rename allows you to make a _local copy_ of a file or group of files.",
    "A question form will be popped up which asks for confirmation. If you ",
    "confirm, all selected files in the source directory will be renamed.",
    "You will be prompted for a new name for each of these files.",
    "",
    "Rename is invoked via `F7 Rename'. It only works in the source directory.",
    "Use `F8 Move' to move files from the source to the target directory, and ",
    "`Meta-F8 Move' to move and rename at the same time.",
    "",
    NULL
};

const char *rename_help_text[] = {
    "",
    "Rename allows you to give a _new name_ to a file. An OK/Cancel form is popped",
    "up which has an input field for the new name. If you don't want to rename the",
    "file, press the `Cancel'-button or the `Escape'-key. Otherwise, type the new",
    "name in. The old name is shown as a `preselected default' name. This is handy",
    "if you want to rename the file to a new name that is very similar to the old",
    "name. Just use an arrow key (or the mouse) to position the cursor and change",
    "the name. If you type straight ahead, without repositioning the cursor once,",
    "the preselected default will be erased completely. This is useful if you want",
    "to use a new completely different from the old one. Note that you will be ",
    "prompted for confirmation if the rename operation would overwrite a file.",
    "",
    "Rename is invoked via `F7 Rename'. It only works in the source directory.",
    "Use `F8 Move' to move files from the source to the target directory, and ",
    "`Meta-F8 Move' to move and rename at the same time.",
    "",
    NULL
};

//   01234567879012345678790123456787901234567879012345678790123456787901234567 70

const char *copy_help_text[] = {
    "",
    "Copy allows you to copy one or more files from the source to the target di-",
    "rectory. A question form will be popped up which asks for confirmation of the ",
    "copy. If you confirm, all selected files in the source directory will be ",
    "copied to new files (with the same names) in the target directory. You will",
    "be prompted to confirm if the copying operation would overwrite a file in",
    "the target directory.",
    "",
    "Copy is invoked via `F10 Copy'. It only works if source and target browsers",
    "and directories are different. Otherwise, you will be prompted to select a",
    "new target directory using the tree.",
    "",
    "Use `Meta-F10 Copy' to copy and rename at the same time.",
    "",
    NULL
};

const char *move_help_text[] = {
    "",
    "Move allows you to move one or more files from the source to the target di-",
    "rectory. A question form will be popped up which asks for confirmation of the ",
    "move. If you confirm, all selected files in the source directory will be moved",
    "to the target directory. You will be prompted for confirmation if the move",
    "operation would overwrite a file in the target directory.",
    "",
    "Move is invoked via `F8 Move'. It only works if the source and target browsers",
    "and directories are different. Otherwise, you will be prompted to select a",
    "new target directory using the tree.",
    "",
    "Use `Meta-F8 Move' to move and rename at the same time.",
    "",
    NULL
};

const char *mkdir_help_text[] = {
    "",
    "MkDir allows you to make a new directory.  An OK/Cancel form is popped up",
    "which has an input field for the new directory's name. If you supply a new",
    "name and confirm, a new directory is made under that name. If the name is not",
    "an absolute pathname, the new directory is made relative to the directory of",
    "the source browser. The current pathname has been provided as a `preselected",
    "default'.",
    "",
    "MkDir is invoked via `F3 MkDir'. Note that all path components but the last ",
    "of the new name must exist in order for success. Use the extended command",
    "`Meta-F3 MkPath' to make a partially or completely new path. For example, ",
    "to create all subdirectories of the new subdirectory tree `./sub0/sub1' at",
    "the same time, it is more efficient to use `MkPath' once, not MkDir twice.",
    "",
    NULL
};

//   01234567879012345678790123456787901234567879012345678790123456787901234567 70

const char *mkpath_help_text[] = {
    "",
    "MkPath, the extended version of MkDir, allows you to make a completely new",
    "directory path. For example, it is possible to create all subdirectories in",
    "the new subdirectory tree `./sub0/sub1' with a single MkPath-command. ",
    "",
    "An OK/Cancel form is popped up which has an input field for the new path name.",
    "If you supply a new name and confirm, a new path is made under that name. If",
    "the name is not an absolute pathname, the new path is made relative to the ",
    "directory of the source browser. The current pathname has been provided as a ",
    "`preselected default'.",
    "",
    "MkPath is invoked via `Meta-F3 MkDir'. Use the normal command `F3 MkDir' to",
    "make ordinary subdirectories. ",
    "",
    NULL
};

const char *duplicate_general_help_text[] = {
    "",
    "Duplicate allows you to make a _local copy_ of a file or group of files.",
    "A question form will be popped up which asks for confirmation. If you ",
    "confirm, all selected files in the source directory will be duplicated.",
    "You will be prompted for a new name for each of these files.",
    "",
    "Duplicate is invoked via `F9 Duplicate' and only works in the source directory.",
    "Use `F10 Copy' to copy files from the source to the target directory, and ",
    "`Meta-F10 Copy' to copy and rename at the same time.",
    "",
    NULL
};

const char *duplicate_help_text[] = {
    "",
    "Duplicate allows you to make a _local copy_ of a file. An OK/Cancel form is",
    "popped up which has an input field for the new name of the copy. If you supply",
    "a new name, the original file is copied to a new file with the new name, ",
    "in the same directory. You will be prompted for confirmation if the duplicate",
    "operation would overwrite an existing file.",
    "",
    "Duplicate is invoked via `F9 Duplicate' and only works in the source directory.",
    "Use `F10 Copy' to copy files from the source to the target directory, and ",
    "`Meta-F10 Copy' to copy and rename at the same time.",
    "",
    NULL
};

const char *deselect_filename_help_text[] = {
    "",
    "The deselect button (pad-minus) allows to deselect a group of files using",
    "shell wildcards. All files whose name matches the wildcard expression given",
    "are deselected (the lines are shown in normal colour). Selections and ",
    "deselections work additively, i.e. files that were deselected before a 2nd",
    "deselection stay deselected. This means you can hand-pick your selection. ",
    "",
    "The current shell wildcards supported are the `*'-character, which matches",
    "anything, and the `?'-character, which matches any single character. Ranges",
    "like `[a-c]' and negated ranges like `[!b-z]' are also supported.",
    "",
    "The deselect function is called by pressing the `minus'-key on the numeric ",
    "keypad. You can also use the middle mouse button or the `Insert'-key to change",
    "the selection status of files. Use the extended `Ctrl-pad-minus'-key to give",
    "deselection expressions that work not only on the file names, but on the",
    "contents of the whole displayed lines. The latter allows to e.g. deselect all",
    "files of owner henrik by using the wildcard expression ` henrik '.",
    "",
    NULL
};    

const char *filter_filename_help_text[] = {
    "",
    "The filter button (pad-star) allows to filter the browser's file display",
    "using shell wildcards. Only files whose names match the wildcard expression",
    "given are let through by the filter and displayed in the browser. For example,",
    "if you want to see only object files, use a file name filter like `*.o'.",
    "Only one filter expression can be active at any given time.",
    "",
    "The current shell wildcards supported are the `*'-character, which matches",
    "anything, and the `?'-character, which matches any single character. Ranges",
    "like `[a-c]' and negated ranges like `[!b-z]' are also supported.",
    "",
    "The filter function is called by pressing the `star' (asterisk) key on the",
    "numeric keypad. Use the extended `Ctrl-pad-star'-key to give filter expres-",
    "sions that work not only on the file names, but on the contents of the whole",
    "displayed lines. The latter allows to e.g. only show directories by using the",
    "wildcard expression `d *'.",
    "",
    NULL
};    

const char *filter_line_help_text[] = {
    "",
    "The `Ctrl'-filter button (pad-star) allows to filter the browser's file list",
    "using shell wildcards. Only full lines who match the wildcard expression",
    "given are let through by the filter and displayed in the browser. For example,",
    "if you want to see only directories, use a line filter like `d *'. Only one",
    "filter expression can be active at any given time.",
    "",
    "The current shell wildcards supported are the `*'-character, which matches",
    "anything, and the `?'-character, which matches any single character. Ranges",
    "like `[a-c]' and negated ranges like `[!b-z]' are also supported.",
    "",
    "The filter by line function is called by pressing the `star'-key on the",
    "numeric keypad together with the `Ctrl'-key. Use the normal `pad-star'-key to",
    "give a filter expression that work only on file names, not lines.",
    "",
    NULL
};    

const char *select_filename_help_text[] = {
    "",
    "The select button (pad-plus) allows to select a group of files using shell",
    "wildcards. All files whose name match the wildcard expression given are",
    "selected (the lines are shown highlighted). Selections and deselections",
    "work additively, i.e. files that were selected before a 2nd selection stay",
    "selected. This means you can hand-pick your selection.",
    "",
    "The current shell wildcards supported are the `*'-character, which matches",
    "anything, and the `?'-character, which matches any single character. Ranges",
    "like `[a-c]' and negated ranges like `[!b-z]' are also supported.",
    "",
    "The select function is called by pressing the `plus'-key on the numeric ",
    "keypad. You can also use the middle mouse button or the `Insert'-key to change",
    "the selection status of files. Use the extended `Ctrl-pad-plus'-key to give",
    "selection expressions that work not only on the file names, but on the",
    "contents of the whole displayed lines. The latter allows to e.g. select all",
    "directories by using the wildcard expression `d *', or by date using e.g.",
    "` May 23 '.",
    "",
    NULL
};    

//   01234567879012345678790123456787901234567879012345678790123456787901234567 70
const char *deselect_line_help_text[] = {
    "",
    "`Ctrl'-deselect button (pad-minus) allows to deselect a group of full lines",
    "in the source browser with shell wildcards. All displayed lines who match the",
    "wildcard expression given by the user are deselected (the lines are shown in",
    "normal colour). Selections and deselections work additively, i.e. files that",
    "were deselected before a 2nd deselection stay deselected. This means you can",
    "hand-pick your selection. ",
    "",
    "The current shell wildcards supported are the `*'-character, which matches",
    "anything, and the `?'-character, which matches any single character. Ranges",
    "like `[a-c]' and negated ranges like `[!b-z]' are also supported.",
    "",
    "The deselect function is called by pressing the `minus'-key on the numeric ",
    "keypad together with the `Ctrl'-key. You can also use the middle mouse button,",
    "the `Insert'-key or the `pad-minus'-key without `Ctrl' to change the selection",
    "status of files. Use the normal `pad-minus'-key to give deselection expressions",
    "that work only on file names, not lines.",
    "",
    NULL
};    

const char *select_line_help_text[] = {
    "",
    "`Ctrl'-select button (pad-plus) allows to select a group of full lines in",
    "the source browser with shell wildcards. All displayed lines who match the",
    "wildcard expression given by the user are selected (the lines are shown in",
    "highlighted colour). For example, you can select all files of owner henrik",
    "by using the full-line wildcard expression ` henrik '.",
    "Selections and deselections work additively, i.e. files that were selected",
    "before a 2nd selection stay selected. This means you can hand-pick your",
    "selection. ",
    "",
    "The current shell wildcards supported are the `*'-character, which matches",
    "anything, and the `?'-character, which matches any single character. Ranges",
    "like `[a-c]' and negated ranges like `[!b-z]' are also supported.",
    "",
    "The select line function is called by pressing the `plus'-key on the numeric ",
    "keypad together with the `Ctrl'-key. You can also use the middle mouse button,",
    "the `Insert'-key or the `pad-plus'-key without `Ctrl' to change the selection",
    "status of files. Use the normal `pad-plus'-key to give selection expressions",
    "that work only on file names, not lines.",
    "",
    NULL
};    

const char *sort_help_text[] = {
    "",
    "The Sorting Options form allows customization of the sort procedure used by",
    "the browsers. The form has two groups of many status buttons. It also has close",
    "and default buttons. All buttons have shortcuts. The shortcuts for the second",
    "group of buttons (labeled `aux. sort by') are the same as for the first, ",
    "except that they require the Control-key to be pressed. The options are changed",
    "for each browser individually. To change them for all browsers, press the",
    "`Sync All'-button to propagate the changes.",
    "",
    "- Description:",
    "  Files in the browser list are sorted in two stages, first via the main or",
    "  primary sort. If the main sort produces a tie, the auxiliary sort criterion",
    "  is used to break the tie. For example, if the main sort is by type, and the",
    "  files compared are all of the same type, the secondary sort, for example",
    "  the names, are used to establish the sort order. ",
    "  The sort options form shows two identical sort control sections, one for",
    "  the main, and one for the auxiliary sort. It is possible to mix any sort",
    "  options together, and to reverse their order. For example, the `Size' sort",
    "  option will normally put smallest files first, but - when reversed - list",
    "  the biggest files first.",
    "  If you want to sort by one criterion only, set the main sort to that cri-",
    "  terion, and set the auxiliary sort to `Name'.",
    "  ",
    "- Special Cases:",
    "  Two special cases were introduced into the sort options after long use of",
    "  the tool. Both affect the `Type' sort option. First, directories are sorted",
    "  before all other types. This allows to have all directories listed on top",
    "  of the browser, which is very convenient. Second, normal files and links",
    "  are given the same order precedence, so that their ordering does not depend",
    "  on the type. This agrees with the common perception of links as real",
    "  `files' in day-to-day use.",
    "  If both the main and auxiliary sorts are not `Name', it is used as implicit",
    "  third sort.",
    "  ",
    "- Factory Defaults:",
    "  Use the `Defaults'-button to restore the sorting factory defaults, which",
    "  are `Type' as main and `Name' as auxiliary sorts.",
    "",
    NULL
};

const char *special_ops_help_text[] = {
    "",
    "These options are a bit special, and won't be used often in normal circum-",
    "stances.",
    "",
    "Focus on startup means that UC will move the mouse pointer and set the focus",
    "to the source browser after it is being started. This is nifty when starting",
    "UC from the command line, because no mouse movement is necessary. However,",
    "if UC is started from an automatic script, it may be undesired to do so.",
    "Therefore, by default, this option is off.",
    "",
    "The special option for copying files is equivalent to the `-p' option for",
    "the Unix cp command. It keeps the access times, permissions, ownership etc.",
    "and other file attributes of the original file when creating the copy. Check",
    "out the cp man page for details.",
    "",
    "The next feature on this form, the ctrl-button timeout counter, allows to",
    "adjust the time the ctrl-button in the toolbox forms takes to flip back to",
    "normal after being pressed. By setting it high, you effectively can trans-",
    "form it into a toggle. However, it is important to note that this has a",
    "global effect for the complete time during which ctrl is switched on, as",
    "if the ctrl-key on the keyboard would be pressed. This can be counter-",
    "intuitive, but was explicitly requested repeatedly by testers. ",
    "",
    "The Browser Auto-Update Frequency defines the number of times per 10 seconds",
    "that UC checks wether a browser directory needs an update. The default of 40",
    "corresponds to 4 checks per second. A setting of 0 means that no automatic",
    "updates take place. This is not recommended unless your server or network",
    "are overloaded.",
    "",
    "To manually force an update, use the browser menu (F2->Actions->Re-Read)",
    "or press `Enter' on the `.'-dot in the browser you want to update.",
    "",
    "The XShell Auto-Update Frequency defines the analog frequency for the xshell.",
    "Setting this to 0 is not recommended unless you experience serious overload",
    "or never type in the xshell.",
    "",
    "You can also set the font size and style used in the UC menus. Please note",
    "that you need to restart UC for these changes to become completely effective.",
    "The tool font feature is experimental. It mainly affects the font used in",
    "the toolbox. You may have to resize the toolbox by hand after changing its",
    "font.",
    "",
    NULL
};

//   01234567879012345678790123456787901234567879012345678790123456787901234567 70
const char *shell_colours_fonts_help_text[] = {
    "",
    "The UCShell is a standard X window terminal emulator tightly coupled to UC.",
    "Therefore, it's appearance can be controlled via X resources. The X class",
    "name for the shell is `XTerm' (`XWsh' on Silicon Graphics systems), and the ",
    "instance name is `UCShell'. So, the UCShell will by default look like your",
    "other window terminal emulators, but can be configured individually if",
    "desired. For example, I have the following lines in my ~/.Xdefaults file:",
    "",
#ifdef SGI    
    "UCShell.background:             black",
    "UCShell.foreground:             white",
    "UCShell*selectionTextColor:     Yellow",
    "UCShell*selectionPageColor:     grey",
    "UCShell*cursorTextColor:        white",
    "UCShell*cursorPageColor:        red",
#else
    "UCShell*background:             black",
    "UCShell*foreground:             white",
#endif    
    "",
    "There will be a more convenient way to adjust shell colours & fonts directly",
    "in a future UC release.",
    "",
    NULL
};    

const char *shell_help_text[] = {
    "",
    "The Shell:",
    "",
    "  The UC shell is like a normal window shell, but integrated into UC. It",
    "  automatically changes directory with the tool, which is especially useful",
    "  in conjunction with the tree. You can type into the shell without changing",
    "  to the shell window (so, no mouse movement is necessary). Any normal alpha-",
    "  numeric characters are transmitted to the shell, and also the important ",
    "  control characters like `ctrl-c' and `ctrl-z'. An `Enter' is transmitted to",
    "  the shell only if there is something typed on the shell command line, ",
    "  otherwise, the enter is used in the browser/tree for activation. You can",
    "  force an `Enter' to be transmitted by using `ctrl-enter' in the browser or",
    "  tree. This can be necessary if you started a program in the shell which ",
    "  requests an `Enter' after processing the command line.",
    "",
    "Selection Forwarding:",
    "",
    "  Use the `alt-f' shortcut to forward the browser selection to the shell. ",
    "  The names of the selected files are forwarded to the shell, separated by",
    "  spaces. If nothing is selected, the name of the current file is taken. This",
    "  shortcut is rather useful, as it allows you to execute any Unix command with",
    "  any leading and/or trailing arguments on the selection.",
    "  ",
    "Caveats:",
    "  ",
    "  - Line length:",
    "  ",
    "  There are a few limitations to the shell. First, command lines cannot be",
    "  longer than 256 characters, due to a very annoying ancient Unix `feature'",
    "  dating back to V7. So, if you transfer large selections, they don't fit. ",
    "  This problem is slightly alleviated by the fact that in this case, only",
    "  the first N fitting names are transmitted. ",
    "  ",
    "  - Changing Directory:",
    "  ",
    "  Another limitation is the way the change directory is handled. When UC",
    "  changes directory, it transmits the new directory string to the shell.",
    "  However, if anything is already typed onto the command line, that will be",
    "  an invalid command line and the backend shell program will _not_ change",
    "  directory. It is possible to erase the command line before changing ",
    "  directory, but that fails in the case where you run a program in the shell",
    "  window. If it doesn't read input, nothing happens, if it does, worse: It",
    "  will read the new directory string as its input ... Of course, it's possible",
    "  to terminate or background any non-backgrounded program running in the shell",
    "  when UC is changing directory, but this can be damaging. It was a design ",
    "  decision to rather forget a change directory than to interrupt a program.",
    "",
    "  The bottom line is, don't run interactive programs (like an editor) in the",
    "  shell. If you need to do so nevertheless, finish them first before going",
#ifdef SUN
    "  back UC, or better, start a new x term  (type: `xterm &') specifically",
#else
    "  back UC, or better, start a new window shell (type: `xwsh &') specifically",
#endif
    "  for them.",
    "",
    "  If you change the shell directory by hand (via the `cd'-command), UC",
    "  changes directory as well (most shells supported, including bash, csh, ",
    "  ksh, pdksh, rc, sh, tcsh and zsh). ",
    "",
    "  - Special Characters:",
    "  ",
    "  The shell was designed to be as compatible to the normal shells as possible.",
    "  Therefore, only the function keys (especially F1 Help) are supported if the",
    "  mouse pointer is _within_ the shell window. All other special keys, like ",
    "  the arrow keys or `Ctrl-t', are forwarded to the shell and DON'T have their",
    "  normal function. This is so that programs with weird input requirements ",
    "  running in the shell can still be used (providing their input from the tree",
    "  or browsers would fail in some special cases like `Ctrl-t', but you now can",
    "  just move the mouse pointer into the shell window). This is rather a kludge.",
    "",
    NULL
};

const char *timeout_help_text[] = {
    "",
    "Timeout Form:",
    "  ",
    "  This form has two counters on it which allow you to set the operation",
    "  timeouts UC uses when accessing files. This is a necessity if you want",
    "  UC to access a file or directory that is not available (a NFS server",
    "  might be down, or an AFS link stale). You want to be able to continue",
    "  working under such circumstances. For this purpose, use the counter for",
    "  `Single File Read Timeout'.",
    "  Additionally, as a convenience, there also is a `Directory Timeout'. This",
    "  is useful if for example you repeatedly step through directories with many",
    "  thousands of entries. Here, always getting the full information of every",
    "  single file is worth avoiding if you are in a hurry.",
    "  ",
    "",
    NULL
};

const char *fkeybar_help_text[] = {
    "  ",
    "The Function Keybar:",
    "  ",
    "  The function keybar is a fully functional visual keyboard. Its layout resembles",
    "  the 3 groups of four function keys. To access a normal function with the mouse, ",
    "  click on it's button in the box. To access the ",
    "  extended functions (usually invoked by also pressing the `Ctrl'-key), press",
    "  the `Ctrl off'-lightbutton in the tool box. It will switch to `Ctrl On',",
    "  and the tool box layout changes to show the extended functions. Then, just ",
    "  press one of the normal buttons within the tool box to invoke them. If you",
    "  don't select an extended function within 2 seconds, then the `Ctrl'-light-",
    "  button will switch back to `Ctrl off'. ",
    "  ",
    "Summary of Keybar Functions:",
    "  ",
    "  1. `Ctrl' in `off' position:",
    "  ",
    "    - F1:  local context-sensitive help (i.e. THIS help, in this case);",
    "    - F2:  local context-sensitive menu, defaulting to the browser menu,",
    "           as there is no toolbox-specific menu;",
    "    - F3:  make a new directory, absolute or relative to source directory;",
    "    - F4:  show a directory tree (very useful for file system navigation);",
    "    - F5:  edit the current file in UC's built-in Emacs-like editor;",
    "    - F6:  edit current/selected file(s) each in the default editor;",
    "    - F7:  rename current/selected file(s) in the source directory;",
    "    - F8:  move current/selected file(s) from source to target directory;",
    "    - F9:  duplicate current/selected file(s) in the source directory;",
    "    - F10: copy current/selected file(s) from source to target directory;",
#ifdef DEC_ALPHA
    "    - F13: delete current/selected file(s) in the source directory; this",
    "           would normally be F11, but the Alpha console uses F11 for escape.",
#else
    "    - F11: delete current/selected file(s) in the source directory;",
#endif
    "    - F12: exit the tool.",
    "  ",
    "  2. `Ctrl' in `On' position:",
    "  ",
    "    - F1:  global help;",
    "    - F2:  global options;",
    "    - F3:  make a new path (a new directory with multiple new components);",
    "    - F6:  edit file(s) _all together_ in the default editor;",
    "    - F8:  move _and_ rename file(s) from source to target directory;",
    "    - F10: copy _and_ rename file(s) from source to target directory;",
    "    - F12: fast exit the tool, no questions asked.",
    "  ",
    "  For most functions, there is more online help available if you execute",
    "  them and then use the `F1' key.",
    "  ",
    "",
    NULL
};

const char *toolbox_help_text[] = {
    "",
    "The Tool Box:",
    "  ",
    "  The tool box is a fully functional visual keyboard. Its layout resembles",
    "  the keyboard's numerical keypad and the 3 groups of four function keys, to",
    "  make it easier for you to learn the keyboard shortcuts. To access a normal",
    "  function with the mouse, click on it's button in the box. To access the ",
    "  extended functions (usually invoked by also pressing the `Ctrl'-key), press",
    "  the `Ctrl off'-lightbutton in the tool box. It will switch to `Ctrl On',",
    "  and the tool box layout changes to show the extended functions. Then, just ",
    "  press one of the normal buttons within the tool box to invoke them. If you",
    "  don't select an extended function within 2 seconds, then the `Ctrl'-light-",
    "  button will switch back to `Ctrl off'. ",
    "  ",
    "Summary of Tool Box Functions:",
    "  ",
    "  1. `Ctrl' in `off' position:",
    "  ",
    "  1.1 Function Keys (ctrl off):",
    "  ",
    "    - F1:  local context-sensitive help (i.e. THIS help, in this case);",
    "    - F2:  local context-sensitive menu, defaulting to the browser menu,",
    "           as there is no toolbox-specific menu;",
    "    - F3:  make a new directory, absolute or relative to source directory;",
    "    - F4:  show a directory tree (very useful for file system navigation);",
    "    - F5:  edit the current file in UC's built-in Emacs-like editor;",
    "    - F6:  edit current/selected file(s) each in the default editor;",
    "    - F7:  rename current/selected file(s) in the source directory;",
    "    - F8:  move current/selected file(s) from source to target directory;",
    "    - F9:  duplicate current/selected file(s) in the source directory;",
    "    - F10: copy current/selected file(s) from source to target directory;",
#ifdef DEC_ALPHA
    "    - F13: delete current/selected file(s) in the source directory; this",
    "           would normally be F11, but the Alpha console uses F11 for escape.",
#else
    "    - F11: delete current/selected file(s) in the source directory;",
#endif
    "    - F12: exit the tool.",
    "  ",
    "  1.2 Keypad (ctrl off):",
    "  ",
    "    - Enter:        view normal file, launch executable, change to directory;",
    "    - `+':          give shell wildcard file name selection expression;",
    "    - `-':          give shell wildcard file name DEselection expression;",
    "    - `*':          give shell wildcard file filter selection expression,",
    "                    only matching files will be shown in the browser;",
    "    - `/':          force a re-read of the current dir (rarely necessary);",
    "  ",
    "    - 0/Insert:     toggle the selection of current file, step (up or down);",
    "    - 1/End:        scroll to the last line;",
    "    - 2/DownArrow:  scroll line down;",
    "    - 3/PgDn:       scroll page down;",
    "    - 4/LeftArrow:  change to parent directory;",
    "    - 5/circle:     center the current line if it is offcenter;",
    "    - 6/RightArrow: if current file is directory, change to it, otherwise,",
    "                    search for closest file in listing that is a directory;",
    "    - 7/Home:       scroll to the first line;",
    "    - 8/UpArrow:    scroll line up;",
    "    - 9/PgUp:       scroll page up.",
    "  ",
    "  2. `Ctrl' in `On' position:",
    "  ",
    "  2.1 Function Keys (ctrl on):",
    "  ",
    "    - F1:  global help;",
    "    - F2:  global options;",
    "    - F3:  make a new path (a new directory with multiple new components);",
    "    - F6:  edit file(s) _all together_ in the default editor;",
    "    - F8:  move _and_ rename file(s) from source to target directory;",
    "    - F10: copy _and_ rename file(s) from source to target directory;",
    "    - F12: fast exit the tool, no questions asked.",
    "  ",
    "  2.2 Keypad (ctrl on):",
    "  ",
    "    - Enter:        unconditionally forward an `Enter' to the UCShell, this",
    "                    can be necessary when an application wants an `Enter';",
    "    - `+':          give wildcard for full line selection expression. All",
    "                    matching LINES, and not file NAMES, will be selected;",
    "    - `-':          give wildcard for full line, not only file name DEsel.;",
    "    - `*':          give wildcard for full line filter selection expression;",
    "    - `/':          force a re-read of all browser dirs (rarely necessary);",
    "  ",
    "    - 5/`T':        equivalent `Ctrl-t', set current browser to target;",
    "    - 7/`H':        change to home directory.",
    "  ",
    "  For most functions, there is more online help available if you execute",
    "  them and then use the `F1' key.",
    "  ",
    "",
    NULL
};
    
const char *status_help_text[] = {
    "",
    "The status messages window is a little utility in which UC displays various",
    "messages about its current operations. It is intended as an extra orientation",
    "help especially for the new user. Use `Escape-q' or the window manager's `close'",
    "function to hide it. You can switch it back on via its button on the global",
    "options form (`Meta-F2'). ",
    "",
    NULL
};

const char *tree_colour_help_text[] = {
    "",
    "Use this form to change all colours in the UC tree. You can either select a",
    "predefined colour scheme, or adjust each colour individually by pressing it's",
    "colour button.",
    "",
    NULL
};

const char *tree_help_text[] = {
    "",
    "Overview:",
    "",
    "  The Cockpit Tree is a powerful tool that visualizes the directory hierarchy",
//   01234567879012345678790123456787901234567879012345678790123456787901234567 70
    "  of your filesystem. You can walk the around the tree with the keyboard or",
    "  mouse. Change to a new directory for the source browser with the `Enter'-",
    "  key or a left mouse double click, and set a new target directory with",
    "  `Ctrl-t' (source and target directories are visualized via little green",
    "  and yellow lights). Expand a tree branch for one level with a middle mouse",
    "  click or the grey keypad `+' button. Collapse (hide) the last level of a ",
    "  branch with a right mouse click or the keypad `-'. Use this together with",
    "  `Ctrl' to expand/collapse all sublevels of the branch.",
    "  Cycle through the browsers with `Tab' & `Shift-Tab', as usual. Note that",
    "  the tree has a menu that you can activate via the `F2 Options'-key, or by",
    "  clicking the mouse in the tree background. The tree is coupled to the UC",
    "  shell similarly to the browsers, which makes a very fast `Shell & Tree'-",
    "  mode of operation possible.",
    "  As an extra scrolling goodie, you can hold down the left mouse button to",
    "  `shove' the tree around (a little hand cursor will appear).",
    "",
    "  All function keys (F1-F12) work in the tree, with the normal meanings",
    "  (move, copy, etc.) adapted to the tree.",
    "",
    "Navigation and Scrolling:",
    "",
    "  An important characteristic of the tree is that the highlighted, or `current',",
    "  node in the tree is not synchronized with the browsers. This means that you",
    "  can move it freely without the source browser changing directory (the reason",
    "  for this is that rereading of directories is far too time consuming when you",
    "  navigate the tree quickly). The tradeoff for this speed is that you need to",
    "  press `Enter', or double-click the mouse, in order for the source browser to",
    "  synchronize and change directory to the directory of the current node in the",
    "  tree.",
    "  You can use the arrow, pageup/down and home/end keys to navigate around. The",
    "  mouse, sliders and buttons also work. It is by far the easiest to learn the",
    "  navigation commands by using them, so you are encouraged to experiment and",
    "  just roam around your file system a little bit. ",
    "  ",
    "  Here's a list of keyboard shortcuts and their associated navigation actions:",
    "  ",
    "  Keyboard:                               Go to, or do:",
    "  ",
    "  left arrow, pad left arrow, Ctrl-b:     parent dir;",
    "  right arrow, pad right arrow, Ctrl-f:   first subdir, if none, down;",
    "  down arrow, pad down arrow, Ctrl-n:     next subdir, if none, one step down;",
    "  up arrow, pad up arrow, Ctrl-p:         previous subdir, if none, a step up;",
    "  Home, pad Home, Alt-<,Ctrl-a:           root dir (/);",
    "  End, pad End, Alt->, Ctrl-e:            last dir in tree;",
    "  pad-5, Ctrl-l:                          center current;",
    "  PageUp, pad PgUp, Alt-v:                step a full page up;",
    "  PageDown, pad PgDn, Ctrl-v:             step a full page down;",
    "  ",
    "  These actions can be extended with the control key:",
    "  ",
    "  Ctrl-left arrow, Ctrl-pad left arrow:   first parent dir on same `height';",
    "  Ctrl-right arrow, Ctrl-pad right arrow: last subdir on same `height';",
    "  Ctrl-down arrow, Ctrl-pad down arrow:   last subdir, if none, a step down;",
    "  Ctrl-up arrow, Ctrl-pad up arrow:       first subdir, if none, a step up;",
    "  Ctrl-Home, Ctrl-pad Home:               change to home directory;",
    "  Ctrl-PageUp, Ctrl-pad PgUp:             go to top of column;",
    "  Ctrl-PageDown, Ctrl-pad PgDn:           go to last in column;",
    "  ",
    "  You're again advised to just try them out.",
    "",
    "",
    "Collapsing and Expanding:",
    "",
    "  A complete tree of a large file system is unhandy. Therefore, UC supports",
    "  methods to cut and grow the tree reflecting each users preferences. By",
    "  default, when invoked for the first time, the paths of all browser dir's",
    "  are shown, with a few subbranches added. You can then add new or remove",
    "  existing branches, which leaves you with a custom tree structure that is",
    "  stored in a tree data base in your home/.uc directory (you'll be prompted",
    "  to store any changes made to the tree when exiting UC, and you can also",
    "  save the data base explicitly via F2-Database-Save).",
    "",
    "  Collapsing (cutting branches) and expanding (adding branches) usually work",
    "  relative to the current node of the tree, and affect only its particular",
    "  subtree. Thus, e.g. choosing the `Expand subtree +1 level' menu option will",
    "  add all subdirectories (but not their children yet) of the current node to",
    "  the tree. If you directly repeat this operation, all the subdirectories of",
    "  all the first subdirectories will be added, and so on. This is particularly",
    "  handy when used with the keyboard shortcut for expansion, the keypad `Plus'",
    "  key. Using `Plus' together with `Ctrl' expands the whole branch.",
    "",
    "  There is an important peculiarity here, if the current node that you are ",
    "  expanding already has visible children in the tree. In this case, expanding",
    "  a level will _not_ add a new level to the (visually right-) most children",
    "  at the bottom of this subtree. Rather, the first expansion _rescans_ the",
    "  first subdirectories, erasing invalid ones and adding new ones, the second",
    "  expansion rescans the subdirectories of the first subdirectories, and so",
    "  on. If you want to add a level to the bottom of the tree, go there directly.",
    "  You can also completely expand a subtree by using the `Ctrl-+' shortcut, or",
    "  via the `Expand subtree all levels' menu option. Note that expansion is an",
    "  expensive operation, and takes time !",
    "  ",
    "  Collapsing is the mirror operation to expansion. Like expansion, it is much",
    "  easier to understand by trying it out, so please do so. Note that collapsing",
    "  is fast, while expansion is not. Shortcuts for collapse are the pad minus key",
    "  and the right mouse button. `Ctrl-Minus' collapses the whole branch.",
    "",
    "",
    "Verification:",
    "  ",
    "  UC attempts to maintain reasonable consistency in its tree database. This",
    "  means that what you see is usually really there. (Note that you don't see ",
    "  ALL that is there except if you explicitly ask for it by fully expanding",
    "  the root directory - which is slow :-). The consistency checker will not",
    "  allow you to e.g. walk into/change into a directory that doesn't exist.",
    "  However, because monitoring large file systems is very expensive, it is",
    "  nevertheless possible that you'll sometimes see a node in the tree that",
    "  doesn't really exist anymore on the discs. In that case, either step on",
    "  it (which will check), or run `Verify' on the subtree that contains it.",
    "  Verify is available in the `Options'-submenu of the tree menu (F2).",
    "  Verify is a medium expensive operation, taking roughly 20-30 seconds for",
    "  each GigaByte of used disc space. It is good practice to run it after",
    "  restarting the tool (if the tree isn't too big), or before saving the",
    "  database.",
    "",
    "Search Mode:",
    "",
    "  Use `Ctrl-s' for searching. Type your search string, and the first matching",
    "  directory will be shown. Use `Escape' to cancel the search. This will restore",
    "  the node in the tree that was current before the search. Use `Enter' to set",
    "  the newly found node current. While in search mode (i.e. the search text is",
    "  visible), you can use `Ctrl-s' to search again for the current search text. ",
    "",
    "  After finishing search mode with an `Enter', you can - as usual - press ",
    "  `Enter' again to actually do the change directory for the source browser.",
    "  Note that you can start your search string with the `*'-character. This is",
    "  useful for searching of name parts other than beginnings.",
    "",
    "Setting target:",
    "",
    "  Use `Ctrl-t' for set target. The function is slightly altered compared to",
    "  the version used in the browsers, due to the asynchronicity between tree",
    "  and browser. In the tree, pressing `Ctrl-t' results in the _target browser_,",
    "  and _not_ the source browser, changing to the current node's directory. This",
    "  extension makes life a bit easier (in most cases) where one wants to set ",
    "  target within the tree.",
    "  As in the browsers, `Ctrl-Keypad5' is equivalent to `Ctrl-t'.",
    "",
    "Fast Browser Focus:",
    "",
    "  Suppose you want to rapidly switch back and forth between the browser and",
    "  the tree. You could open and close the tree all the time, but that is slow.",
    "  It is better to use `Ctrl-1' (or 2,3,etc) which sets the browser of that ID",
    "  source and puts the focus (& mouse pointer) into that window. Press F4 Tree",
    "  to jump back into the tree. ",
    "",
    NULL
};

const char *tree_copy_help_text[] = {
    "Tree Copy allows you to copy a whole directory tree to a new location.",
    "",
    NULL
};

const char *tree_delete_help_text[] = {
    "Tree Delete allows you to delete a whole directory tree.",
    "",
    NULL
};

const char *tree_duplicate_help_text[] = {
    "Tree Copy allows you to copy a whole directory tree, with a new name.",
    "",
    NULL
};


const char *tree_mkdir_help_text[] = {
    "",
    "TreeMkDir allows you to make a new directory.  An OK/Cancel form is shown",
    "which has an input field for the new directory's name. If you supply a new",
    "name and confirm, a new directory is made under that name. If the name is not",
    "an absolute pathname, the new directory is made relative to the directory of",
    "the current node in the tree, NOT relative to the source browser as it would",
    "normally be the case. The pathname has been provided as a `preselected",
    "default'.",
    "",
    "TreeMkDir is invoked via `F3 MkDir' while being in the tree window. Note that",
    "all path components but the last of the new name must exist in order for ",
    "success.",
/*
Use the extended command",
    "`Meta-F3 MkPath' to make a partially or completely new path. For example, ",
    "to create all subdirectories of the new subdirectory tree `./sub0/sub1' at",
    "the same time, it is more efficient to use `MkPath' once, not MkDir twice.",
    */
    "",
    NULL
};

const char *tree_move_help_text[] = {
    "",
    "TreeMove allows you to move the current directory in the tree.  An",
    "OK/Cancel form is shown which has an input field for the new location.",
    "The target browser directory has been provided as a `preselected default'.",
    "It is not necessary, but good practice, to change the target browser",
    "to the desired target directory in advance. Otherwise, type the ",
    "directory in.",
    "",
    "TreeMove is invoked via `F8 Move' while being in the tree window. Note",
    "that the move won't work across different file systems.",
    "",
    NULL
};

const char *tree_rename_help_text[] = {
    "",
    "TreeRename allows you to rename the current directory in the tree.  An",
    "OK/Cancel form is shown which has an input field for the new name. The",
    "current name has been provided as a `preselected default'.",
    "",
    "TreeRename is invoked via `F7 Rename' while being in the tree window. Note ",
    "that the new name may not contain any slashes (`/'), and the move won't",
    "work across different file systems.",
    "",
    NULL
};

const char *browser_search_help_text[] = {
    "",
    "Browser Search Mode:",
    "",
    "  The search mode is activated via `Ctrl-s'. Type your search string, and the",
    "  first matching file will be shown. Use `Escape' to cancel the search. This",
    "  will restore the current line in the source browser that was current before",
    "  the search. Use `Enter' to keep the newly found file as the current. While",
    "  in search mode (i.e. the search text is visible), you can use `Ctrl-s' to",
    "  search again for the current search text.",
    "  Note that you can start your search string with the `*'-character. This is",
    "  useful for searching of name parts other than beginnings (i.e. extensions.",
    "  like `*.gz').",
    "",
    NULL
};

const char *tree_search_help_text[] = {
    "",
    "Tree Search Mode:",
    "",
    "  The search mode is activated via `Ctrl-s'. Type your search string, and the",
    "  first matching directory will be shown. Use `Escape' to cancel the search.",
    "  This will restore the node in the tree that was current before the search.",
    "  Use `Enter' to set the newly found node current. While in search mode (i.e.",
    "  the search text is visible), you can use `Ctrl-s' to search again for the",
    "  current search text. ",
    "",
    "  After finishing search mode with an `Enter', you can - as usually - press ",
    "  `Enter' again to actually do the change directory for the source browser.",
    "  Note that you can start your search string with the `*'-character. This is",
    "  useful for searching of name parts other than beginnings.",
    "",
    NULL
};

const char *tree_target_mode_help_text[] = {
    "",
    "Tree Select New Target Mode:",
    "",
    "  The tree can be used to select a target directory for binary operations",
    "  like copy or move. It is popped up by default if the source and target ",
    "  directories are the same when such an operation is invoked, otherwise only",
    "  if you choose `New Target ...' explicitly. You can navigate the tree as",
    "  usual, but if you select (via the mouse, or via `Enter') a directory, the",
    "  tree immediately returns this selection as the new target directory for the",
    "  operation.",
    "  ",
    "  Note that if you have only one browser open, you will always be prompted to",
    "  supply a target directory for binary operations.",
    "",
    NULL
};
    

const char *info_overview[] = {
    "",
    "Overview:",
    "",
    "The Unix Cockpit is a general purpose file/work managing tool designed to make",
    "working with Unix easier, faster and more enjoyable for you. First, it is",
    "intended to make the day-to-day file operations like moving and copying as",
    "simple, safe and fast as possible. Next, advanced features for more experienced",
    "users or system administrators are provided. Last not least, it was tried to",
    "stay upward compatible to the standard Unix shells by integrating them intuitively",
    "into the system.",
    "In contrast to mouse-only based tools, UC was deliberately designed to work very",
    "quickly and conveniently with the keyboard/shell in addition to the mouse. It is",
    "hoped that it is relatively obvious how to use it, and therefore that this",
    "documentation is mostly redundant or for reference only. ",
    "You are encouraged to explore (it is useful and very recommended to create a ",
    "subdirectory of garbage files and directories for that purpose). Still, in ",
    "order to take full advantage of your cockpit instruments, and also to avoid",
    "surprises with its powerful operations, it's not a waste of time to read on.",
    "",
    "Browsers:",
    "",
    "The first key component of UC are file browser windows, or browsers. They",
    "display a sorted and formatted list of files or view into a directory, which",
    "can be completely customized in size, colour, font, display, filtering and",
    "sorting options. They also have a menu for your own custom operations.",
    "",
    "- The Source Browser",
    "",
//   01234567879012345678790123456787901234567879012345678790123456787901234567 70
    "An UC session has at least one browser open at any given time, but typically",
    "has several. Exactly one browser is designated the _source_ browser, which",
    "means unary actions like selecting or removing files take place within it and",
    "its associated directory. ",
    "The source browser has the string `Source' in its window title, and also has",
    "a visible `current line' that can be moved with the arrow keys. To make any",
    "particular browser source, just press a mouse button within it, or use the ",
    "tab/shift-tab keys to cycle between the browsers.",
    "",
    "- The Target Browser",
    "",
    "Another browser (which can be the same as the source browser, allthough that",
    "is not particularly useful) is called the _target_ browser, which is used as",
    "target for binary operations like `copy from dir A to dir B' (the binary",
    "operations require a source and target directory). Note that if source and",
    "target directories _or_ browsers are identical, you will be prompted to supply",
    "a new target directory.",
    "To make a browser the target, select `set target' from its browser menu, which",
    "you can get by pressing the right mouse button in its window. You can also use",
    "the `5'-key on the numerical keypad or the `Ctrl-t' shortcut. If you have just",
    "two browsers open, UC automagically sets the target browser to the non-source",
    "browser.",
    "The remaining browsers in the system are called passive, and don't influence",
    "current operations until they become source or target again.",
    "",
    "Tree:",
    "",
    "The second key component of UC is the directory tree. You can use it to",
    "visualize your file system, change directory, or select new target directories",
    "for binary operations. ",
    "",
    "Shell:"
    "",
    "The third component is the UC shell. It is much like a standard window shell,",
    "except that it changes directory together with the other components. ",
    "",
    "How General Operations Work:",
    "",
#ifdef DEC_ALPHA
    "Let's start with a word of warning, mostly about the `F13 Delete'-button: As",
#else
    "Let's start with a word of warning, mostly about the `F11 Delete'-button: As",
#endif
    "Unix is a powerful tool, so is the Un*x Cockpit, and for example recursive",
    "removal of directory trees does quick and extensive damage to your data, if",
    "you don't know what you are doing (or type ahead very quickly). So, handle",
    "all `overwrite' or `delete' questions and operations with care. The author",
    "and the company give you no warranty against you removing your own data.",
    "However, it was tried to make these kind of accidents unlikely.",
    "As a consequence, all the operations like `move' or `copy' were implemented",
    "to have the same behaviour as their Unix originals. UC usually asks for",
    "explicit confirmation from you before overwriting files, removing files,",
    "working on groups of files and/or directories, etc.",
    "",
    "Typically, a desired operation like `copy' can be activated both via a",
    "keyboard shortcut - usually a function key or numerical keypad key - and",
    "via the mouse. For the latter purpose, a toolbox window with function key",
    "buttons (which can be operated by a mouse click) is provided. Most of the",
    "operations can work on single files and/or groups of selected (highlighted)",
    "files. If no files are selected, the operation takes the file given in the",
    "current line of the source browser as its input. If several files are ",
    "selected, either via the mouse or via a selection expression, the operation",
    "works on all of them, one after another.",
    "Operations usually ask for confirmation before they execute anything.",
    "Confirmation is given via the mouse or by hitting the enter key, while",
    "cancelling works best via the `Escape' key. Note that operations give you",
    "detailed information about their status while they execute.",
    "All operations can be interrupted via `Escape'. This will only affect the",
    "files that have not been worked upon, however. Be aware that you are being",
    "asked ONCE for an operation that potentially affects MANY selected files.",
    "",
    "Changing Directories",
    "",
    "Position the current line on the directory you want to change into, and press",
    "enter or the right arrow key. To go up one level, press enter while being on",
    "the parent directory entry (`..'), or press the `left arrow'-key. Another",
    "useful shortcut is `ctrl' with the `Home'-key, which changes straight into",
    "the home directory.",
    "An extra option to change directory is the directory tree invoked via `F4'.",
    "",
    "",
    NULL
};

const char *info_managing_selections[] = {
    "",
    "Managing Selections", 
    "",
    "Selections - i.e. a group of files in a browser that are specially",
    "marked or selected for action - are a key feature that allow to use",
    "UC efficiently. This is because actions like copying or removing",
    "can be performed on all selected files at once, and don't need to be",
    "specified and re-specified ad nauseam for each individual file. Also,",
    "UC has an interface to the standard Unix `make' program, which allows",
    "to execute any action that can be specified in a makefile upon the",
    "selection (see the F2 browser menu and the file ~/.uc/ucmk for",
    "examples).",
    "",
    "Usually, no files are selected, and actions work on the current file",
    "which is indicated by the position of the current bar. This is much",
    "the same as if exactly that and only that file were selected. With",
    "the mouse or the `+' and `-' keys on the keypad, however, it becomes ",
    "possible to assemble large selections quickly. As an example, selecting",
    "all files that start with a capital `A' can be done by entering `A*' as",
    "an selection expression after pressing the `Select'-Button. All",
    "selected files are usually shown in a highlighted colour, although",
    "this can vary if you customize the colours in a non-standard way.",
    "You can perform a sequence of selections/deselections, which is ",
    "very handy. For example, you can select all files via `*', and then",
    "deselect all files starting with a `b' via `b*', leaving you with all",
    "files but the `b*'-types selected.",
    "",
    "Selections can also be performed via the middle mouse button, which ",
    "toggles the selection status of the file pointed to from on to off",
    "or vice versa. By holding the middle mouse button down and dragging",
    "downwards, the selection status of a whole group of files can be ",
    "toggled simultaneously.",
    "",
    "Finally, the current file's selection status can be toggled by using ",
    "the `Insert'- or `0'-button on the numeric keypad. After toggling, the",
    "current line is moved downwards by one step. Use `Ctrl-Insert' to toggle",
    "the selection status of all files.",
    "",
    "Notes: ",
    "- the selection/deselection operations don't support full regular",
    "  expressions. Most users understand the simple wildcard notation",
    "  employed here, but get very confused about full regexp's.",
    "- the current directory `.' and the parent directory `..' are never",
    "  selected. If you really want to perform an action on them, you ",
    "  have to use the current bar.",
    "- the simple matching operation performed by `Select'/`Deselect' ",
    "  does match files with the expression `*', even if the file names",
    "  start with a leading `.', which can be different in Unix shells.",
    "",
    NULL
};

const char *info_unary_operations[] = {
    "",
    "Unary Operations:",
    "",
    "Unary operations are operations that only affect the currently ",
    "source browser and the files in its associated directory. ",
#ifdef DEC_ALPHA
    "The most important unary operations are F13 Delete and F9 Duplicate.",
#else
    "The most important unary operations are F11 Delete and F9 Duplicate.",
#endif
    "",
    "F9 Duplicate allows to duplicate the selected files. For each file, ",
    "you will be asked for a new name. The file gets duplicated to that",
    "new name, if no file of that file exists. Otherwise, you'll be asked",
    "to confirm removal of the old file with the new name. Duplicate can",
    "duplicate whole directory trees with no problems, although that may",
    "take a while for large trees, depending on filesystem throughput.",
    "",
#ifdef DEC_ALPHA
    "F13 Delete allows to remove selected groups of files or directories.",
#else
    "F11 Delete allows to remove selected groups of files or directories.",
#endif
    "Be warned that removal in general, and recursive removal of directories",
    "in particular, is a rather powerful",
    "and irreversible operation. So, make sure you really want to remove",
    "the data, and/or have them on backup media. The Unix Cockpit does allow",
    "you to",
    "interrupt a remove operation while it is proceeding, but cannot undo",
    "the removals that took place until the interruption. ",
    "A simple strategy for you to counter the `remove blues' is to avoid",
#ifdef DEC_ALPHA
    "the F13 Delete function, and to use the F8 Move function to move  ",
#else
    "the F11 Delete function, and to use the F8 Move function to move  ",
#endif
    "unwanted files into a `wastebasket' directory. You can then examine ",
    "your wastebasket e.g. at the end of a working day, and then make ",
    "final remove decisions. Note that this strategy becomes unhandy if",
    "work is performed over filesystem boundaries, because then a move to",
    "the wastebasket needs to be a copy operation, which takes long, can",
    "fail, etc. It may be supported in a future release, if we get it ",
    "satisfactorily stable.",
    "",
    "",
    NULL
};

const char *info_binary_operations[] = {
    "",
    "Binary (Source-to-Target) Operations:",
    "",
    "",
    "",
    NULL
};

const char *new_user_info[] = {
    "",
    "Introduction for New Users",
    "",
    "You have started this program, the Unix Cockpit (UC), without having a",
    "configuration database (neither in $HOME/.uc nor /usr/local/lib/uc). ",
    "Therefore, UC assumes that you are a new user and gives you a quick",
    "introduction here. Please read this.",
    "",
    "First, there are a few keys worth to remember, because they work practi-",
    "cally anywhere:",
    "",
    "@C1Enter:",
    "           Confirm current operation, say `yes' to a question, activate,",
    "           a file. Shortcut for any button that shows the `Enter-arrow',",
    "           like the `Close'-button in the bottom left of this window.",
    "           ",
    "@C1Escape:",
    "           Cancel current operation, say `no' to a question, interrupt.",
    "           Shortcut for any `Cancel'-button. Also, close a popup window.",
    "           For example, _this_ window can be closed using `Escape'.",
    "           More \"durable\" :-) windows, like an editor window or the tree,",
    "           can be closed with `Escape-q', for `quit'.",
    "           ",
    "@C1F1:",
    "           Context-sensitive help, tailored to UC's current situation.",
    "           For example, if you haven't tied the F1 key to a window manager",
    "           function, press F1 RIGHT NOW to get a help window that",
    "           explains how to scroll around in this browser. Do this to",
    "           familiarize yourself with the scroll commands, as they are ",
    "           always the same and used everywhere in the tool.",
    "           ",
    "Note: In the following, `Meta'-F1 means any one of the combinations",
    "`Ctrl'-F1 and `Alt'-F1. UC supports both modifiers (Alternate and",
    "Control) internally. The reason for this is that window managers like",	
    "fvwm tend to attach special meanings to the function key combinations.",
    "So, if your WM eats Ctrl-function keys, use alt and vice versa. If",
    "your WM eats Ctrl AND Alt, use the mouse on UC's function key bar window",
    "together with Ctrl on the keyboard. As a last resort, you can use",
    "also try `Escape' as a replacement for `Ctrl' and `Alt' in the tree,",
    "the browsers and the editors.",
    "           ",
    "           ",
    "@C1Meta-F1:",
    "           General help, with options for more specific information.",
    "           Again, you're advised to do this once straightaway. Just",
    "           open up the global help window and close it again (or click.",
    "           on `Introduction' to get back to this help window).",
    "           ",
    "@C1F12:",
    "           Exit the program normally, which includes confirming the",
    "           exit and possibly (depending on the configuration), the",
    "           saving of UC's configuration to its database file in your",
    "           home/.uc directory. Press F12 now and choose `Cancel' from",
    "           the dialog box in order to continue.",
    "           ",
    "@C1Meta-F12:  ",
    "           Force an unconditional, immediate exit. Use this if you get",
    "           lost. If any operation is in progress, you may need to press",
    "           `Escape' first, to stop the operation. Don't do this right",
    "           now :-).",
    "           ",
    "",
    "As you notice, the Ctrl- and Alt-keys are used to extend the functionality",
    "of the normal keys. This feature is used a lot in the tool. Another useful",
    "thing to know is that many forms have specific options, which can be ",
    "invoked as follows:",
    "",
    "@C1F2:",
    "           Context-sensitive options menu or form (e.g., which fonts or",
    "           colours to use in that particular form). Press F2 for the font",
    "           options of this help viewer, then Escape to get back.",
    "",
    "           Within the browsers, editors and the tree, you can also use",
    "           the right mouse button to get the context menu.",
    "",
    "@C1Meta-F2:",
    "           General options for the whole tool (e.g., which default editor",
    "           to use). Again, try this straight away, then hide it again.",
    "",
    "@C1Arrow Keys:",
    "Next, just note that the arrow keys also work practically everywhere, ",
    "even within menus. They are also useful for switching of the default",
    "return button. For example, press the rightarrow key NOW and observe",
    "what happens to the buttons in the lower left corner of this form.",
    "",
    "@C1Critical Sections and Lock-Up:",
    "Those popup windows that have no window frames (like dialogs or menus)",
    "usually require an action from you and freeze the other UC windows. You",
    "need to deal with them (by answering the question, or making a selection",
    "from the menu, etc) before you can continue working as usual.",
    "",
    "UC has two features, AutoMouse and AutoRaise, that can be very annoying",
    "to the new user, but are tremendously useful once you are accustomed to",
    "them (AutoMouse moves the mouse pointer to the window/button of interest,",
    "AutoRaise winpops the source browser when it is set). Switch them on/off",
    "in the global options section (`Meta-F2'), and save the configuration, if",
    "you don't like them.",
    "",
    "Final Note:",
    "The best way to learn UC is to go exploring. You are encouraged to press",
    "all the buttons - but preferably on junk files, and after you made a full",
    "backup ! Be careful with your data. If you have the time, do at least the",
    "first parts of the online tutorial (a tutorial button is on bottom of this",
    "form, and on `Meta-F1' Global Help if you need it later).",
    "",
    "Unix Cockpit is Open Source. It took the better part of the last couple of",
    "years to write, so if you like the program, feel free to drop me a line.",
    "",
    "Good luck and lots of fun,",
    "   Henrik Klagges (henrik@klagges.com)",
    "",
    NULL
};

const char *other_environment[] = {
    "",
    "Environment and Default Settings:",
    "",
    NULL
};

const char *other_acks[] = {
    "",
    "UC ran first as a rudimentary system on SGI Irix 3.2.1 in 1991. The tool",
    "was rewritten from scratch twice and is now completely coded in 55000 lines/",
    "1.6MB of C++. The professional release 1.0 for SGI GL has been shipping",
    "since September 1994. Since then, I ported the program to generic X11. The",
    "SGI GL version was discontinued and replaced by the SGI-X11 1.0 Pro release",
    "in December 1994. Then I ported UC to SunOS, Solaris, Linux, DEC Alpha",
    "OSF1, HP-UX, FreeBSD and IBM AIX in January '95. Further Unixes followed.", 
    "",
    "By 1998, people from more than 16 countries, including Japan, Australia, ",
    "New Zealand and Russia had registered the program while it was shareware.",
    "In January 1999, I decided to make it Open Source to strengthen the Open ",
    "Source community. The community needs all the help it can get.",
    "",
    "Thanks a lot to Mark Overmars (markov@cs.ruu.nl) from the Netherlands and ",
    "T.C. Zhao (zhao@bloch.phys.uwm.edu) for their outstanding `XForms' user ",
    "interface library. This great software is used as a GUI basis in the current",
    "release of UC. Another big thanks to Marc van Kempen (marc@bowtie.nl) and",
    "Gennady Sorokupud (gena@netvision.il) for their XFEdit editor, on which UC's",
    "editor is based.",
    "",
    "Last not least, I'd like to say thanks to the Linux-, FreeBSD- and other",
    "Free Unix-communities for developing the Free Unixes into such incredibly",
    "good operating systems and development platforms.",
    "",
    "With a big Cheers! to every Unix user,",
    "    Mr. Unix Cockpit (henrik@klagges.com)",
    "",
    NULL
};


const char *other_bugs[] = {
    "",
    "Limitations and Bugs:",
    "",
    "- Automounter problems.",
    "",
    "",
    "",
    "",
    NULL
};

//   01234567879012345678790123456787901234567879012345678790123456787901234567 70
const char *quick_edit_help_text[] = {
    "",
    "  ",
    "1. General:",
    "",
    "The `F5 QuickEdit'-function invokes a simple text editor patterned after",
    "Emacs. You can have multiple editor windows open simultaneously, and UC",
    "remembers their attributes such as size, colour and fonts. The editor",
    "supports the normal UC scroll & cursor movement commands.",
    "  ",
    "  scroll action: <-> associated keyboard shortcuts:",
    "  ",
    "  a char backward    left arrow, pad left arrow, Ctrl-b (backward)",
    "  a char forward     right arrow, pad right arrow, Ctrl-f (forward)",
    "  a word backward    ctrl-left arrow, ctrl-pad left arrow, Alt-b, Esc-b (backward)",
    "  a word forward     ctrl-right arrow, ctrl-pad right arrow",
    "  a line down        down arrow, pad down arrow, Ctrl-n (next)",
    "  a line up          up arrow, pad up arrow, Ctrl-p (previous)",
    "  a page down        page down, pad page down, Ctrl-v",
    "  a page up          page up, pad page up, Alt-v, Esc-v",
    "  beginning of line  Home, pad Home, Ctrl-a",
    "  end of line        End, pad End, Ctrl-e",
    "  go to first line   Ctrl-Home, Ctrl-pad Home, Alt-<, Esc-<",
    "  go to last line    End, pad End, Alt->, Esc->",
    "  go to line number  Alt-g, Esc-g (go to)",
    "  center line        pad-5, Ctrl-l      ",
    "  ",
    "  Note: If you hold down the `shift'-key together with one of these",
    "  commands, then the text being covered is selected. This works as",
    "  well with the arrow keys as with the control keys. For example, ",
    "  `Ctrl-N' moves a line down and selects, while `Ctrl-n' only moves",
    "  a line down. (On some keyboards, `shift' won't work properly with",
    "  the keypad and the `<' and `>' keys, but the normal arrow keys will",
    "  do. In some window manager configurations, such as Fvwm-2, some of",
    "  the combinations of Alt, Ctrl and the arrow keys will be used for",
    "  window manager functions. In that case, they won't be available for",
    "  UC unless you reconfigure the window manager).",  
    "  ",
    "  Action:            Shortcut:",
    "  delete char        Ctrl-d",
    "  delete word        Alt-d, Esc-d",
    "  ",
    "  Note: The shortcuts with `Escape' are meant as replacement for `Alt',",
    "        in the case your window manager assigns special meaning to the",
    "        Alt-keys, such as for non-english keyboards.",
    "  ",
    "2. Cut and Paste:",
    "  ",
    "You can select text either with the mouse or via shift-scroll commands.",
    "To select text with the mouse, drag the mouse over the text with the",
    "left mouse button pressed. You can extend an existing selection by ",
    "clicking with the left mouse while holding the `Shift'-key.",
    "  ",
    "To cut, copy or paste selected text, you can use the `Edit'-menu or the",
    "following keyboard shortcuts:",
    "  ",
    "  Ctrl-x, Alt-x, Esc-x      cut selected text",
    "  Ctrl-c, Alt-c, Esc-c      copy selected text",
    "  Ctrl-y, Alt-y, Esc-y      yank (paste) selected text",
    "  Ctrl-k                    cut up to end of this line (incremental)",
    "  ",
    "Note that UC doesn't use `Ctrl-v' or `Alt-v' for pasting, as might be",
    "expected from other systems. The reason is that UC and Emacs have allways",
    "used these shortcuts for scrolling. Ctrl-k is a special cut command that",
    "deletes up to the end of the current line. If you repeat Ctrl-k, the ",
    "multiple deleted lines are accumulated and can be yanked back with a ",
    "single Ctrl-y. This is useful for the cutting and pasting of short blocks,",
    "which is particularly useful if you switch between multiple editor windows",
    "with Alt-1, Alt-2 etc.",
    "  ",
    "  ",
    "3. Fast Browser/Editor Focus:",
    "",
    "Fast browser focus (e.g., pressing `Ctrl-1' for browser 1) does work",
    "from within the editor window. There is an analogous `fast editor focus' ",
    "shortcut with `Alt-1' for editor window 1, `Alt-2' for editor 2 etc. ",
    "This is worth remembering, as it makes for very fast switching between",
    "windows. Again, `Esc-1' is equivalent to `Alt-1' and so forth.",
    "",
    "", 
    "4. Search Mode:",
    "  ",
    "The Quick Editor also has a search mode available via Ctrl-s. If the ",
    "search is successfull, you can use Ctrl-s again to find the next match, if",
    "any. In this case, you don't have to type the search string again, because",
    "the editor is still in search mode. Use any key to leave the search mode.",
    "",
    "",
    "5. Adjustable Options:",
    "",
    "The font size and style used in the editor window are adjustable via the `F2",
    "Options'-key (if pressed _within_ the editor window !), or via the \"Options\"-",
    "submenu of the \"Edit\"-Menu. These parameters, together with the size and ",
    "position of the view window, are part of the UC configuration database, and",
    "can thus be remembered over several invocations of UC by saving the configu-",
    "ration. Each editor window can have its own configuration, which allows to",
    "have e.g. different colours for each window.",
    "",

    NULL
};

const char *make_help_text[] = {
    "",
    "Make Interface:",
    "",
    "This advanced facility integrates the powerful Unix `make' command into UC.",
    "On startup, UC reads the file `ucmk' in your home/.uc directory and looks",
    "for targets. All normal targets found are put into the `UC Make' submenu",
    "in the browser. If that file doesn't exist, UC looks for a global `ucmk'",
    "in its global default directory, which is /usr/local/lib/uc (the environment",
    "variable UC_HOME - if defined - overrides the global default directory).",
    "",
    "For example, you could put something like this into ucmk:",
    "",
    "shutdown:",
    "        echo 'Hasta la vista, babe \\! > /dev/console'",
    "        sleep 5",
    "        /etc/shutdown",
    "",
    "This makes it possible for you to access your favourite actions from UC.",
    "",    
    "A really useful extension is the special ${UC_FILES} macro. This makes it",
    "possible to have any make action work on UC's list of selected files. Use",
    "it like in this example:",
    "",
    "compress:",
    "        compress ${UC_FILES}",
    "",
    "Here, when you choose `compress' from the `UC Make' submenu, make will be",
    "called so that the ${UC_FILES} macro gets expanded to the browser selection.",
    "",
    "You are encouraged to take a look into the makefile. It contains good default",
    "rules and examples to build upon. If you are extremely concerned about system",
    "security, use absolute pathnames for the commands in the makefile.",
    "",
    NULL
};

const char *suffix_rules_help_text[] = {
    "",
    "UC has a facility to define file suffix rules. For this, it has a special",
    "makefile named `ucsfx' in your home/.uc directory. It is used to bind user",
    "actions to file suffixes such as `.rgb' or `.tiff'. For each new suffix,",
    "you can write a new rule, change an existing one, or leave it unused.",
    "If no ucsfx file exists in your home/.uc directory, UC looks for a `ucsfx'",
    "in its global default directory, which is /usr/local/lib/uc (the environment",
    "variable UC_HOME - if defined - overrides the global default directory).",
    "If no ucsfx file exists, it is automagically created the first time you",
    "run UC.",
    "",
    "If a suffix rule exist for a file that you double-click (or press `Enter'",
    "upon) in the source browser, the rule will be executed. So, you can always",
    "play a sound file, view an image file, edit a showcase file etc.",
    "",
    "Here are a few example rules (change or add yours in ~/.uc/ucsfx):",
    "(Within a rule, use the special macro `$<' for the file that will",
    "be worked upon, see below).",
    "",
    ".aiff:",
    "        playaiff $<",
    "",
    ".au:",
    "        sfplay $<",
    "",
    ".rgb:",
    "        ipaste $<",
    "",
    "So, for example, if you double-click a file `snap.rgb', the command ",
    "`ipaste snap.rgb' will be executed.",
    "",
    "You are encouraged to take a look into the suffix rules makefile. It",
    "contains good default rules and examples to build upon. If you are",
    "extremely concerned about system security, use absolute pathnames for",
    "the commands in the suffix makefile.",
    "",
    NULL
};
    
const char *delete_help_text[] = {
    "",
#ifdef DEC_ALPHA
    "F13 Delete allows you to remove selected groups of files or directories in",
#else
    "F11 Delete allows you to remove selected groups of files or directories in",
#endif
    "the source directory. A question form will be popped up which asks for ",
    "confirmation of the delete. If you confirm, all selected files in the source",
    "directory will be deleted. You will be prompted again for files which are",
    "write protected, or which are directories.",
    "",
    "Be warned that removal in general, and recursive removal of directories",
    "in particular, is a rather powerful and irreversible operation. So, make",
    "sure you really want to remove the data, and/or have them on backup media.",
    "The Unix Cockpit does allow you to interrupt a remove operation while it",
    "is proceeding, but cannot undo the removals that took place until the",
    "interruption. ",
    "",
    "A simple strategy for you to counter the `remove blues' is to avoid the",
    "Delete function, and to use the F8 Move function to move unwanted files",
    "into a `wastebasket' directory. You can then examine your wastebasket e.g.",
    "at the end of a working day, and then make final remove decisions. Note",
    "that this strategy becomes unhandy if work is performed over filesystem",
    "boundaries, because then a move to the wastebasket needs to be a copy",
    "operation, which takes long, can fail, etc. ",
    "",
    NULL,
};

const char *default_editor_help_text[] = {
    "",
    "With this feature, you can set the editor command and its options that",
    "will be used together with the F6 Edit key. There is one important issue",
    "when setting this: The editor must either run in its own window, such as",
    "xedit or emacs, or it MUST be called together with a window shell in which",
    "it can run. Otherwise, programs like `vi', which expect a shell, will behave",
    "erratically.",
    "",
    "If you are unsure what to do, supply the string <builtin> (including the",
    "'<' and the '>'). In that case, UC's internal editor will be used, which",
    "is pretty good anyway :-)!",
    "",
    "Examples:",
    "1. For the builtin editor (never supply any other arguments here!):",
    "<builtin>",
    "",
    "2. commands for editors with their own windows:",
    "/usr/bin/X11/xedit",
    "/usr/local/bin/emacs",
    "",
    "3. commands for editors which need a terminal emulator:",
#ifdef SGI    
    "/usr/sbin/winterm -c /usr/bin/vi",
#else
    "xterm -e /usr/bin/vi",
#endif
    "",
    "A useful feature for an editor command line is to specify a X11 geometry",
    "string, so that the editor window will pop up at the given position ",
    "immediately, without the need to position it interactively. Here is an",
    "example:",
    "",
#ifdef SGI    
    "/usr/sbin/winterm -title UCEdit -geometry 80x40+200+200 -c /usr/bin/vi",
#else
    "xterm -title UCEdit -geometry 80x40+200+200 -e /usr/bin/vi",
#endif
    "",
    "Try to position the editor and UC windows in such a way that the editor",
    "pops up under the mouse, so that you can type away into the editor without",
    "any mousing around. This allows very quick and comfortable editing. (Only",
    "X window editors and the X window terminal emulators support geometry",
    "strings).",
    "",
    NULL,
};

const char *quick_edit_colour_help_text[] = {
    "",
    "Use this form to change all colours in the UC quick editor. Simply adjust",
    "each colour individually by pressing it's colour button.",
    "",
    NULL
};

const char *wm_help_text[] = {
    "",
    "The UC Mini-Window Manager window allows you to execute window management",
//   01234567879012345678790123456787901234567879012345678790123456787901234567 70
    "functions on all UC windows at once. You can iconify, hide (unmap) or show",
    "all windows, or push (lower) or pop (raise) them. Note that the Mini-WM",
    "maintains the correct window stacking/overlapping of all UC windows while",
    "manipulating them, which can take a little time over slow connections.",
    "",
    "Use the `speed' buttons to move all UC windows into one direction, and",
    "click the `direction' button to change the move direction itself.",
    "",
    "Like the toolbox, the Mini-WM window also has a F12 exit button, for quick",
    "exiting of the tool. This is useful if the other UC windows are hidden, for",
    "example.",
    "",
    NULL
};
    
const char *xshell_conflict_help_text[] = {
    "",
    "The UCShell event machinery of the Unix Cockpit has detected that multiple",
    "unexpected XEvents are sent to the shell. This can be harmless, but it ",
    "could be harmful if the unexpected events are generated by an external",
    "source. Therefore, as a precaution, your shell was switched off.",
   "",
    NULL
};

const char *xshell_options_help_text[] = {
    "",
    "In this window, you can supply custom options to the UC shell. This is ",
    "especially useful for changing the shells colours and fonts. Additionally,",
    "you can supply fudge-factors that are used in the positioning of the shell",
    "window. UC tries to outsmart your window manager but may fail, in which ",
    "case the window positioning of the shell will be slightly wrong after a",
    "database-save, database-reload cycle. Use the fudges to offset these errors.",
    "",
    "Dont's:",
    "",
    "- don't give a geometry string here as UC does this for you already;",
    "- don't supply -title or -name options, this will mix up UC.",
    "- also be careful supplying options that affect the starting of the ",
    "  shell window, such as -iconic or -wait_for_map.",
    "",
    "",
    NULL
};





