#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "error_notifier_forms_aux.h"
#include "flspecial.h"
#include "forms.h"
#include "global.h"
#include "gl_utility.h"
#include "help_forms_aux.h"
#include "help_text.h"
#include "license_forms.h"
#include "license_forms_aux.h"
#include "scroll_events.h"
#include "wm_forms_aux.h"

#ifdef GENERICBSD
#include <sys/types.h>
#include <pwd.h>
#endif

//#include "earth.xpm"

void GlobalHelpIntroScreenButtonCB(FL_OBJECT *, long){
    //fl_set_pixmap_data(BetaFormPixmap, earth);
    fl_show_form(BetaForm, FL_PLACE_CENTER, FL_FULLBORDER, "Welcome to Cyberspace");
    tool_focus_move(BetaForm, BetaFormReleaseText);
    fl_set_timer(BetaTimer, 0.0);
}

static int beta_raw_cb(FL_FORM *, void *xev){
    XEvent *xevent = (XEvent *) xev;
    //M_warn("beta raw","event %d", xevent->type); 
    if(xevent->type == KeyPress || xevent->type == ButtonPress){
	BetaTimerCB(NULL, 0);
	return TRUE;
    }
    return FALSE;
}

static int BetaFormAtClose(FL_FORM *, void *) {
	BetaTimerCB(NULL, 0);
	return FL_IGNORE;
}

/* this message has to be shown, even so short, for the window manager
 * data to be acquired. It's better this way than to show one more extra
 * window. I could open a 1pix win offscreen :-)
 */

void startup_msg(void){
    M_info("startup_msg", "start");
    char buffer[62];
    sprintf(buffer, "Open Source %s V%s.%s", version_os, version_major, version_minor);
    fl_set_object_label(BetaFormReleaseText, buffer);
    fl_register_call_back(BetaForm, FL_ALL_EVENT, beta_raw_cb);

    int w0 = fl_get_string_width(
 	BetaFormC0Text->lstyle, 
	BetaFormC0Text->lsize,
	BetaFormC0Text->label,
	strlen(BetaFormC0Text->label)
    );
    int w1 = fl_get_string_width(
 	BetaFormPresentsText->lstyle, 
	BetaFormPresentsText->lsize,
	BetaFormPresentsText->label,
	strlen(BetaFormPresentsText->label)
    );
    if(w1>w0) w0 = w1;
    w1 = fl_get_string_width(
 	BetaFormCockpitText->lstyle, 
	BetaFormCockpitText->lsize,
	BetaFormCockpitText->label,
	strlen(BetaFormCockpitText->label)
    );
    if(w1>w0) w0 = w1;
    fl_set_form_size(BetaForm, w0+30, BetaForm->h);
    if(tool_bw_flag){
	fl_set_object_color(BetaFormCockpitText, FL_WHITE, FL_BLACK);
	fl_set_object_color(BetaFormPresentsText, FL_WHITE, FL_BLACK);
	fl_set_object_color(BetaFormReleaseText, FL_WHITE, FL_BLACK);
	fl_set_object_color(BetaFormC0Text, FL_WHITE, FL_BLACK);
	fl_set_object_color(BetaFormC1Text, FL_WHITE, FL_BLACK);
	fl_set_object_color(BetaFormC2Text, FL_WHITE, FL_BLACK);
    }
	
    fl_set_form_atclose(BetaForm, BetaFormAtClose, NULL);
    fl_show_form(BetaForm, FL_PLACE_CENTER, FL_FULLBORDER, "Welcome to Cyberspace");
    if(tool_startup_msg_flag){
	fl_set_timer(BetaTimer, 15.0);
	tool_focus_move(BetaForm, BetaFormReleaseText);
    } else {
	fl_set_timer(BetaTimer, 0.1);
    }
    while(BetaForm->visible){
	tool_mung_events();
    }
}

void BetaTimerCB(FL_OBJECT *, long){
  static int first = TRUE;
  if(BetaForm->visible){
    if (first) {
      // fudge computation only at real startup, not later re-show.
      first = FALSE;
      wm_compute_fudges(BetaForm);
    }
    fl_hide_form(BetaForm);
  }
}

