# makefile
#
# Copyright (C) 1991-99 Henrik Klagges (henrik@klagges.com)

include makefile.aux

LOCALS		= $(LOCAL_INC) $(LOCAL_LIB)

UC_FD_OBJ = action_forms.o colour_forms.o crash_forms.o dirinfo_forms.o \
	display_forms.o edit_colour_forms.o edit_forms.o \
	error_notifier_forms.o fkeybar_forms.o ghelp_forms.o \
	help_forms.o license_forms.o options_forms.o sort_forms.o \
	status_forms.o toolbox_forms.o tree_forms.o \
	tree_colour_forms.o  wm_forms.o \
	xshell_forms.o

UC_AUX_OBJ = \
	action_forms_aux.o colour_forms_aux.o crash_forms_aux.o \
	dirinfo_forms_aux.o \
	display_forms_aux.o edit_forms_aux.o error_notifier_forms_aux.o \
	fkeybar_forms_aux.o forms_aux.o \
	ghelp_forms_aux.o help_forms_aux.o license_forms_aux.o \
	options_forms_aux.o sort_forms_aux.o status_forms_aux.o \
	toolbox_forms_aux.o tree_forms_aux.o tree_colour_forms_aux.o \
	wm_forms_aux.o

UC_NORM_OBJ = \
	browser.o browser_menu.o cb.o cb_table.o cb_key.o cb_fkey.o \
	cb_rename.o cb_move.o cb_duplicate.o cb_copy.o cb_remove.o \
	cstring.o defaults.o dir_menu.o file_utility.o fl_edit.o \
	fl_editscrollbar.o fork_pipe.o gl_utility.o global.o help_text.o \
	linklist.o make.o menu.o pathnames.o resource.o scandir.o \
	scroll_events.o stack.o suffix.o superls.o textbuf.o \
	tutorial_text.o uc.o utility.o wildcard.o \
	xshell.o

UC_C_OBJ = \
	panel.o

UC_OBJ = ${UC_FD_OBJ} ${UC_AUX_OBJ} ${UC_NORM_OBJ} ${UC_C_OBJ}

UC_SOURCES = $(UC_NORM_OBJ:.o=.C) $(UC_AUX_OBJ:.o=.C) $(UC_FD_OBJ:.o=.c) ${UC_C_OBJ:.o=.c}

BM_FILES = \
	arggh64.bm browser.bm editor.bm fkeybar.bm folder.bm \
	folder_mask.bm \
	shell.bm status.bm \
	toolbox.bm tree.bm wm.bm xshell.bm 

UC_HEADERS = \
        $(UC_AUX_OBJ:.o=.h) \
        $(UC_FD_OBJ:.o=.h) \
	browser.h browser_menu.h cb.h cb_table.h cb_key.h cb_fkey.h  \
	cb_duplicate.h cb_remove.h client_msg.h cstring.h dir_menu.h \
	file_utility.h fix_keysyms.h fl_edit.h fl_editscrollbar.h \
	gl_utility.h global.h linklist.h make.h menu.h pathnames.h \
	resource.h scroll_events.h textbuf.h fork_pipe.h scandir.h \
	stack.h suffix.h superls.h system.h utility.h help_text.h \
	wildcard.h xshell.h

# clean list to begin with:
.SUFFIXES:

# now add out rules:
.SUFFIXES:  .C .o .c

.C:
	$(CC) $(CCFLAGS) $(LOCALS) $@.C -o $@ $(LINK_LIBS) 

.C.o:	
	$(CC) $(CCFLAGS) $(LOCAL_INC) ${LOCAL_VAR} $*.C -c 

.c.o:
	$(CC) $(CFLAGS) $(CCFLAGS) $(LOCAL_INC) ${LOCAL_VAR} $*.c -c

all:	uc

uc:	$(UC_OBJ)
	$(CC) $(CCFLAGS) $(LOCALS) $(UC_OBJ) -o $@ $(LINK_LIBS)

wc:
	wc ${UC_HEADERS} ${UC_SOURCES} | sort

clean:
	- /bin/rm *.o *.bak *..c core mon.out a.out 

depend:	${UC_SOURCES}
	${CC} -MM $(CCFLAGS) $(LOCALS) $(UC_SOURCES) > depend.mk

include depend.mk
#
# DO NOT DELETE THIS LINE -- make depend depends on it.
