
#ifndef RESOURCE_H
#define RESOURCE_H

#include <fstream.h>

/* allows user-definable default value I/O functions.
 * handy for e.g. directory lists, which need insertion.
 * input functions just add their data to the list; while
 * output functions get called only once for a multi-parameter,
 * thus they have to output the whole list. Future :-)
   typedef void (*load_func_pt)(void *);
 */

typedef enum {char_p_e, double_e, int_e, long_e, short_e} prm_type_et;

typedef struct {
    const char *name;
    prm_type_et type;
    void *data_p;
} prm_entry_t;

int resource_load_default(    // true if successful.
    prm_entry_t prm_table[],  // supplied `keypad_prm_table'
    const char *ID_string,    // supplied `keypad_ID_string'
    const char *obj_tok,      // data `keypad'
    const char *name_tok,     // data `win_x'
    const char *val_tok       // data `100'
);

void resource_save_defaults(
    ofstream &ofile,
    prm_entry_t prm_table[],  // supplied `keypad_prm_table'
    const char *ID_string     // supplied `keypad_ID_string'
);

#endif

