/*
 * traced all mallocs, all copystr's (?).
 * killed: recursive option. shortlisting. use_less option.
 * uid/gid info stays permanent. 
 * zero'ed Npsfiles, Npfiles. 
 * useless version not supported, will be removed.
 * eliminate dostat. Always stat. 
 * Use scandir.
 *
 * todo: other statevariables.
 */

/*
 * "Super" ls program.  Allows complete specification of output contents:
 * field order, width, format, and sort order.
 *
 * Options:
 *   -a		show all files (includes '.' files)
 *   -d		show directories in arg list as files
 *   -l		long listing (uses $SLS_LONGFMT if set, or ls style)
 *   -L		follow symbolic links (show stat of pointed-to file)
 *   -p "ostr"	output key string
 *   -s "sstr"	sort key string
 *
 * Uses environment vbl SLS_DATEFMT as default format string for dates, if
 * supplied.
 * 
 * this encapsulated (non-standalone version) hacked without mercy by HAK.
 * this code is almost in its original sls state, and tested on the net.
 * better don't change it :-)
 *
 * based on a sls program from long ago.
 */

#include "system.h"

#include <ctype.h>
#ifdef SCO
#include <dirent.h>
#endif
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <pwd.h>
#include <grp.h>
#include <time.h>
#include <signal.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "action_forms_aux.h"
#include "global.h"
#include "help_forms_aux.h"
#include "options_forms_aux.h"
#include "status_forms_aux.h"
#include "superls.h"
#include "utility.h"

#if defined(LINUX) || defined(GENERICBSD)
#    include <signal.h>
#endif

#if defined(HP) || defined(DEC_ALPHA) || defined(AIX) || defined(SOLARIS) || defined(UNIXWARE) || defined(SINIX)
#    include <signal.h>
#    include <dirent.h>
#else
#    include <sys/dir.h>
#endif

#define ISEXEC(m)	(m & (S_IEXEC|(S_IEXEC>>3)|(S_IEXEC>>6)))
#define MAXUIDS		5000	/* max #of user names from passwd file */
#define MAXGIDS		MAXUIDS	/* max #of group names from group file */
                                /* some sites give each user his group */

    /* defines for sort/print option strings (preceded by a '%'); keys can
     * have field widths; leading '-' indicates left-justify (string fields)
     * or reverse order if it is a sort key; leading '0' indicates zero-fill
     * (numeric fields) */
#define F_ADATE		'a'	/* access date (optional fmtdate string) */
#define F_BLOCKS	'b'	/* #allocated (512-byte) blocks (+ m,k,c|b) */
#define F_CDATE		'c'	/* inode change date */
#define F_DEV		'd'	/* device number inode resides on */
#define F_GROUPA	'g'	/* ascii group name (from group file) */
#define F_GROUPN	'G'	/* numeric group id */
#define F_INODE		'i'	/* inode number */
#define F_BLKSIZE	'k'	/* optimal file system block size */
#define F_NLINKS	'l'	/* number of hard links */
#define F_MDATE		'm'	/* modify date (optional fmtdate string) */
#define F_NAME		'n'	/* file name (+ b=basename,a=ascii,s=suffix) */
#define F_NAMEL		'N'	/* file name with symbolic links shown */
#define F_PERMA		'p'	/* ascii permissions */
#define F_PERMO		'P'	/* octal permissions */
#define F_RDEV		'r'	/* device number file resides on */
#define F_SIZE		's'	/* file size in bytes (mods: m,k,c|b) */
#define F_TYPE		't'	/* file type (coded like 'ls') */
#define F_USERA		'u'	/* ascii user name (from passwd file) */
#define F_USERN		'U'	/* numeric user id */
#define F_EXTENSION     'x'     /* file name extension */

SFILESTAT *Psfiles;	/* list of files to sort/print */
int       Npsfiles;	/* number of files in Psfiles */

    /* global options */
int    Follow_links;	/* follow symbolic links */
int    Stat_dirs;	/* show directories as files */
int    All_files;	/* include '.' files in listing */
char  *Defdatefmt;	/* default format for dates */
char  *Sortopt;
char  *Printopt;

/* 
 * new special sls options.
 * the following one is intended to list directories first
 * under normal ordering - last under reverse ordering.
 * This should be unconditionally.
 * we also have a flag that allows to integrate links into
 * the regular file listing, which otherwise is slightly
 * awkward.
 */

int sls_directories_first_flag = 1;
int sls_list_links_like_files_flag = 1;
int quiet_flag = 1;

static char 
    *copystr (char  *str),
    *showname (register char  *fname)
;

static int sortsfile (SFILESTAT *pf1, SFILESTAT *pf2);

char
    *getpwname (int  uid),
    *getgrname (int  gid)
;

char *getfmtstr (
    char   ftype,	
    int    width,
    int    leftjust,
    int    zerofill
);

char  *aperms (
    mode_t   mode,	
    char     *poptstr,	
    int      *pnmod
);

static void 
    dirread (char *dirname),
    display (SFILESTAT *pf),
    dofile (register char *fname, int cmdarg),
    reinit (void),  /* HAK */
    selectfs (register char *fname, register struct stat  *psbuf)
;

//extern char  *getenv(...); //, *malloc(), *realloc();
//extern int    errno;
extern time_t time();

/* HAK's reentrant-enabler. */
/* communicate to functions that this is new.*/

static int     maxpsfiles = 0;


void reinit (void){
    /* don't free stat .. it isn't alloc'ed. */
    /* psfiles: */
    if(Psfiles){
	for(int i=0; i<Npsfiles; i++){
	    if(Psfiles[i].f_name){
		fl_free(Psfiles[i].f_name);
		Psfiles[i].f_name = NULL;
		//cerr << "Freeing psfile #" << i << endl;
	    }
	}
#ifdef SUN
	fl_free((char *)Psfiles);
#else
	fl_free(Psfiles);
#endif
	Psfiles = NULL;
    }
    Npsfiles = 0;
    maxpsfiles = 0;
}

/***/
/* is it a directory, and is it in the list ? */
/*
static int dbg_flag = FALSE;

class entry_c{
public:
    char *name;
    struct stat statbuf;
    entry_c(const char *name_iv);
};

entry_c::entry_c(const char *name_iv){
    if(!name_iv){
	cerr << "NULL name in entry_c constructor.\n";
    } else {
	name = strdup(name_iv);
    }
}

#include "linklist.h"

linklist_c dir_list;

static int is_cached(char *dirname){
    if(!dirname) return FALSE;
    int size = dir_list.getsize();
    for(int i=0; i<size; i++){
	entry_c *buf = (entry_c *) dir_list[i];
	if(buf){
	    if(buf->name){
		if(strcmp(buf->name, dirname) == 0){
		    if(dbg_flag) cerr << "search_dir name (NOT TIME) success for: " << dirname << endl;
		    return TRUE;
		}
	    } else {
		fprintf(stderr, "no name in buf.");
	    }
	} else {
	    fprintf(stderr, "NULL buf in linklist.");
	}
    }
    if(dbg_flag) cerr << "search_dir not found: " << dirname << endl;
    return FALSE;
}

static int load_from_cache(char *dirname){
    if(!dirname) return FALSE;
    if(is_cached(dirname)){
	dofile (dirname, 1);    
	return TRUE;
    } else {
	return FALSE;
    }
}
*/
/******************************************************************************/

static browser_puts_fpt sls_puts;

static int
    skip_all_flag = 0
;

static struct timeval
    dir_start_time,
    last_file_time
;    

/*
struct timeval click_time;
gettimeofday(&_time, NULL);
long diff = msecs_diff(click_time, prev_click_time);
*/

#if defined(HP) || defined(LINUX) || defined(DEC_ALPHA) || defined(AIX) || defined(SOLARIS) || defined(GENERICBSD) || defined(UNIXWARE) || defined(SGI_IRIX62) || defined(SCO) || defined(SINIX)
static void file_sigalrm_proc(int){
#elif defined(SGI_IRIX6)
static void file_sigalrm_proc(...){
#else
static void file_sigalrm_proc(int, ...){
#endif
    //cerr << "sls: file timeout.\n";
}

class file_info_c {
public:
    file_info_c(struct stat &statbuf_iv, const char *fname_iv);
};

int sls_main (int ac, char *av[], browser_puts_fpt browser_puts){
    register char *pav, *longfmt;
    register int   i, gotfilearg;

    if(!browser_puts || !av || ac < 1){
	error_exit("Null args to list_main");
    }

    sls_puts = browser_puts;
    
    gotfilearg = 0;
    Sortopt = "%n";
    Printopt = "%n";
    Defdatefmt = "%h %d 19%y %H:%M";
    longfmt = "%t%p %2l %-u %s %m %n";
    Follow_links = Stat_dirs = All_files = 0;

    // prepare timeout handling. 
    skip_all_flag = 0;
    gettimeofday(&dir_start_time, NULL);
	
    while (--ac > 0)
    {
	pav = *++av;
	if (*pav == '-')
	{
	    while (*++pav) switch (*pav)
	    {
	    case 'a':
		All_files = 1;
		break;
	    case 'd':
		Stat_dirs = 1;
		break;
	    case 'l':
		Printopt = longfmt;
		break;
	    case 'L':
		Follow_links = 1;
		break;
	    case 'p':
		if (--ac == 0)
		{
		    fprintf (stderr, "missing argument\n");
		    exit (1);
		}
		Printopt = *++av;
		pav = "-";	/* so while() quits */
		break;
	    case 's':
		if (--ac == 0)
		{
		    fprintf (stderr, "missing argument\n");
		    exit (1);
		}
		Sortopt = *++av;
		pav = "-";	/* so while() quits */
		break;
	    default:
		fprintf (stderr, "can't parse `%s'\n", pav);
		exit (1);
	    }
	} else {
	    if(gotfilearg > 0){
		fprintf(stderr, "cannot handle multiple files.\n");
	    } else {
		//if(!load_from_cache(pav)){
		dofile (pav, 1);
		//}
	    }
	    ++gotfilearg;
	}
    }

    if (!gotfilearg){
	fprintf(stderr, "no file argument given, defaulting to `.'.\n");
	dofile (".", 1);
    }

    if (strlen(Sortopt) > 0)
	qsort ((void *)Psfiles, Npsfiles, sizeof(*Psfiles), 
	       ( (int (*) (const void*, const void*)) sortsfile))
	    ;

    for (i=0; i<Npsfiles; ++i)
	display (Psfiles+i);
    
    reinit();
    return 0;
}  /* main */

/******************************************************************************/

void dofile (register char *fname, int cmdarg)
	/* name of file to stat and list */
	/* =1 if fname was command line arg */
{  /* check if file should be displayed (read contents if a directory) */
    struct stat     sbuf;
    register char  *pbase;	/* ptr to basename part of fname */
    int continue_flag;

    // update all stuff for timing/alarm
    gettimeofday(&last_file_time, NULL);
    long diff = msecs_diff(last_file_time, dir_start_time);
    //cerr << "diff: " << diff << endl;
    if(diff > tool_dir_timeout_secs * 1000 && !skip_all_flag){
	continue_flag = TRUE;
	while(continue_flag){
	    // switch(fl_show_choice("reading dir takes too long", "", "", 3, "Continue", "Skip", "Options")){
	    switch(ask_multi_question(FALSE, 1, "directory reading takes too long",
	        "Continue Trying", "Cc", NoSymbol, "Skip", "Ss", NoSymbol, "Options", "Oo"
	    )){
	    case -1:
	    case 0:
		status_msg(1, "continue.");
		gettimeofday(&dir_start_time, NULL); // reset.
		continue_flag = FALSE;
		break;
	    case 1:
		status_msg(1, "skip remaining files");
		skip_all_flag = TRUE;
		continue_flag = FALSE;
		break;
	    case 2:
		status_msg(1, "options");
		timeout_adjust();
		break;
	    default:
		break;
	    }
	}
    }
    
    if(!fname){
	error_exit("ls: NULL fname in dofile.");
    }
	
    if ((pbase = strrchr (fname, '/')) == (char *)NULL){
	pbase = fname;
    } else {
	++pbase;
    }
	/* skip files that start with '.' unless -a */
    if (*pbase == '.' && !All_files && !cmdarg){
	return;
    }
    if(skip_all_flag){
	// cerr << "avoid stat .:-)\n";
	memset(&sbuf, 0, sizeof(struct stat));
    } else {
	int success;
	continue_flag = TRUE;
	// cerr << "do stat\n";
	while(continue_flag){
	    success = 0;
	    // trivial alrm proc - we just need EINTR.
	    signal(SIGALRM, file_sigalrm_proc);  
	    alarm(tool_file_timeout_secs);
	    if(Follow_links){
		success = stat (fname, &sbuf);
	    } else {
		success = lstat(fname, &sbuf);
	    }
	    alarm(0);
	    if(success != 0){
		if(errno != EINTR){
		    if(!quiet_flag){
			fprintf (stderr, " cannot stat: `%s' (errno=%d)\n", fname, errno);
		    }
		    return;
		} else {
		    int local_continue_flag = TRUE;
		    char buffer[MAXPATHLEN+64];
		    sprintf(buffer, "getting info for file %s takes too long.", fname);
		    while(local_continue_flag){
			switch(ask_multi_question(FALSE, 1, "directory reading takes too long",
	                    "Continue Trying", "Cc", NoSymbol, "Skip", "Ss", NoSymbol, "Options", "Oo"
	                )){
			case -1:
			case 0:
			    status_msg(1, "continue trying.");
			    local_continue_flag = FALSE;
			    break;
			case 1:
			    status_msg(1, "skip file");
			    local_continue_flag = FALSE;
			    return;
			case 2:
			    status_msg(1, "options");
			    timeout_adjust();
			    break;
			default:
			    break;
			}
		    }
		}
	    } else {
		continue_flag = 0;
	    }
	}
    }

    if ((sbuf.st_mode&S_IFMT) == S_IFDIR)	/* it's a directory */
    {
	if (!cmdarg
	    && (strcmp (pbase, ".") == 0 || strcmp (pbase, "..") == 0))
	{  /* don't show these unless -a given */
	    if (All_files){
		selectfs (fname, &sbuf);
	    }
	    return;
	}

	if (cmdarg){
	    /* it's a dir, and it's a toplevel arg */
	    
	}
	
	if (Stat_dirs || !cmdarg){
	    selectfs (fname, &sbuf);
	} else {
	    dirread (fname);
	}
	return;
    }

    selectfs (fname, &sbuf);

}  /* dofile */

/******************************************************************************/

void dirread (char *dirname)
{  /* read a directory and everything under it that's on the same device */
    register DIR   *dirp;		/* ptr to directory list */
#if defined(HP) || defined(DEC_ALPHA) || defined(AIX) || defined(SOLARIS) || defined(UNIXWARE) || defined(SCO) || defined(SINIX)
    register struct dirent  *dentp;	/* ptr to directory entry */
#else
    register struct direct  *dentp;	/* ptr to directory entry */
#endif
    register char  *pfname;
    register int    len;
    char            fname[MAXPATHLEN];		/* maximum pathname length */

    if(!dirname){
	fprintf(stderr, "NULL dirname given.");
	exit(-1);
    }

	/* open and read a directory */
    if ((dirp = opendir(dirname)) == NULL)
    {
	fprintf (stderr, "cannot open directory `%s' (errno=%d)\n",
	    dirname, errno);
	return;
    }
    strcpy (fname, dirname);
    len = strlen(fname);
    pfname = &fname[len];		/* point to start of filename part */
    if (len > 0 && *(pfname-1) != '/')
    {  /* doesn't end with slash, so add it */
	strcat (fname, "/");
	++pfname;
	++len;
    }

    /* loop through directory entries */
    while((dentp = readdir(dirp)) != NULL){
#if defined(SOLARIS) || defined(UNIXWARE) || defined(LINUX) || defined(SCO) || defined(SINIX)
	if (len + strlen(dentp->d_name) >= sizeof(fname))
#else
	if (len + dentp->d_namlen >= sizeof(fname))
#endif
	{
	    *pfname = '\0';	/* so we don't see previous filename part */
	    fprintf (stderr, "name too long (truncated): `%s%s'\n",
		fname, dentp->d_name);
	    continue;
	}
        /* add this file name to the directory path */
	strcpy (pfname, dentp->d_name);
	/*
	fprintf(stderr, " ..readdir: fname is %s, (entry: `%s')\n", 
	    fname, dentp->d_name
	); 
	*/
	dofile (fname, 0);
    }

    closedir (dirp);

}  /* dirread */

/******************************************************************************/

void selectfs (register char *fname, register struct stat  *psbuf)
{  /* allocate a struct for this file for sorting */
    SFILESTAT      *pf;
    unsigned int   size;

    if(!psbuf){
	fprintf(stderr, "NULL stat buf");
	exit(-1);
    }
    if(!fname){
	fprintf(stderr, "NULL file name");
	exit(-1);
    }
    /* reentrant */
    /* check if need more space for SFILESTAT ptrs */
    if (Npsfiles == maxpsfiles)
    {
	maxpsfiles += 100;
	size = maxpsfiles * sizeof(SFILESTAT);
	if (Psfiles == (SFILESTAT *) NULL){
	    Psfiles = (SFILESTAT *) fl_malloc (size);
	} else {
#ifdef SUN
	    Psfiles = (SFILESTAT *) fl_realloc ((char *)Psfiles, size);
#else
	    Psfiles = (SFILESTAT *) fl_realloc ((void *)Psfiles, size);
#endif
	}
	if (Psfiles == (SFILESTAT *) NULL)
	{
	    fprintf (stderr, "out of memory (errno=%d) for file `%s'\n",
		errno, fname);
	    exit (1);
	}
    }

    pf = Psfiles + Npsfiles;
    pf->f_name = copystr (fname);
    pf->f_stat = *psbuf;	/* copies entire struct */
    ++Npsfiles;

}  /* selectfs */

/******************************************************************************/

static int sortsfile (
		      register SFILESTAT     *pf1,
		      register SFILESTAT     *pf2
		      )
{  /* qsort comparison routine */
    register char         *ps, *p1, *p2, *ptmp;
    register struct stat  *psbuf1, *psbuf2;
    long                   l1, l2;
    int                    i, reverse, ascii, basen;
    char                   tbuf1[200], tbuf2[200];

    if(!pf1 || !pf2){
	error_exit("ls: sort file with NULL args.");
    }

    psbuf1 = &(pf1->f_stat);
    psbuf2 = &(pf2->f_stat);
    for (ps=Sortopt; *ps; ++ps)
    {
	if (*ps++ != '%')
	{
	    fprintf (stderr, "cannot sort by `%.6s'...\n", ps);
	    exit (1);
	}

	    /* check for '-' (for reverse order sort) */
	reverse = 1;		/* NOT a flag - multiplied by strcmp() result */
	if (*ps == '-')
	{
	    reverse = -1;
	    ++ps;
	}

	l1 = l2 = 0;
	p1 = p2 = (char *)NULL;
	int extension_flag = FALSE;
	switch (*ps)
	{
	case F_TYPE:
	    switch (psbuf1->st_mode & S_IFMT)
	    {
	    case S_IFREG:	p1 = "-"; break;
	    case S_IFDIR:
		{
		    if(sls_directories_first_flag){
			p1 = "+";
		    } else {
			p1 = "d"; 
		    }	
		    break;
		}
	    case S_IFCHR:	p1 = "c"; break;
	    case S_IFBLK:	p1 = "b"; break;
	    case S_IFLNK:	
		{
		    if(sls_list_links_like_files_flag){
			p1 = "-";
		    } else {
			p1 = "l"; 
		    }
		    break;
		}
	    case S_IFSOCK:	p1 = "s"; break;
	    case S_IFIFO:	p1 = "p"; break;
	    default:		p1 = "?"; break;
	    }
	    switch (psbuf2->st_mode & S_IFMT)
	    {
	    case S_IFREG:	p2 = "-"; break;
	    case S_IFDIR:
		{
		    if(sls_directories_first_flag){
			p2 = "+";
		    } else {
			p2 = "d"; 
		    }	
		    break;
		}
	    case S_IFCHR:	p2 = "c"; break;
	    case S_IFBLK:	p2 = "b"; break;
	    case S_IFLNK:	
		{
		    if(sls_list_links_like_files_flag){
			p2 = "-";
		    } else {
			p2 = "l"; 
		    }
		    break;
		}
	    case S_IFSOCK:	p2 = "s"; break;
	    case S_IFIFO:	p2 = "p"; break;
	    default:		p2 = "?"; break;
	    }
	    break;
	case F_PERMA:
	    p1 = aperms (psbuf1->st_mode, ps+1, &i);
	    p2 = aperms (psbuf2->st_mode, ps+1, &i);
	    ps += i;
	    break;
	case F_PERMO:
	    l1 = ((psbuf1->st_mode) & (~S_IFMT));
	    l2 = ((psbuf2->st_mode) & (~S_IFMT));
	    break;
	case F_NLINKS:
	    l1 = psbuf1->st_nlink;
	    l2 = psbuf2->st_nlink;
	    break;
	case F_INODE:
	    l1 = psbuf1->st_ino;
	    l2 = psbuf2->st_ino;
	    break;
	case F_DEV:
	    l1 = psbuf1->st_dev;
	    l2 = psbuf2->st_dev;
	    break;
	case F_RDEV:
	    l1 = psbuf1->st_rdev;
	    l2 = psbuf2->st_rdev;
	    break;
	case F_USERA:
	    l1 = psbuf1->st_uid;
	    l2 = psbuf2->st_uid;
	    if ((ptmp = getpwname((uid_t)l1)) == (char *)NULL)
		break;
	    strcpy (tbuf1, ptmp);
	    if ((ptmp = getpwname((uid_t)l2)) == (char *)NULL)
		break;
	    strcpy (tbuf2, ptmp);
	    p1 = tbuf1;
	    p2 = tbuf2;
	    break;
	case F_USERN:
	    l1 = psbuf1->st_uid;
	    l2 = psbuf2->st_uid;
	    break;
	case F_GROUPA:
	    l1 = psbuf1->st_gid;
	    l2 = psbuf2->st_gid;
	    if ((ptmp = getgrname((gid_t)l1)) == (char *)NULL)
		break;
	    strcpy (tbuf1, ptmp);
	    if ((ptmp = getgrname((gid_t)l2)) == (char *)NULL)
		break;
	    strcpy (tbuf2, ptmp);
	    p1 = tbuf1;
	    p2 = tbuf2;
	    break;
	case F_GROUPN:
	    l1 = psbuf1->st_gid;
	    l2 = psbuf2->st_gid;
	    break;
	case F_SIZE:
	    l1 = psbuf1->st_size;
	    l2 = psbuf2->st_size;
	    break;
	case F_BLOCKS:
	    perror("Unsupported on Irix: number of blocks. Could div by 512.");
	    exit(-99);
	    /* 
	     * l1 = psbuf1->st_blocks;
	     * l2 = psbuf2->st_blocks;
	     */
	    break;
	case F_BLKSIZE:
	    perror("Unsupported on Irix: st_blksize. Could maybe hack it.");
	    exit(-99);
	    /*
	     * l1 = psbuf1->st_blksize;
	     * l2 = psbuf2->st_blksize;
	     */
	    break;
	case F_MDATE:
	    l1 = psbuf1->st_mtime;
	    l2 = psbuf2->st_mtime;
	    break;
	case F_ADATE:
	    l1 = psbuf1->st_atime;
	    l2 = psbuf2->st_atime;
	    break;
	case F_CDATE:
	    l1 = psbuf1->st_ctime;
	    l2 = psbuf2->st_ctime;
	    break;
	case F_EXTENSION:
	    extension_flag = TRUE;
	case F_NAME:
	case F_NAMEL:
	    ascii = basen = 0;
	    while (*(ps+1) && strchr("abs",*(ps+1)) != NULL)
	    {
		++ps;
		if (*ps == 'a')
		    ascii = 1;
		else if (*ps == 'b')
		    basen = 1;
		else if (*ps == 's')	/* ignored for sort purposes */
		    ;
	    }
	    if (basen)	/* basename only */
	    {
		if ((p1 = strrchr (pf1->f_name, '/')) == (char *)NULL)
		    p1 = pf1->f_name;
		else
		    ++p1;
		if ((p2 = strrchr (pf2->f_name, '/')) == (char *)NULL)
		    p2 = pf2->f_name;
		else
		    ++p2;
	    }
	    else
	    {
		p1 = pf1->f_name;
		p2 = pf2->f_name;
	    }
	    if (ascii)	/* show non-printing chars */
	    {
		strcpy (tbuf1, showname (p1));
		strcpy (tbuf2, showname (p2));
		p1 = tbuf1;
		p2 = tbuf2;
	    }
	    if (extension_flag) {
		char *pChar;
		pChar = strrchr (p1, '.');
		if (pChar && pChar != p1) p1 = pChar;
		pChar = strrchr (p2, '.');
		if (pChar && pChar != p2) p2 = pChar;
	    }
	    break;
	default:
	    fprintf (stderr, "cannot sort by `%%%c'\n", *ps);
	    continue;
	}  /* switch */

	    /* now check for type of comparison for this field */
	if (p1 != (char *)NULL)
	{  /* string comparison */
	    i = strcmp (p1, p2);
	    if (i == 0)
		continue;	/* need to go to next sort field */
	    else
		return (reverse*i);
	}
	else
	{  /* numeric comparison */
	    if (l1 == l2)
		continue;	/* need to go to next sort field */
	    else if (l1 > l2)
		return (reverse);
	    else		/* l1 < l2 */
		return (-reverse);
	}
    }  /* loop through sort options string */

    return (strcmp (pf1->f_name, pf2->f_name));

}  /* sortsfile */

/******************************************************************************/

void display (SFILESTAT *pf){
/* display info about a file 
 * HK: treat extensions like names here, unlike for sorting.
 */
    register struct stat   *psbuf;
    register char  *popt, *pobuf, *fmtstr;
    register int    n, fwid;
    long            l;
    int             i, zerofill, leftjust, ascii, basen, suffix;
    char            obuf[200], lname[200], *ptmp, *pc, *fname, c;

    if(!pf){
	error_exit("attempt to display a NULL fname");
    }

    fname = pf->f_name;
    psbuf = &(pf->f_stat);
    pobuf = obuf;

    switch (psbuf->st_mode & S_IFMT){
    case S_IFBLK:	strcpy(obuf, "@B"); break;
    case S_IFCHR:	strcpy(obuf, "@C"); break;
    case S_IFDIR:	strcpy(obuf, "@D"); break;
    case S_IFLNK:	strcpy(obuf, "@L"); break;
    case S_IFIFO:	strcpy(obuf, "@P"); break;
    case S_IFREG:	strcpy(obuf, "@R"); break;
    case S_IFSOCK:	strcpy(obuf, "@S"); break;
    default:            strcpy(obuf, "@?"); break;
    }
    pobuf+=2; // important;

    for (popt=Printopt; *popt; ++popt)
    {
	if (*popt != '%')
	{
	    *pobuf++ = *popt;
	    continue;
	}
	if (*(popt+1) == '%')
	{
	    *pobuf++ = *popt++;
	    continue;
	}

	    /* check for optional field width and '-' (for left justify) */
	fwid = zerofill = leftjust = 0;
	if (*(popt+1) == '-')
	{
	    leftjust = 1;
	    ++popt;
	}
	if (isdigit (*++popt))
	{
	    zerofill = (*popt == '0');
	    for (fwid=0; isdigit(*popt); ++popt)
		fwid = fwid*10 + *popt - '0';
	}

	c = *popt;
	switch (c)
	{
	case F_TYPE:
	    switch (psbuf->st_mode & S_IFMT)
	    {
	    case S_IFBLK:	ptmp = "b"; break;
	    case S_IFCHR:	ptmp = "c"; break;
	    case S_IFDIR:	ptmp = "d"; break;
	    case S_IFIFO:	ptmp = "p"; break;
	    case S_IFLNK:	ptmp = "l"; break;
	    case S_IFREG:	ptmp = "-"; break;
	    case S_IFSOCK:	ptmp = "s"; break;
	    default:
		ptmp = "?";
		if(!quiet_flag){
		    fprintf (stderr, "weird file type 0%o for file `%s'\n",
			     psbuf->st_mode & S_IFMT, fname);
		}
		break;
	    }
	    if (fwid == 0)
	    {
		*pobuf++ = *ptmp;
		*pobuf = '\0';	/* so 'while' loop below exits */
	    }
	    else
	    {
		fmtstr = getfmtstr ('s', fwid, leftjust, zerofill);
		sprintf (pobuf, fmtstr, ptmp);
	    }
	    break;
	case F_PERMA:
	    if (fwid == 0)
		strcpy (pobuf, aperms (psbuf->st_mode, popt+1, &i));
	    else
	    {
		fmtstr = getfmtstr ('s', fwid, leftjust, zerofill);
		sprintf (pobuf, fmtstr,
		    aperms (psbuf->st_mode, popt+1, &i));
	    }
	    popt += i;
	    break;
	case F_PERMO:
	    if (fwid == 0)
		fmtstr = getfmtstr ('o', 3, 0, 1);
	    else
		fmtstr = getfmtstr ('o', fwid, leftjust, zerofill);
	    sprintf (pobuf, fmtstr, psbuf->st_mode & (~S_IFMT));
	    break;
	case F_NLINKS:
	    fmtstr = getfmtstr ('d', (fwid?fwid:4), leftjust, zerofill);
	    sprintf (pobuf, fmtstr, psbuf->st_nlink);
	    break;
	case F_INODE:
	    fmtstr = getfmtstr ('d', (fwid?fwid:6), leftjust, zerofill);
	    sprintf (pobuf, fmtstr, psbuf->st_ino);
	    break;
	case F_DEV:
	    fmtstr = getfmtstr ('d', (fwid?fwid:6), leftjust, zerofill);
	    sprintf (pobuf, fmtstr, psbuf->st_dev);
	    break;
	case F_RDEV:
	    fmtstr = getfmtstr ('d', (fwid?fwid:6), leftjust, zerofill);
	    sprintf (pobuf, fmtstr, psbuf->st_rdev);
	    break;
	case F_USERA:
	    n = (int) psbuf->st_uid;
	    if ((ptmp = getpwname((uid_t) n)) == (char *)NULL)
	    {
		fmtstr = getfmtstr ('d', (fwid?fwid:8), leftjust, zerofill);
		sprintf (pobuf, fmtstr, n);
	    }
	    else
	    {
		if (fwid == 0)
		    fmtstr = getfmtstr ('s', 8, leftjust, 0);
		else
		    fmtstr = getfmtstr ('s', fwid, leftjust, zerofill);
		sprintf (pobuf, fmtstr, ptmp);
	    }
	    break;
	case F_USERN:
	    fmtstr = getfmtstr ('d', (fwid?fwid:4), leftjust, zerofill);
	    sprintf (pobuf, fmtstr, psbuf->st_uid);
	    break;
	case F_GROUPA:
	    n = (int) psbuf->st_gid;
	    if ((ptmp = getgrname((gid_t) n)) == (char *)NULL)
	    {
		fmtstr = getfmtstr ('d', (fwid?fwid:8), leftjust, zerofill);
		sprintf (pobuf, fmtstr, psbuf->st_uid);
	    }
	    else
	    {
		if (fwid == 0)
		    fmtstr = getfmtstr ('s', 8, leftjust, 0);
		else
		    fmtstr = getfmtstr ('s', fwid, leftjust, zerofill);
		sprintf (pobuf, fmtstr, ptmp);
	    }
	    break;
	case F_GROUPN:
	    fmtstr = getfmtstr ('d', (fwid?fwid:4), leftjust, zerofill);
	    sprintf (pobuf, fmtstr, psbuf->st_gid);
	    break;
	case F_SIZE:
	    l = (long) psbuf->st_size;
	    if (*(popt+1) == 'm')
	    {
		fmtstr = getfmtstr ('d', (fwid?fwid:3), leftjust, zerofill);
		sprintf (pobuf, fmtstr, (l+1048575)>>20);
		++popt;
	    }
	    else if (*(popt+1) == 'k')
	    {
		fmtstr = getfmtstr ('d', (fwid?fwid:6), leftjust, zerofill);
		sprintf (pobuf, fmtstr, (l+1023)>>10);
		++popt;
	    }
	    else
	    {
		fmtstr = getfmtstr ('d', (fwid?fwid:9), leftjust, zerofill);
		sprintf (pobuf, fmtstr, l);
		if (*(popt+1) == 'c' || *(popt+1) == 'b')
		    ++popt;
	    }
	    break;
	case F_BLOCKS:
	    perror("Unsupported on Irix: number of blocks. Could div by 512.");
	    exit(-99);
	    break;
	case F_BLKSIZE:
	    perror("Unsupported on Irix: st_blksize. Maybe could hack it.");
	    exit(-99);
	    break;
	case F_MDATE:
	    if (fwid == 0)
		strcpy (pobuf, fmtdate (psbuf->st_mtime, popt+1, &i));
	    else
	    {
		fmtstr = getfmtstr ('s', fwid, leftjust, zerofill);
		sprintf (pobuf, fmtstr, fmtdate (psbuf->st_mtime, popt+1, &i));
	    }
	    popt += i;
	    break;
	case F_ADATE:
	    if (fwid == 0)
		strcpy (pobuf, fmtdate (psbuf->st_atime, popt+1, &i));
	    else
	    {
		fmtstr = getfmtstr ('s', fwid, leftjust, zerofill);
		sprintf (pobuf, fmtstr, fmtdate (psbuf->st_atime, popt+1, &i));
	    }
	    popt += i;
	    break;
	case F_CDATE:
	    if (fwid == 0)
		strcpy (pobuf, fmtdate (psbuf->st_ctime, popt+1, &i));
	    else
	    {
		fmtstr = getfmtstr ('s', fwid, leftjust, zerofill);
		sprintf (pobuf, fmtstr, fmtdate (psbuf->st_ctime, popt+1, &i));
	    }
	    popt += i;
	    break;
	case F_EXTENSION:	/* FALL-THROUGH */
	case F_NAME:
	case F_NAMEL:
	    ascii = basen = suffix = 0;
	    while (*(popt+1) && strchr ("abs", *(popt+1)) != NULL)
	    {
		++popt;
		if (*popt == 'a')
		    ascii = 1;
		else if (*popt == 'b')
		    basen = 1;
		else if (*popt == 's')
		    suffix = 1;
	    }
	    if (basen)	/* basename only */
	    {
		if ((ptmp = strrchr (fname, '/')) == (char *)NULL)
		    ptmp = fname;
		else
		    ++ptmp;
	    }
	    else
		ptmp = fname;
	    if (ascii)	/* show non-printing chars */
		ptmp = showname (ptmp);
	    pc = "";
	    /* HAK: don't add @ for links. We rather show ` -> ' */
	    if (suffix)
	    {	/* add trailing type char for some files */
		switch (psbuf->st_mode & S_IFMT)
		{
		case S_IFDIR:	pc = "/"; break;
		case S_IFLNK:   break;
		    /* case S_IFLNK:	pc = "@"; break; */
		case S_IFSOCK:	pc = "="; break;
	    case S_IFIFO:	pc = "|"; break;
		default:
		    if (ISEXEC(psbuf->st_mode))
			pc = "*";
		    break;
		}
	    }
	    if (fwid == 0)
	    {
		strcpy (pobuf, ptmp);
//		if (c == F_NAMEL && !suffix)
		if (c == F_NAMEL)
		{	/* add linked-to filename if a symlink */
		    if ((psbuf->st_mode & S_IFMT) == S_IFLNK
			&& (n = readlink (fname, lname, sizeof(lname))) >= 0)
		    {
			lname[n] = '\0';
			strcat (pobuf, " -> ");
			strcat (pobuf, lname);
		    }
		}
	    }
	    else
	    {
		fmtstr = getfmtstr ('s', fwid, leftjust, zerofill);
		sprintf (pobuf, fmtstr, ptmp);
	    }
	    if (*pc)
	    {  /* add type-char to end of filename */
		for (ptmp=pobuf; *ptmp; ++ptmp)
		{
		    /* why this loop ? It inserts the type char into the file name,
		     * almost deliberately. functionality with this disabled like
		     * now seems to be better.
		    if (*ptmp == ' ')
		    {
			*ptmp = *pc;
			pc = "";
			break;
		    }
		    */
		}
		if (*pc)  /* didn't find a space to add it, so add it to end */
		    strcat (pobuf, pc);
	    }
	    break;
	default:
	    fprintf (stderr, "cannot print `%%%c'\n", *popt);
	    continue;
	}

	    /* update output ptr */
	while (*pobuf)
	    ++pobuf;

    }  /* loop through print options string */

    *pobuf = '\0';
    (*sls_puts) (obuf, pf);

}  /* display */

/******************************************************************************/

char *getfmtstr (
    char   ftype,	/* format type */
    int    width,	/* field width */
    int    leftjust,	/* =1 if left-justified wanted ('%-3s') */
    int    zerofill)	/* =1 if zero-fill wanted ('%03d') */
{  /* build (user-specified) format string */
    register char  *pbuf;
    static char     buf[20];

    pbuf = buf;
    *pbuf++ = '%';
    if (ftype == 's' && leftjust)
	*pbuf++ = '-';
    else if (ftype != 's' && zerofill)
	*pbuf++ = '0';

	/* encode width here instead of sprintf - too much overhead */
    if (width > 99)
    {	/* hundred's digit */
	width %= 1000;		/* ensure a single digit for pathologic cases */
	*pbuf++ = width/100 + '0';
	width %= 100;
    }
    if (width > 9)
    {	/* tens digit */
	*pbuf++ = width/10 + '0';
	width %= 10;
    }
    *pbuf++ = width + '0';	/* ones digit */
    *pbuf++ = ftype;		/* the format char itself ('s', 'd', 'o') */

    *pbuf++ = '\0';
    return (buf);

}  /* getfmtstr */

/******************************************************************************/

char  *aperms (
    mode_t mode,	/* mode word from stat structure */
    char   *poptstr,	/* ptr to format string following %<char> */
    int    *pnmod)	/* #of chars "eaten" from format string */
{  /* return ascii representation of permission bits */
    static char    buf[20];
    register char *pbuf;
    register int   i;

    *pnmod = 0;
    pbuf = buf;
	/* get perm bits for user, group, other */
    for (i=0; i<3; ++i)
    {
	*pbuf++ = ((mode & (S_IREAD>>(i*3))) ? 'r' : '-');
	*pbuf++ = ((mode & (S_IWRITE>>(i*3))) ? 'w' : '-');
	*pbuf = ((mode & (S_IEXEC>>(i*3))) ? 'x' : '-');
	if (i == 0 && (mode & S_ISUID))
	    *pbuf = (*pbuf == 'x' ? 's' : 'S');
	else if (i == 1 && (mode & S_ISGID))
	    *pbuf = (*pbuf == 'x' ? 's' : 'S');
	else if (i == 2 && (mode & S_ISVTX))
	    *pbuf = (*pbuf == 'x' ? 't' : 'T');
	++pbuf;
    }
    *pbuf = '\0';

    if (*poptstr && strchr ("123456789", *poptstr) != NULL)
    {
	buf[0] = buf[*poptstr - '0'];
	buf[1] = '\0';
	*pnmod = 1;
    }

    return (buf);

}  /* aperms */

/******************************************************************************/

static char *showname (register char  *fname)
{  /* show non-printing chars in a filename as \ddd */
    static char     newname[200];
    register char  *pnew;

    for (pnew=newname; *fname; ++fname,++pnew)
    {
	if (isprint(*pnew = *fname))
	    continue;
	sprintf (pnew, "\\%03o", *fname);
	pnew += strlen(pnew) - 1;
    }
    *pnew = '\0';

    return (newname);

}  /* showname */

/******************************************************************************/

static char  *Wdays[] = {
    "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat" };
static char  *FWdays[] = {
    "Sunday", "Monday", "Tuesday", "Wednesday",
    "Thursday", "Friday", "Saturday" };
static char  *Months[] = {
    "January", "February", "March", "April", "May", "June",
    "July", "August", "September", "October", "November", "December" };

char *fmtdate (
    time_t          ldate,	/* system date to be formatted */
    register char  *poptstr,	/* ptr to format string following %<char> */
    int            *pnmod)	/* #of chars "eaten" from format string */
{  /* format ldate according to string in pfmt, returning ptr to static area */
    /* struct tm      *localtime(); */
    register struct tm  *ptime;
    register char   c, *padate, *pfmt, endc;
    int             i;
    static char     adate[100];

    *pnmod = 0;

	/* get components of the system date */
    ptime = localtime (&ldate);

	/* check for format string */
    pfmt = poptstr;
    endc = '\0';
    if (*pfmt == '\'' || *pfmt == '\"'){
	endc = *pfmt++;
    } else {
	/* use default date format (or environment vbl) */
	pfmt = Defdatefmt;
    }

	/* parse format string */
    padate = adate;
    while ((c = *pfmt++) != endc && c != '\0')
    {
	if (c != '%')
	{
	    *padate++ = c;
	    continue;
	}
	switch (c = *pfmt++)
	{
	  case '%':	/* "%%" - print a percent sign */
	    *padate++ = '%';
	    break;

	  case 'n':	/* "%n" - print a newline */
	    *padate++ = '\n';
	    break;

	  case 't':	/* "%t" - print a tab */
	    *padate++ = '\t';
	    break;

	  case 'm':	/* "%m" - print month of year (01 to 12) */
	    sprintf (padate, "%02d", ptime->tm_mon+1);
	    padate += 2;
	    break;

	  case 'd':	/* "%d" - print day of month (01 to 31) */
	    sprintf (padate, "%02d", ptime->tm_mday);
	    padate += 2;
	    break;

	  case 'y':	/* "%y" - print last 2 digits of year (00 to 99) */
	    sprintf (padate, "%02d", ptime->tm_year);
	    padate += 2;
	    break;

	  case 'D':	/* "%D" - print date as mm/dd/yy */
	    sprintf (padate, "%02d/%02d/%02d",
		ptime->tm_mon+1, ptime->tm_mday, ptime->tm_year);
	    padate += 8;
	    break;

	  case 'H':	/* "%H" - print hour (00 to 23) */
	    sprintf (padate, "%02d", ptime->tm_hour);
	    padate += 2;
	    break;

	  case 'M':	/* "%M" - print minute (00 to 59) */
	    sprintf (padate, "%02d", ptime->tm_min);
	    padate += 2;
	    break;

	  case 'S':	/* "%S" - print second (00 to 59) */
	    sprintf (padate, "%02d", ptime->tm_sec);
	    padate += 2;
	    break;

	  case 'T':	/* "%T" - print time as HH:MM:SS */
	    sprintf (padate, "%02d:%02d:%02d",
		ptime->tm_hour, ptime->tm_min, ptime->tm_sec);
	    padate += 8;
	    break;

	  case 'j':	/* "%j" - print julian date (001 to 366) */
	    sprintf (padate, "%03d", ptime->tm_yday+1);
	    padate += 3;
	    break;

	  case 'w':	/* "%w" - print day of week (0 to 6) (0=Sunday) */
	    sprintf (padate, "%1d", ptime->tm_wday);
	    padate += 1;
	    break;

	  case 'a':	/* "%a" - print abbreviated weekday (Sun to Sat) */
	    sprintf (padate, "%3.3s", Wdays[ptime->tm_wday]);
	    padate += 3;
	    break;

	  case 'W':	/* "%W" - print full weekday (Sunday to Saturday) */
	    sprintf (padate, "%s", FWdays[ptime->tm_wday]);
	    padate += strlen(FWdays[ptime->tm_wday]);

	  case 'h':	/* "%h" - print abbreviated month (Jan to Dec) */
	    sprintf (padate, "%3.3s", Months[ptime->tm_mon]);
	    padate += 3;
	    break;

	  case 'F':	/* "%F" - print full month (January to December) */
	    sprintf (padate, "%s", Months[ptime->tm_mon]);
	    padate += strlen(Months[ptime->tm_mon]);
	    break;

	  case 'r':	/* "%r" - print time in AM/PM notation */
	    i = ptime->tm_hour;
	    if (i > 12)
		i -= 12;
	    sprintf (padate, "%02d:%02d:%02d %2.2s",
		i, ptime->tm_min, ptime->tm_sec,
		ptime->tm_hour >= 12 ? "PM" : "AM");
	    padate += 11;
	    break;

	  case 'E':	/* "%E" - print day of month with no padding (CFI) */
	    sprintf (padate, "%d", ptime->tm_mday);
	    padate += (ptime->tm_mday > 9 ? 2 : 1);
	    break;

	  case 'x':	/* "%x" - print date in system format (#seconds) */
	    sprintf (padate, "%ld", (long)ldate);
	    padate += strlen (padate);
	    break;

	  case 'X':	/* "%X" - print date in system format, days only */
	    sprintf (padate, "%ld", (long)ldate/(60*60*24));	/* secs/day */
	    padate += strlen (padate);
	    break;

	  default:
	    *padate++ = '%';
	    *padate++ = c;
	    *padate++ = '?';
	    break;
	}
    }

    if (c != endc)
	fprintf (stderr, "malformed date string\n");

    *padate = '\0';
    if (endc != '\0')		/* need to return #chars in format string */
	*pnmod = pfmt - poptstr;
    return (&adate[0]);

}  /* fmtdate */

/******************************************************************************/

static struct  uids {
	uid_t   u_id;
	char *u_name;
} uids[MAXUIDS];

char *getpwname (uid_t  uid)
{  /* get user name from passwd file */
    static int  nuids = 0;
    static int first = 1;
    register int  i;

    struct passwd  *pw; /* , *getpwuid(); */

    for (i=0; i<nuids; ++i)
	if (uids[i].u_id == uid)
	    return (uids[i].u_name);

    if (nuids == MAXUIDS)
    {
	if(first){
	    first = 0;
  	    fprintf (stderr, "UC: too many user names (max=%d)\n", MAXUIDS);
	}
	return ((char *)NULL);
    }

    /* add new user name */
    uids[nuids].u_id = uid;
    if ((pw = getpwuid(uid)) == (struct passwd *)NULL)
	uids[nuids].u_name = (char *)NULL;
    else
	uids[nuids].u_name = copystr (pw->pw_name);
    return (uids[nuids++].u_name);

}  /* getpwname */

/******************************************************************************/

static struct gids {
	gid_t g_id;
	char *g_name;
} gids[MAXGIDS];

char *getgrname (gid_t gid)
{  /* get user group name from group file */
    static int    ngids=0;
    static int first = 1;
    register int  i;
    struct group *gr; /* , *getgrgid(); */

    for (i=0; i<ngids; ++i)
	if (gids[i].g_id == gid)
	    return (gids[i].g_name);

    if (ngids == MAXGIDS)
    {
	if(first){
	    first = 0;
	    fprintf (stderr, "UC: too many group names (max=%d)\n", MAXGIDS);
	}
	return ((char *)NULL);
    }

	/* add new group name */
    gids[ngids].g_id = gid;
    if ((gr = getgrgid(gid)) == (struct group *)NULL)
	gids[ngids].g_name = (char *)NULL;
    else
	gids[ngids].g_name = copystr (gr->gr_name);
    return (gids[ngids++].g_name);

}  /* getgrname */

/******************************************************************************/

static char *copystr (char  *str)
{  /* Allocate space for a string, copy it, and return ptr to new space */
    if(!str) return NULL;
    char  *p;
    p = strdup(str);
    if(p){
	return p;
    } else {
	fprintf(stderr, "dk.C: copy: out of memory.");
	exit(-1);
    }
    //return (p);
}

