/* "system.h": system specific stuff */

#ifndef SYSTEM_H
#define SYSTEM_H

#ifdef _AIX
#   define AIX
#   define NAME_MAX FL_PATH_MAX
#   include <sys/time.h>        // for gettimeofday.
#   define MAXNAMELEN MAXPATHLEN	// for AIX4.1
extern "C" {
//int gethostname(char *, int);
//int gethostid();
//AIX4.1 has gettimeofday
//int gettimeofday(struct timeval *tp, struct timezone *);
}
#endif

#ifdef sun    // not __sun
#   define SUN
#   define NAME_MAX FL_PATH_MAX

//#   define SOLARIS
#   ifdef SOLARIS 
#       include <sys/time.h>
#       include "scandir.h"
//        extern "C" int gettimeofday(struct timeval *tp, struct timezone *);
// gettimeofday is part of Solaris2.4 (missing in 2.3)
        extern "C" long gethostid(void);
        extern "C" int gethostname (char *name, int namelen);
#       define MAXHOSTNAMELEN 256

#   else
#       define NO_TEMPLATE
#	define SUNOS
#	define MAXNAMELEN MAXPATHLEN
        typedef unsigned long ulong;
#   endif

#endif

#ifdef __sgi
#   define SGI        // also def'd if Irix4 is on.
//#   define SGI_IRIX4  // conditional.
//#   define SGI_IRIX6  // conditional.
#define SGI_IRIX62
#ifdef SGI_IRIX4
extern "C" long gethostid(void);
#endif
#endif

#ifdef __hpux
#   define HPUX
#   define HP
#   define NAME_MAX FL_PATH_MAX
#   define MAXNAMELEN MAXPATHLEN
extern int gethostid(void);
typedef unsigned long ulong;
#endif

// DEC defines __alpha, but that conflicts with Linux-Alpha.
// So, use DEC_ALPHA instead.
#ifdef DEC_ALPHA
extern "C" int gethostid(void);
// OSF 4.0 needs this:
#   define MAXNAMELEN MAXPATHLEN
#endif

// UnixWare defines __USLC__, but let's use the -D flag.
#ifdef UNIXWARE
#   define MAXHOSTNAMELEN 256
typedef unsigned long ulong;
extern "C" {
int gethostid();
int gethostname(char *, int);
}
#endif

#if !defined(UNIXWARE) && !defined(SINIX) && !defined(SCO) && !defined(LINUX_GLIBC2)
// darn UnixWare doesn't have this (most others do):
#include <osfcn.h>
#endif

#ifdef SINIX
#       define MAXHOSTNAMELEN 256
#endif

#ifdef SCO
extern "C" {
//int gethostname(char *, int);
//int gethostid();
}
#   include <sys/time.h>        // for gettimeofday.
int gettimeofday(struct timeval *tp, struct timezone *);

#   define  MAXPATHLEN 1024
#   define MAXNAMELEN MAXPATHLEN
#   define NAME_MAX FL_PATH_MAX
#   define MAXHOSTNAMELEN 256
#   define S_IFSOCK 0140000
#endif

#ifdef LINUX
#   include <sys/param.h>
#   define MAXNAMELEN MAXPATHLEN
#endif

#if defined(FREEBSD) || defined(OPENBSD) || defined(NETBSD)
#   define GENERICBSD       
#endif

#ifdef GENERICBSD
#   define MAXNAMELEN MAXPATHLEN
    typedef unsigned long ulong;
#endif

/* future support
// V4.3 defines __ultrix
#ifdef __ultrix
#endif
*/

#if !defined(SGI)
extern void sginap(unsigned long nap_ticks);
#endif

#endif
