
#ifndef TREE_FORMS_AUX_H
#define TREE_FORMS_AUX_H

#include "forms.h"
#include "resource.h"

extern int
    tree_source_colour,
    tree_target_colour,
    tree_visible_flag,
    tree_ww,
    tree_wh,
    tree_wx,
    tree_wy
;

extern char
    tree_new_target_dir[]
;

void tree_form_help_func   (void);
void tree_close_form       (void);
void tree_iconify          (void);
void tree_uniconify        (void);
void tree_show_form        (void);
void tree_create_the_forms (void);
void tree_save_defaults    (ofstream &ofile);
void tree_sync_defaults    (void);   // after loading. 
void tree_sync_to_target_browser(void);

const char *tree_get_path	(void);

int  conditional_tree_dump (void);   // output database if changed and flag.

int tree_load_default(
    const char *obj_tok, 
    const char *name_tok, 
    const char *val_tok
);

// show and loop:
int do_tree_new_target(void);

// just show:
void do_tree                   (int tree_target_mode_flag = FALSE);
void tree_reshape              (void);
void tree_form_sync            (void);
void tree_set_complete_wintitle(void);

class tree_node_c;
tree_node_c *tree_construct_path(const char *path, int reshape_flag = TRUE);

// hides the last component of the path, if it is visible. for deleting directories.
// Returns wether reshape still necessary.
int tree_delete_path(const char *path, int reshape_flag = TRUE);

// for renaming/moving directories. Returns wether reshape still necessary.
int tree_move_path2dir(const char *source_path, const char *target_dir,  int reshape_flag = TRUE);
void tree_rename_path(const char *source_path, const char *target_path);

// external drag and drop track & get: (NULL if none below).
const char *tree_xdnd_track(FL_Coord mx, FL_Coord my);

int tree_handle_free(FL_OBJECT *obj, int event, FL_Coord x, FL_Coord y, int key, void *xev);

// operation functions for toolbox and fkeybar:
void
	TreeCenterCB	(FL_OBJECT *, long),
	TreeCollapseCB	(FL_OBJECT *, long),
	TreeEnterKeyCB	(FL_OBJECT *, long),
	TreeExpandCB	(FL_OBJECT *, long),
	TreeHomeCB		(FL_OBJECT *, long)
;

void
	tree_end		(void),
	tree_page_down	(void),
	tree_page_up	(void),
	tree_down_arrow	(int override = FALSE),
	tree_up_arrow	(int override = FALSE),
	tree_left_arrow	(void),
	tree_right_arrow(void)
;

void
    tree_copy     (void),
    tree_delete   (void),
    tree_duplicate(void),
    tree_edit     (void),
    tree_mkdir    (void),
    tree_move     (void),
    tree_rename   (void),
    tree_view     (void)
;
#endif




