// converted using sed 's/.*/"&",/'.
// 01234567879012345678790123456787901234567879012345678790123456787901234567 70
const char *tutorial_help_text[] = {
"",    
"",    
"                          The Unix Cockpit Tutorial",
"                      Henrik Klagges (henrik@klagges.com)",
"                    This manual is intended for online use.",
"                                Nov 6th, 2000",    
"",    
"",
"",
"",
"Contents",
"",
"1     First Steps",
"1.1     Introduction",
"1.1.1     Basics",
"1.2     Navigating the File System",
"1.2.1     Good old `cd' still works",
"1.2.2     Use of Arrow-Keys and cd-Shortcuts",
"1.2.3     Setting Source, setting Target",
"1.3     Advanced Navigation with Tree and Stack",
"1.3.1     The Directory Stack",
"1.3.2     Changing Directory with the Tree",
"1.4     Any Operation you like",
"1.4.1     Copy and Copy-Rename",
"1.4.2     Duplicate",
"1.4.3     Rename",
"1.4.4     Delete",
"1.4.5     Move",
"1.5     The Quick Editor",
"1.5.1     Emacs-like Shortcuts",
"1.5.2     Usage Tips"
"",
"2     Next Steps",
"2.1     Make is Powerful",
"2.1.1     Using the Menu",
"2.1.2     Changing the Menu",
"2.2     Getting More from your Shell",
"2.2.1     Using the Shell from within a Browser",
"2.2.2     Selection Forwarding",
"2.2.3     Shell and Tree Operation",
"2.3     A Tree Cookbook",
"2.3.1     Collapse and Expand",
"2.3.2     Hints",
"2.4     Seeing what you want, how you want",
"2.4.1     Display Options",
"2.4.2     Sort Options",
"2.4.3     Filters",
"2.4.4     Browser Column Menus",
"2.5     A Bunch of small Hints",
"2.5.1     Menu's aren't for the Mouse alone",
"2.5.2     If you talk GNU Emacs, you talk UC",
"2.5.3     For each File's Extension, an Action",
"2.5.4     Fast Jumping between Tree and Browser",
"2.5.5     More Ways to select",
"2.5.6     UC's Mini-Window Manager",
"2.6     Troubleshooting",
"2.6.1     My Browser is not up-to-date !",
"2.6.2     Some Keys don't work !",
"2.6.3     My Window Positioning is wrong !",
"",
"",
"                            CHAPTER 1: First Steps",
"",
"                              1.1 Introduction",
"",
"This tutorial is a collection of simple first steps for working with the ",
"Unix Cockpit (UC), in addition to the online, context-sensitive help system.",
"(hint: try F1-Help right now!) To understand what is said, you have to run UC",
"on a X11 terminal next to this document and physically do most of the indivi-",
"dual steps. It helps if you do at least the first few sections sequentially,",
"later you can go exploring. Each section is self-contained and should be do-",
"able in a short time (10-60 minutes), so things should progress quickly. The",
"whole point of UC is to make your life easier, so I tried to make the",
"instructions easy, too ! Please mail your comments to henrik@klagges.com.",
"",
"1.1.1 Basics",
"",
"If you've never seen UC (or similar programs like the PC Norton Commander)",
"before, and if there is nobody around to answer the first questions, here's",
"a nutshell explanation what it is all about. ",
"",
"UC is a multi-window file manager made from three key components: one or",
"more browsers, a shell window, and a directory tree.",
"",
" o  A browser, with its sorted list of files, is a view into a directory.",
"    One browser is the current or _source_ browser, the focus of file",
"    activities like renaming or deleting. A second browser can be the",
"    the _target_ browser, whose directory is used as target for binary",
"    operations like copy and move (which copy from a _source_ to a _target_).",
"    Files in a browser can be _selected_, that is marked as group to be",
"    worked with.",
"",
" o  The tree visualizes the large Unix directory hierarchy (file system). It",
"    allows for quick navigation and overview. Instead of or together with the",
"    target browser, it can also be used to specify a target directory if",
"    necessary. It doesn't visualize the complete file system, which would be",
"    unhandy. Rather, you can grow and prune it to taste.",
"",
" o  The shell is your preferred shell running in a window, but with a twist.",
"    It and the source browser change directory together, and you can transfer",
"    the browsers list of selected files to it (among other handy things).",
"    Thus, UC becomes in effect upward-compatible with your shell. ",
"     ",
"Important extra functionality is added via a customizable `Make'-submenu ",
"system, which allows you to organize and wire any Unix command to your",
"fingertips. Last not least, UC also has a nice builtin editor.",
"If you don't know what to do in a given situation, remember that `Meta-F1' ",
"starts context sensitive help, which is available in almost all ",
"situations. As you do this tutorial online, also remember that `Ctrl-1'",
"will get you to browser 1, while `Escape-1' will bring you to editor 1,",
"which is _this_ window. With these shortcuts you can switch quickly between",
"them.",
"",
"In this tutorial, `Meta-F1' means any one of the combinations `Ctrl-F1' and",
"`Alt-F1'. UC supports both modifiers, Alternate and Control, internally.",
"The reason for this is that window managers like Fvwm tend to attach special",
"meanings to the function key combinations. So, if your WM eats `Ctrl'-",
"function keys, use `Alt' instead and vice versa. If your WM eats `Ctrl' and",
"`Alt', you might have to reconfigure your WM. Alternatively, you can use the",
"mouse to press the function keys on UC's function key bar together with ",
"`Ctrl' or `Alt' on the keyboard.",
"",
"UC also supports `Escape' as a replacement for `Ctrl' and `Alt' in most",
"cases. For example, `Escape-F1' opens the global help window. This new",
"feature of UC 2.0 is bit of a compromise, because `Escape' is used for",
"other UC functions as well, but at the end of the day gives the users ",
"on different platforms more flexibility.",
"",
"",
"                      1.2 Navigating the File System",
"",
"",
"UC makes walking around the file system fast and easy. Here's how. (It's",
"supposed that you have at least one browser and the shell window open).",
"",
"1.2.1 Good old `cd' still works",
"",
"Type `cd / <Enter>' in the shell or browser window. Shell _and_ browser will",
"change to the root directory. Type `cd <Enter>' with no arguments. You will",
"be back in your home directory. Also try other variations like `cd ..' or",
"`cd /usr/bin'.",
"",
"Note that you can type these commands both directly into the shell (the mouse",
"pointer over the shell window) and indirectly via the browser. These examples",
"show that the good old `cd' command still works, and how it is integrated",
"with UC's browsers.",
"",
"1.2.2 Use of Arrow-Keys and cd-Shortcuts",
"",
"Suppose you want to `cd' to your home directory, but don't have a shell",
"window open so that you can't type straight `cd'. Just press `ctrl-home'",
"instead, it does the same. Then, press the `leftarrow key'. It will bring you",
"one directory up. Now, press the cursor or keypad `rightarrow' key. It will",
"bring you one directory back down. If your current line is not located on a",
"subdirectory, pressing the rightarrow key will make it jump to the next one",
"- if any - in the browser's file list. Pressing `Enter' (or doubleclicking",
"the left mouse button) on a directory also changes into it. For example,",
"press `Enter' while being located on the `..'-directory (Unix's symbol for",
"the current directory's parent). You will change one directory up.",
"Arrow keys and `Enter' are best if you walk around a group of neighbouring",
"directories a lot.",
"            ",
"1.2.3 Setting Source, setting Target",
"",
"To set a browser source, click the mouse in its window, or press `TAB' a few",
"times now to cycle through the browsers. Note how, in the case of 2 browsers,",
"the target browser is adjusted together with the source browser. Press `F2'",
"and select `Action->Clone' from the menu. Because there are three browsers",
"now,  the target browser is _not_ adjusted while you cycle forward with `TAB'",
"and backward with `shift-TAB'. Now press `ctrl-t' to set a browser target,",
"cycle with `TAB' and press `ctrl-t' again. ",
"",
"Next, press `ctrl-1'. Note how the browser with ID 1 in its window title is",
"set source. Press `ctrl-2' and `ctrl-3' to see the other browsers again",
"(this is most useful if you have many browsers open, and tabbing through",
"them is too slow). Finally, use `F2->Action->Kill' to get rid of the third",
"browser. Press `TAB' again once to see the automatic target adjustment again.",
"",
"",
"             1.3 Advanced Navigation with Tree and Stack",
"",
"",
"File systems and the associated directory trees are big, often _too_ big to",
"walk around in small steps. UC has two extra mechanisms to deal with this,",
"one for keeping a stack of interesting directories to go to, and one for a",
"fast global overview of the tree.",
"",
"1.3.1 The Directory Stack",
"",
"Like many shells, UC has a directory stack accessible via the `F2-directory'",
"browser menu entry. Change into some directory like `/usr/bin/X11'. (It is",
"possible that it doesn't exist on your system, but that's unlikely). Now get",
"the browser menu (via `F2' or the mouse), and select the `Directory' entry.",
"From the now-appearing submenu, press `Remember' to put the current directory",
"into UC's stack. Next, change to somewhere else, for exampe via `ctrl-home'.",
"To use the remembered directory, get the browser directory submenu again, and",
"select the `Change To ...' entry. It will show a stack of directories, with",
"the last one you remembered on top. Select any directory from the stack, and",
"UC will change into it. Voila !",
"",
"The directory stack is saved and loaded with the configuration, so that you",
"can keep a permanent list of hot spots in the file system. It is best suited",
"for remembering far away directories with long names. Additionally, UC keeps",
"a history of all the directories you traversed during each session. This is",
"done automatically, without the need to press `Remember'. To use it, simply",
"get the directory menu and select the `History...' submenu entry.",
"",
"1.3.2 Changing Directory with the Tree",
"",
"Another useful option for navigation is the `F4'-directory tree. Press `F4'",
"to see a tree window with a part of your file system visualized as a tree.",
"Press `home' to scroll to the root directory at the tree top. Move the tree",
"window so that you can see the source browser. It has _not_ changed directory",
"yet ! In the tree window, press `Enter'. _Now_ the source browser is synchro-",
"nized, which is indicated by the little green light appearing next to the",
"tree's highlighted node. If you have a second (target) browser open, press",
"`ctrl-t'. It will synchronize the target browser (indicated by a little ",
"yellow light) to the tree as well.",
"",
"Press the grey keypad `+' key. If the root directory wasn't expanded yet, it",
"will be now, and you will see its subdirectories in the tree window. Use the",
"arrow keys to walk around, and occasionally synchronize with `Enter' to see",
"the contents. If you have the shell window open, type `cd /etc' while in the",
"tree window. Like when typing in the browsers, shell and tool will change",
"directory.",
"",
"Last not least, leave the tree window open but move the mouse into a browser",
"window. Change directory via `leftarrow' or `Enter'. Note how the tree",
"changes along with the browsers. If you have a target browser open, switch",
"between source and target with the `Tab'-key. Again, watch the tree while",
"doing this. When done working with the tree window, you can close it with",
"`Meta-q', iconify it or just hide it under other windows. The tree layout is",
"stored in a database, so that you don't need to rescan the file system each",
"time UC runs.",
"",
"",
"                        1.4 Any Operation you like",
"",
"",
"Although this section is a bit longer than the others, it pays to do it in",
"one go, because the later parts expect the junk files created in the first",
"ones. You should have two browsers open and know how to navigate around the",
"file system.",
"",
"1.4.1 Copy and Copy-Rename",
"",
"Let's create a few junk files to play with and learn about UC's operations in",
"the process. Change one browser to the `/usr/tmp' directory, which is good",
"for temporary stuff. Press `F3'-MakeDir and type `stuff' to create a new",
"directory `/usr/tmp/stuff'. Change into the new directory. Then, switch to",
"the other browser with the TAB-key, and change it into `/usr/bin/X11'. If",
"that directory doesn't exist, try `/usr/openwin/bin/' or `/usr/X11R6/bin' etc.",
"Position the current line (with mouse or arrow keys) on the file `xterm'. ",
"Press `F10'-Copy and confirm. The copying should proceed smoothly. Verify",
"that a new file named `xterm' is visible in `/usr/tmp/stuff'. Make sure",
"you're still using `/usr/bin/X11' as source directory and press `F10'-Copy",
"again. Confirm. Note that this time, you will be asked twice, to confirm",
"overwriting, because `xterm' already exists in the target directory. Cancel",
"overwriting. Press `ctrl-F10'-CopyRename and confirm. You'll be shown a",
"dialog that shows the `xterm' string highlighted. Type ahead and see how",
"the highlighted part is replaced completely. Cancel completely again",
"(`Escape'), and press `ctrl-F10' again (this is getting interesting :-).",
"This time, use the `rightarrow' key and note how the highlighted part is",
"kept. Just add a `2' at the end, so that the new name will be `xterm2'.",
"Confirm. The copy-rename should proceed smoothly, verify that you now have",
"both `xterm' and `xterm2' in the `/usr/tmp/stuff' directory. ",
"",
"1.4.2 Duplicate",
"",
"Next, switch back (`TAB') to `/usr/tmp/stuff'. Press the grey keypad `+'-key",
"to select files. If the keypad doesn't work, use the mouse to press the ",
"`+'-button in the UC ToolBox window. You will be asked for a selection ",
"expression. Type `xterm*' and confirm. This selects all files whose name",
"starts with `xterm' and ends with anything (indicated by the asterisk `*'). ",
"Don't confuse the asterisk in the selection expression with the trailing",
"asterisks shown after the `xterm'-files.",
"Those are file type indicators for executable files. For comparison, look at a",
"directory and note the trailing slash (`/'), which indicates directory type).",
"Both `xterm' and `xterm2' should be highlighted. Then, press `F9'-Duplicate.",
"You'll be asked wether you want to duplicate the 2 files. Confirm. When asked",
"to duplicate `xterm', give `xterm3' as new name. For `xterm2', supply `xterm4'.",
"Verify that you now have 4 `xterm'-files in `/usr/tmp/stuff'. ",
"",
"Press `leftarrow' to change a directory up. You'll be in `/usr/tmp', with the",
"current line positioned on `stuff'. Press `F9'-Duplicate again. Confirm and",
"supply a new name (like `stuff2'). You'll be asked again to confirm duplica-",
"tion, because `stuff' is a directory. Confirm. ",
"",
"1.4.3 Rename",
"Change into `stuff2' and position the current line on `xterm'. Press",
"`F7'-Rename and change the name to `xterm2'. Confirm. You'll be",
"prompted again to overwrite because `xterm2' already exists. Confirm.",
"Verify that only three files are left in `stuff2'. ",
"",
"1.4.4 Delete",
"",
"Still in `stuff2', press the grey keypad `+'-key. You will be prompted for a",
"selection expression, with the default being the one you used last. In this",
"case, that's ok, so confirm. All `xterm'-files should be highlighted (again,",
"don't confuse selection expression with trailing asterisks).",
"",
#ifdef DEC_ALPHA
"Press `F13'-Delete. Confirm the delete. Note that for confirming delete, the",
#else
"Press `F11'-Delete. Confirm the delete. Note that for confirming delete, the",
#endif
"default button is `Cancel' (use `leftarrow' and `rightarrow' to switch",
"between the buttons). Now, `stuff2' should be empty. Use `leftarrow' to",
"change one directory up. Make sure the current line is positioned on `stuff2'.",
#ifdef DEC_ALPHA
"Press `F13'-Delete and confirm the delete. Although `stuff2' is a directory,",
#else
"Press `F11'-Delete and confirm the delete. Although `stuff2' is a directory,",
#endif
"you will not be asked twice for deletion, because it is an empty directory. ",
"",
"Use duplicate trice to duplicate `stuff' again. Name the copies `stuff2',",
"`stuff3' and `stuff4'. Press the grey keypad `+'-key and supply `stuff?' as",
"selection expression. All filenames that start with `stuff' and have exactly",
"one arbitrary more trailing character will be selected, in this case the ",
#ifdef DEC_ALPHA
"three `stuff''s with digits. Press `F13'-Delete and confirm. Now you will see",
#else
"three `stuff''s with digits. Press `F11'-Delete and confirm. Now you will see",
#endif
"a new dialog that shows you a question (file stuff2 is a non-empty directory.",
"Really delete ?) and _four_ options. You can cancel the complete operation,",
"cancel deletion for this particular directory, confirm deletion of this",
"particular directory, or confirm deletion of all directories that may remain",
"in this multi-delete operation. Note that you are _only_ asked for this extra",
"confirmation because the `stuff''s are directories and therefore treated",
"specially by UC (for normal files, you wouldn't be asked again for confir-",
"mation). In this case, press the `Do Delete'-button. You will be prompted",
"again for `stuff3'. Press the `Delete ALL'-button. Note that you're not",
"prompted again for `stuff4'. ",
"",
"Be warned to be careful with Delete, you can do significant damage quickly",
"if you don't check what you remove. Especially if you work on a selection of",
"files, you may have accidentally selected (or left selected from a previous",
"operation !) files you don't want to loose. ",
"",
"1.4.5 Move",
"",
"With the target browser set to `/usr/tmp/stuff', change the source browser to ",
"`/usr/bin/X11' again. With the grey keypad `+'-key, supply an asterisk (`*',",
"that is everything) as a selection expression and confirm. All files in",
"`/usr/bin/X11' should be highlighted. Press `F10'-Copy and confirm. While",
"this operation proceeds, watch its progress. After a couple of files are",
"copied, press `Escape'. The copying will be interrupted.",
"									",
"Next change the source browser from `/usr/bin/X11' to `/usr/tmp'. `F3'-MakeDir",
"a new directory `stuff2'. Change into it. Then, use `TAB' to switch to the",
"other browser in `/usr/tmp/stuff', where all the copied files are located.",
"Use the keypad `+' to select all files. Press `F8'-Move to move all files",
"from `/usr/tmp/stuff' to `/usr/tmp/stuff2'. Use `TAB' to switch browsers,",
"select all again and press `ctrl-F8'-MoveRename to move them all back.",
"Supply a new name to the first file, then cancel the operation to save you",
#ifdef DEC_ALPHA
"time. Finally, change up to `/usr/tmp' and use `F13'-Delete to clean up the",
#else
"time. Finally, change up to `/usr/tmp' and use `F11'-Delete to clean up the",
#endif
"junk directories `stuff' and `stuff2'. Note that you now deleted the direc-",
"tory `/usr/tmp/stuff' that the target browser was in. Use `TAB' to switch ",
"into the browser. You will get an error message that it couldn't change ",
"directory (it was just deleted by you). Press `leftarrow' to recover the ",
"target browser.",
"",
"In this section, you have seen how to rename, move, copy and delete single",
"or groups of files or directories. You've also seen a bit of error handling",
"and exceptional cases requiring confirmation, and how to stop an operation",
"in progress. You have been warned to be careful with delete. ",
"",
"",
"                          1.5 The Quick Editor",
"",
"",
"Since Version 2.0, UC has a built-in editor (A big thanks to Marc van Kempen",
"and Gennadi Sorokupud, who wrote mosts parts of it). It is not meant to ",
"replace the functionality behind `F6 Edit', where you can define and use",
"your favourite editor from within UC. Rather, it's an extra option available",
"if you don't like the standard Unix editors, if your favourite editor is",
"unavailable or too slow to start up for quick edits.",
"",
"1.5.1 Emacs-like Shortcuts",
"",
"The Quick Editor is using the same set of Emacs-like shortcuts that are used",
"everywhere in UC. So, `Ctrl-n' (next), `Ctrl-p' (previous) scroll a line ",
"down or up, `Ctrl-v' and `Alt-v' scroll a page down or up and `Alt->' and",
"`Alt-<' go to the end or the beginning of the file. As an extension to the ",
"scroll commands used in the browser, the editor uses `Ctrl-a' and `Ctrl-e'",
"to jump to the beginning or end of the current line. As expected, `Ctrl-s'",
"is used for incremental searching. In order to work with window managers",
"that take up all the `Alt'-key combinations for themselves, UC also supports",
"`Escape-v', `Escape->' and `Escape-<' as replacements for the `Alt'-commands.",
"",
"1.5.2 Usage Tips",
"",
"1. For X-Window cut & paste, use left mouse-dragging for selection and ",
"   middle mouse to paste. These functions are also available under the",
"   `Edit'-menu, which is great for moving, copying or deleting blocks ",
"   of text.",
"",
"2. The shortcuts for cut, copy and paste are `Meta-x', `Meta-c' and `Meta-y'",
"   (yank). This is inconsistent with other shortcut schemes like the one ",
"   from Apple Macintosh-computers, which require `Alt-v' for pasting/ ",
"   yanking. However, UC has always used `Alt-v' and `Ctrl-v' as synonyms for",
"   `PageUp' and `PageDown'. UC will continue to do so to stay consistent with ",
"   itself and Emacs. ",
"",
"3. The editor window can be extensively customized in fonts and colours via",
"   the `F2->Options' menu. If you have multiple editor windows open, each ",
"   one can be configured separately, and all it's attributes (including",
"   window size and position) are remembered in the `ucdb' database.",
"",
"4. To switch from the editor to a browser, you can use the `Ctrl-ID'",
"   shortcut to access the browser with the given ID. A similar fast access ",
"   shortcut for the editor is to use `Alt-ID' or `Escape-ID'. This is",
"   particularly useful if you have many browsers and editors open at the ",
"   same time.",
"",
"5. UC can have multiple Editor windows open for the same file, but it",
"   doesn't communicate the changes between the windows. This can leave you",
"   with an inconsistent file after the editor windows are closed. Therefore,",
"   UC warns you when you want to edit a file more than once.",
"",
"6. The editor is best suited for small to medium text files up to 1MB. It",
"   won't work well on binary files yet.",
"",
"",
"                            CHAPTER 2: Next Steps",
"",
"                             2.1 Make is Powerful",
"",
"A whole new world of options and customizability is hidden behind the browser ",
"menu's make submenu. It allows you to wire in arbitrary unix command scripts ",
"into UC and to execute them with or without arguments. ",
"",
"2.1.1 Using the Menu",
"",
"Create yourself a few normal junk files (non-directories), then select them",
"with the middle mouse button. Press `F2' and select `Make->packer->compress'",
"from the browser menu. Confirm `make compress' to compress the selected files,",
"which will get the `.Z' extension. Next, select these `.Z'-files and uncompress",
"the files using `F2->Make->packer->uncompress'. ",
"",
"Change to your home directory (`ctrl-home'). Remember the name of a file ",
"that's somewhere in or below this directory. Select `F2->Make->find->file' ",
"next. You will be asked for an argument, supply the name you remembered. ",
"Confirm. You'll see an output window where `find' looks for all filenames",
"that contain that name string. ",
"",
"These examples show that you can call complex commands with I/O from",
"within UC.",
"",
"2.1.2 Changing the Menu",
"",
"The make submenu structure is not fixed, but stored in a makefile named ",
"`ucmk' in your UC configuration directory (typically /usr/local/lib/uc or a ",
".uc-subdirectory of your home). It contains the targets that you see as menu ",
"entries and the commands you want to execute when the menu entry is chosen. ",
"It also defines the menu shortcuts. The file contains detailed instructions ",
"how to change it (make a backup copy). A typical menu entry is defined as ",
"follows:",
"",
"hello:    #h",
"        xterm -title Hello &",
"",
"Here, `hello' will appear in the menu, `h' is the shortcut,and `xterm ...' ",
"is the command to be executed when you select the `hello'-menu entry. Note ",
"the ampersand (`&') used to background this command, you don't want UC to ",
"wait for `xterm' to finish. A submenu is defined via an underscore in the ",
"target name:",
"",
"packer_compress:    #p c",
"",
"Here, `compress' is used with the shortcut `c' in the submenu `packer' with ",
"the shortcut `p'. There is one peculiarity about Unix make that makes life ",
"harder: The whitespace before the `xterm'-command _must_ be TAB's, it cannot ",
"be blanks. Be careful when cutting and pasting from one makefile into ",
"another, often the TAB's get converted to blanks and will invalidate the new ",
"makefile ! ",
"",
"",
"                       2.2 Getting More from your Shell",
"",
"",
"For most practical purposes, UC is upward compatible with your shell. It also ",
"adds a few extensions explained below, for which it is assumed that you have",
"a browser and the shell open.",
"",
"2.2.1 Using the Shell from within a Browser",
"Position the mouse pointer over a browser and type `ls <Enter>'. The command ",
"is forwarded and executed in the shell. Now press `Enter' again - it is _not_ ",
"forwarded to the shell, but used to activate the current file in the browser ",
"instead (cancel the activation in this case). This is because UC knows that ",
"the shell command line is empty, and no `Enter' is needed. ",
"",
"To force an `Enter' in the shell, either move the mouse into the shell ",
"window, or press `ctrl-Enter' now. This is useful if you run an interactive",
"program in the shell that wants an `Enter' which UC can't know about. It's ",
"usually not a good idea to run interactive programs in the shell, because ",
"they will get the directory string as input if you change directory with the ",
"browser. Either finish the interactive program before contining with UC, or",
"use an extra shell window to run it in (via `xterm &', for example). Note",
"that you can also force a TAB to the shell, via `ctrl-TAB'.",
"",
"2.2.2 Selection Forwarding",
"",
"Suppose you want to execute a command on the selection of files in the UC ",
"source browser. If you use the command often, you would put it into the UC ",
"makefile. To do it just once, it is possible to forward UC's selection to the ",
"shell. Use the middle mouse to select a few files in a browser. Then, type ",
"`ls ' (for simplicity, it doesn't do much). Add a blank after the `ls'. Then, ",
"still in the browser, press `Alt-f' (f for `forward'). It forwards the list of ",
"UC's files, separated by blanks, to the shell. Finally, add an `Enter' to ",
"execute. ",
"",
"This feature allows you to execute any command with arbitrary leading and ",
"trailing options on UC's selection. The only limitation is that interactive ",
"Unix shells can only deal with 256 characters on the input line. If UC's",
"selection list is too long, it forwards only complete file names to the ",
"shell, and doesn't overflow the command line.",
"",
"2.2.3 Shell and Tree Operation",
"",
"If you only need a shell and the tree for a while, iconify the browser. ",
"Typing in the tree is forwarded to the shell as it is in the browsers. So, ",
"you can use the shell as you'd always do, and just use the UC tree for ",
"overview and fast change directory.",
"",
"",
"                            2.3 A Tree Cookbook",
"",
"",
"2.3.1 Collapse and Expand",
"",
"Change to your home directory. Start up the tree with `F4'. Press `ctrl'-",
"keypad plus. You'll be asked wether you really want to rescan the complete ",
"subtree. Confirm. This will add all subdirectories below your home directory ",
"to the tree (if you have a very large home hierarchy, you can interrupt the ",
"operation using `Escape'). When done, press keypad minus and observe how the ",
"deepest sublevel below your home directory is collapsed and not displayed",
"anymore. Continue collapsing until only your home directory is left. Press ",
"the keypad plus and observe how one level is added to the tree. Press it ",
"again and observe how a second level is added (for efficiency, the first ",
"level is not rescanned if you immediately add another level). Press `ctrl'-",
"keypad minus to collapse the complete subtree (including the home directory).",
"",
"Click the middle mouse button on some unexpanded directory. It will expand ",
"one level as if you pressed keypad plus. Click the right mouse button on ",
"an expanded directory. It will collapse one level as if you pressed keypad ",
"minus. ",
"",
"2.3.2 Hints",
"",
" o The tree supports drag & drop moving of directories, as long as the move",
"   happens within the same file system. To try this, click with the left",
"   mouse button onto a directory (don't release the mouse button yet, keep",
"   it pressed). Then, drag the directory to another one. Watch how the ",
"   target directory is indicated via the little target light next to it.",
"   Also, observe the tree window title. To do the move, release the mouse",
"   button over the desired target directory. To cancel, release it in the",
"   tree background.",
"",
" o If you have very large trees (larger than the tree window), you can hold ",
"   down the left mouse button. A new arrow cursor will appear, allowing ",
"   you to shove around the tree. If your tree is too small, you can tempo-",
"   rarily make the window very small to test this feature.",
"",
" o Position the mouse in the tree. Press `ctrl-s' to activate the search ",
"   mode. Type a search string and watch how the current node is adjusted to ",
"   the search pattern. To search again after finding a match, press `ctrl-s'",
"   again. After trying this feature first, press `Escape'. The current node ",
"   is reset to the position it had before the search. Now, press `ctrl-s' ",
"   again twice. It will first put you into search mode again, then re-search ",
"   for the last string because you didn't supply a new one. This time, press ",
"   `Enter' to stop the search. The current node will be set to the matching ",
"   node, and _not_ be reset to the starting position.",
"",
" o Locate a symbolic link (visible by a string like `-> /usr/var/sbin' shown",
"   to the right of the tree node). If you find one (your tree may not show ",
"   or have any), click on the linkname. You will be positioned on the link ",
"   target, that is the directory the link really points to.",
"",
" o A good tree customized to your needs is valuable. Save it into the tree ",
"   database using the tree menu (press `F2->Database' in the tree window).",
"",
"Close the tree with `Escape' when done.",
"",
"",
"                   2.4 Seeing what you want, how you want",
"",
"",
"This section explores how to customize the file list that a browser shows ",
"you.",
"",
"2.4.1 Display Options",
"",
"Select `F2->Options->Display'. You'll get a display options window, move it ",
"so that both it and the source browser are visible. Use the `g'-shortcut to ",
"toggle the group display. Note how the group column is hidden and shown again",
"in the source browser. Press `Seconds' in the `Time Format'-group. Note how",
"the displayed modification time format now includes seconds. Play with a few ",
"more buttons. ",
"If you have more than one browser open, move the mouse into the source ",
"browser and press `TAB' to switch browsers. Note how the display options ",
"window is updated to reflect the different settings of the new source browser ",
"(to get a browser with the same settings, use clone). Press `TAB' again to",
"set the original browser source. Press `Defaults' in the display options ",
"window to restore the defaults, if desired. Use `Escape' to hide the window.",
"",
"2.4.2 Sort Options",
"",
"Select `F2->Options->Sorting'. Press the `Reverse'-button for the main sort. ",
"Note how directories will be sorted last. Press `ctrl-s' to use size as ",
"auxiliary sort. Press `ctrl-r' to to reverse the auxiliary sort and see ",
"biggest files first. Use `rightarrow' to change the return button to the",
"`Defaults' button. Press `Enter' to reset to the sorting defaults. Use ",
"`leftarrow' to change the return button to the `Close' button. Press `Enter' ",
"to hide the form.",
"",
"2.4.3 Filters",
"",
"Suppose you are in a directory where some files have extensions, like `.C' or ",
"`.o'. Press the grey keypad asterisk (`*'). You will be prompted for a ",
"filter. Press `F1' to get context sensitive help. Then, enter `*.C' (or ",
"whichever extension is used in your directory, and note the asterisk). Only ",
"files with matching the expression will be shown. Press keypad asterisk again ",
"and reset the filter to normal by entering an asterisk (`*'), which matches ",
"everything. You'll rarely need filters. ",
"",
"2.4.4 Browser Column Menus",
"",
"Position the mouse on a browser column header like `Group'. Click the left ",
"mouse button. You will see a menu specific for group information. Select the ",
"`Show Numeric ID' menu entry. Owner and group ID will be displayed numeri-",
"cally. Get the menu again and select the `hide' menu entry. The group column ",
"will be hidden (you can use `F2->Options->Display' to get it back). Press",
"Alt-g to access the group menu with its shortcut. If the group column was",
"hidden, it will be shown automagically if you access the group menu. Explore",
"the other column menus as well. ",
"",
"",
"                          2.5 A Bunch of small Hints",
"",
"",
"2.5.1 Menu's aren't for the Mouse alone",
"",
"UC's menus are not for the mouse alone. They can also be used via the ",
"keyboard. For example, press `F2' in a browser to get its menu. Then press",
"the `End'-key. The active line in the menu will be set to the last menu ",
"entry. Try `uparrow' and `downarrow' for moving up and down as well. Next, ",
"use the `o'-shortcut for the options submenu. To get back up to the parent",
"menu, press `leftarrow'. To get back down again, press `rightarrow'. To hide ",
"all menus, use `Escape'.",
"",
"2.5.2 If you talk GNU Emacs, you talk UC",
"",
"If you're an Emacs afficionado (like me), you'll be happy to hear that  it's ",
"cursor control/scrolling commands also work in UC, even in the menus. So, ",
"ctrl-n/-p scroll a line down/up, ctrl-v and alt-v a page down/up, and ",
"ctrl-a/-e to the top/end. ctrl-f/-b work like the right and left arrow keys. ",
"Also, ctrl-l centers the current line (if possible), and ctrl-s activates a ",
"search mode. The search mode works in the tree and the browsers.",
"",
"2.5.3 For each File's Extension, an Action",
"",
"UC has suffix (extension) rules for activating a file when you doubleclick it ",
"or press `Enter' on it when it's current. These rules are kept in a makefile",
"named ucsfx in your UC configuration directory (typically /usr/local/lib/uc",
"or a .uc-subdirectory of your home). You can change the rules, or add new ",
"ones. ",
"Press `ctrl-home' to change home. Find and change into the .uc subdirectory.",
"Locate the file ucsfx and press `F5'-view on it. The makefile has expla-",
"natory comment text in it that tells you how to add or deactivate it. For ",
"example, use `F2->Make->packer->compress' to compress a file. Then, double-",
"click with the left mouse button on it. It will be uncompressed, which is ",
"the rule for files with a `.Z'-extension.",
"",
"2.5.4 Fast Jumping between Tree and Browser",
"",
"Suppose you navigate around with the tree. You change into an interesting ",
"directory and look at the source browsers list of files. The list may not",
"be displayed completely in the window, or otherwise you may want to check",
"something out (for example, `F5'-QuickEdit a file). Normally, you would",
"need to either close the tree window or move the mouse - a nuisance if you",
"do it repeatedly. Just use `ctrl-1' (or `ctrl-2', etc) to jump directly from",
"tree to the browser with that ID, and use F4 to jump back to the tree.",
"",
"You can also use this feature from within the Quick Editor. To get back",
"into the editor, or to switch between multiple editor windows, use `Alt-1' or",
"`Esc-1' etc. This is particularly useful if you have many browsers and",
"editors open at the same time.",
"",
"2.5.5 More Ways to select",
"",
"You can select/deselect in many ways, not only with the middle mouse button",
"or the grey keypad `+/-'-keys. You can also use the keypad `Insert'-key to ",
"toggle the current line's selection status. Also, you can use `ctrl-Insert'",
"to _mirror_ the selection. All files that were selected will be deselected, ",
"and vice versa. The only exception, as always, will be the `.'-file (the ",
"current directory) and the `..'-file (the parent directory). They cannot be ",
"selected.",
"",
"You can also use `shift-leftmouse' to select if you don't have a three-",
"button mouse. ",
"",
"2.5.6 UC's Mini Window Manager",
"",
"UC has a small extra window, the Mini-WM, just in order to manage the ",
"many UC windows that can be open at any time. You can iconify, hide, show",
"and move all windows together. ",
"Please note that when moving windows offscreen in this way, the relative",
"positions may be lost depending on your window manager.",
"",
"",
"                           2.6 Troubleshooting",
"",
"",
"2.6.1 My Browser is not up-to-date !",
"",
"UC tries to keep track of changes happening to the browser directories, and ",
"automagically updates when it notices such a change. However, because this is",
"a very time-consuming operation, UC concentrates only on bigger changes and",
"sometimes may miss a change. ",
"Change to `/usr/tmp'. Create a empty junk file named `junk' via `touch junk' ",
"in the shell. Wait a minute. `touch junk' again. Because `junk' is already ",
"created, only it's modification time will be updated, but UC won't notice ",
"the change. Press the grey keypad slash (`/') key to force an update of the ",
"source browser directory. Note how the access time is now correct. Press ",
"`ctrl-/' to force an update of all UC browser directories.",
"",
"2.6.2 Some keys don't work !",
"",
"Most X-servers generate meaningful key symbols if you press a key on your",
"keyboard. Some don't - older Sparc Stations running SunOS 4, for example,",
"have a really hard time generating the proper KP_Subtract when you press",
"the keypad `minus'. Therefore, UC may not recognize all key symbols off all",
"keyboards. The solution is complicated, so it helps to have somebody around",
"who is knowledgeable about X11. The complexity is unfortunate, but intrinsic",
"to X11. It goes like this:",
"",
"- identify which keys don't work with UC on your system. Likely candidates",
"  are the keypad keys, and the function keys, especially F11 and F12. The",
"  cursor keys, including `home', `end' etc. can also be wrong.",
"",
"- next, use the `xev' program to check which key symbols are generated when",
"  you use the bad keys. To do this, start `xev' and move the mouse pointer",
"  into the xev window. Then, press the offending keys and observe the output",
"  from xev. It will show KeyRelease events and tell you the wrong `keysym's.",
"",
"- identify which `keysym' would be desired instead of the bad keysym's you",
"  are getting. UC expects function keys to be F1 up to F12, and the cursor",
"  keys to be `Home', `End' etc., and the keypad keys to be `KP_Home', ",
"  `KP_End', `KP_Add' etc. (You can look these up in the keysymdef.h file in",
"  the X11 include directory, typically /usr/include/X11)",
"",
"- use `xmodmap' to change your keyboard mapping. You can write a translation",
"  map file `.xmodmap'. Put it into your home directory and always load it",
"  when you start up X.",
"",
"2.6.3 My Window Positioning is wrong !",
"",
"This could be a compatibility bug in UC. EMail us your window manager and",
"system configuration, we'll look into it. It's also quite possible that you",
"have a X session manager that is buggy. In this case, try wether you can ",
"configure the session manager so that it ignores UC.",
"",
"Another reason for wrong positions is if you start UC before your window",
"manager. The reason for this is that UC needs to query the window manager",
"how it (the wm) redirects positioning and move requests. If the wm isn't",
"running yet, UC can't get this information and will be wrong once the wm",
"starts running.",
"",
"",
"This is the end of the Unix Cockpit Tutorial. More sections will be added",
"over time.",
"",
"Please email suggestions, especially criticisms or any other comments to",
"me at henrik@klagges.com. If you find a bug or want a new feature, let me",
"know, so that I can do something about it.",
"",
"<< END.",
0
};    
