
#include <iostream.h>
#include <locale.h>
#include <new.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>     // atoi.
#include <string.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <time.h>

#include "forms.h"

#include "action_forms.h"
#include "action_forms_aux.h"
#include "browser.h"
#include "browser_menu.h"
#include "cb.h"
#include "cb_fkey.h"
#include "client_msg.h"
#include "colour_forms_aux.h"
#include "crash_forms_aux.h"
#include "dir_menu.h"
#include "display_forms_aux.h"
#include "edit_colour_forms.h"
#include "edit_forms_aux.h"
#include "error_notifier_forms_aux.h"
#include "file_utility.h"
#include "fkeybar_forms_aux.h"
#include "flspecial.h"
#include "ghelp_forms_aux.h"
#include "global.h"
#include "gl_utility.h"
#include "help_forms_aux.h"
#include "help_text.h"
#include "license_forms_aux.h"
#include "options_forms_aux.h"
#include "pathnames.h"
#include "sort_forms_aux.h"
#include "status_forms_aux.h"
#include "toolbox_forms_aux.h"
#include "tree_colour_forms_aux.h"
#include "tree_forms_aux.h"
#include "utility.h"
#include "wm_forms_aux.h"
#include "xshell.h"
#include "xshell_forms.h"

#ifdef SGI_IRIX4
#include <getopt.h>
#endif

#ifdef BETA
static int export_flag = FALSE;
#else
static int export_flag = FALSE;
//static int export_flag = TRUE;
#endif

void create_all(void){
    M_info2("create_all", "start");
    action_create_the_forms();
    colours_create_the_forms();
    crash_create_the_forms();    
    display_create_the_forms();
    edit_colour_create_the_forms();    
    error_notifier_create_the_forms();
    fkeybar_create_the_forms();
    ghelp_create_the_forms();
    help_create_the_forms();
    license_create_the_forms();
    options_create_the_forms();
    sort_create_the_forms();
    status_create_the_forms();
    toolbox_create_the_forms();
    tree_colour_create_the_forms();
    tree_create_the_forms();
    wm_create_the_forms();
    xshell_create_the_forms();
}

void callback_loop_init_cb(FL_OBJECT *, long) {
    //set_explain_version();
    M_info("global::", "set_new_user_intro.");
    if(tool_looser_flag){
	if(ask_question(FALSE, "Would you like information for new users ?")){
	    load_help_browser(new_user_info, "New User Introduction", "Tutorial", do_tutorial);
 	    // create database _now_ so that we don't get asked again all the time!
	    tool_defaults_save(NULL);
	}
    }
    status_msg(1, "Open Source UC Version %s.%s for %s", version_major, version_minor, version_os);
}

/* useful for getting rid of the shell. 
 * Doesn't work in all cases, e.g. Kill. Reparenting would be
 * better.
 */
#if defined(GENERICBSD) || defined(HP) || defined(LINUX) || defined(DEC_ALPHA) || defined(AIX) || defined(SOLARIS) || defined(UNIXWARE) || defined(SGI_IRIX62) || defined(SCO) || defined(SINIX)
static void sigint_proc(int){
#elif defined(SGI_IRIX6)
static void sigint_proc(...){
#else
static void sigint_proc(int, ...){
#endif
    //cerr << "SIGINT.\n";
    int count = get_edit_changed_count();
    tool_ctrl_on_flag = (count == 0);
    ExitButtonCB(NULL, 0);
}

#if defined(GENERICBSD) || defined(HP) || defined(LINUX) || defined(DEC_ALPHA) || defined(AIX) || defined(SOLARIS) || defined(UNIXWARE) || defined(SGI_IRIX62) || defined(SCO) || defined(SINIX)
static void sigsegv_proc(int){
#elif defined(SGI_IRIX6)
static void sigsegv_proc(...){
#else
static void sigsegv_proc(int, ...){
#endif
    static int first = TRUE;
    fprintf(stderr, "UC: memory error. Sorry ! Mail to henrik@klagges.com and complain :)\n");
    if(first){
	crash_show();
	first = FALSE;
    }
    if(export_flag){
	exit(-1);
    } else {
	abort();
    }
}

#if defined(GENERICBSD) || defined(HP) || defined(LINUX) || defined(DEC_ALPHA) || defined(AIX) || defined(SOLARIS) || defined(UNIXWARE) || defined(SGI_IRIX62) || defined(SCO) || defined(SINIX)
static void sigbus_proc(int){
#elif defined(SGI_IRIX6)
static void sigbus_proc(...){
#else
static void sigbus_proc(int, ...){
#endif
    static int first = TRUE;
    fprintf(stderr, "UC: bus error. Sorry ! Mail to henrik@klagges.com and complain.\n");
    if(first){
	crash_show();
	first = FALSE;
    }
    if(export_flag){
	exit(-1);
    } else {
	abort();
    }
}

static void init_mask(void){
    static int first = TRUE;
    if(first){
	first = FALSE;
	mode_t tmp_mask = umask(0);    // get.
	mkdir_mode_mask = (S_IRWXO | S_IRWXG | S_IRWXU) & ~tmp_mask;
	umask(tmp_mask); // set again.
	/*
	cerr << "org mask: " << mkdir_mode_mask << endl;
	cerr << "tmp mask: " << tmp_mask << endl;
	cerr << "mkdir mask: " << mkdir_mode_mask << endl;
	cerr << "set ret:  " << umask(tmp_mask) << endl; // set again.
	cerr << "2nd ret:  " << umask(tmp_mask) << endl; // set again.
	*/
    }
}

extern "C" void fl_show_errors(int);

static void tool_init(void){
    M_info("tool_init", "start");
    char buf[1024];
    if(export_flag){
	signal(SIGBUS,  sigbus_proc);
	signal(SIGSEGV, sigsegv_proc);
    }
    signal(SIGINT,  sigint_proc);
    fl_show_errors(!export_flag);
    init_mask();
    // try to have our own process group (for killing).
    // setpgid(getpid(), getpid());  
    // has too many dangerous side effects depending on Unix system used.
    
    // the following should be equivalent or better, but it ain't
    // no good if run from the commandline, no ctrl-c or -z possible.
    // setpgrp();       
    xshell_init();   // before loading.

    /* cant do this anymore without access to the XForms source:
    fl_focus_restore_start  = focus_restore_start;
    fl_focus_restore_finish = focus_restore_finish;
    fl_focus_move = tool_focus_move;
    fl_focus_save = focus_save;
    */

    strcpy(default_editor, "<builtin>");

    if(!getenv("DISPLAY")){
	// double safeguard.
        cerr << "Sorry, the DISPLAY environment variable is not defined.\n";
        cerr << "Please set it, for example to `:0'.\n";
	exit(1);
    }
    // have name use `@name:' Else use `:'
    char buffer0[MAXHOSTNAMELEN+1], buffer1[sizeof(buffer0) + 2];
    if(gethostname(buffer0, sizeof(buffer0)) == 0){
	// cerr << "running on host: " << buffer0 << endl;
	char *dpy_name = getenv("DISPLAY");
	if(dpy_name){
	    // cerr << "running on display: " << dpy_name << endl;
	    char *dpy_buf = strdup(dpy_name);
	    char *where = strchr(dpy_buf, ':');
	    int local_flag = TRUE;
	    if(where){
		*where = '\0';
		if(strlen(dpy_buf) > 0){
		    if(strcmp(buffer0, dpy_buf) != 0){
			if(strcmp("shm", dpy_buf) != 0){    // shared memory extension.
			    local_flag = FALSE;
			}
		    }
		}
	    }
	    fl_free(dpy_buf);
	    dpy_buf = NULL;
	    if(local_flag){
		M_info("tool_init", "running on local display");
		tool_host_string = strdup(":");
	    } else {
		strcpy(buffer1, "@");
		strcat(buffer1, buffer0);
		strcat(buffer1, ":");
		tool_host_string = strdup(buffer1);
	    }
	}
    } else {
	cerr << "UC: couldn't get hostname, sorry.\n";
	tool_host_string = strdup(":");
    }
    
    char *home_buf = getenv("HOME");
    if(home_buf){
	sprintf(buf, "%s/.uc", home_buf);
	tool_ldefault_dir = strdup(buf);
	sprintf(buf, "%s/ucdb", tool_ldefault_dir);
	tool_default_fname = strdup(buf);
	// make the directory if it doesn't exist.
	struct stat statbuf;
	if(stat(tool_ldefault_dir, &statbuf) != 0){
	    // make it.
	    action_work_noform();
	    do_fork_mkdir(tool_ldefault_dir);
	} else {
	    if(!S_ISDIR(statbuf.st_mode)){
		timed_error_notifier("Warning: A file $HOME/.uc exists and is not a directory!");
	    }
	    if(!try_access(&statbuf, X_OK)){
		timed_error_notifier("Warning: A directory $HOME/.uc exists but is not accessible !");
	    }
	}
    } else {
	error_msg("UC: Warning: couldn't getenv HOME.");
    }

    if(tool_ldefault_dir){
	M_info("tool_init", "local default directory is %s", tool_ldefault_dir);
    }

    char *root_buf = getenv("UC_HOME");
    if(!root_buf){
	root_buf = "/usr/local/lib/uc";    // fallback.
    }
    tool_gdefault_dir = strdup(root_buf);

    if(tool_gdefault_dir){
	M_info("tool_init", "global default directory is %s", tool_gdefault_dir);
    }

    M_info("tool_init", "done validating.");

    // hack, recolor the default cursor.
    // fl_set_cursor_color(fl_default_curname, FL_RED, FL_WHITE);
    fl_set_cursor_color(XC_left_ptr, FL_RED, FL_WHITE);
    
    // preemptive, no sync. Allows to decide wether to show startup msg.
    // also allows early start of shell (good because of delays). 
    tool_defaults_load(tool_default_fname, FALSE);

    // The message HAS TO BE SHOWN NO MATTER WHAT - even if it is only for
    // a millisecond. UC uses this to query the window manager about sizing,
    // window location and movement. Every wm is different, there's not really
    // a better way.
    startup_msg();

    // after startup msg, now the wm border values are valid :-)
    tool_max_ww = fl_scrw - 2*(fl_wmstuff.rpx + fl_wmstuff.bw);
    tool_max_wh = fl_scrh - (fl_wmstuff.rpy + fl_wmstuff.bw) - (fl_wmstuff.rpx + fl_wmstuff.bw);
    bound_value(tool_max_ww, fl_scrw - 30, fl_scrw);
    bound_value(tool_max_wh, fl_scrh - 50, fl_scrh);

    // also, the bw flag is valid
    if(fl_depth(fl_vmode) <= 1){
	tool_bw_flag = TRUE;
	M_warn("UC:init_forms", "running in B/W mode, depth %d", fl_depth(fl_vmode));
	//cerr << "BW is active(" << fl_depth(fl_vmode) << ").\n";
    } else {
	M_warn("UC:init_forms", "running in color mode.");
	tool_bw_flag = FALSE;
    }

    status_msg(1, "loading ... ");

    M_debug("tool_init", "making browsers.");
    browser_c *ab, *ac;
    // we need one browser, so class vars are initialized.
    // this is the minimal configuration, into which more browsers
    // can be inserted.
    ab = new browser_c();
    if(!ab){
	program_unstable("Memory allocation failed.");
	return;
    }
    source_browser = ab;
    source_browser->set_source(TRUE);
    target_browser = ab;
    target_browser->set_target(TRUE);

    if(tool_number_of_browsers > 1){
	ac = ab; // in case we only have one. 
	// make it, test make, insert it, show it, advance the insertion pointer.
	for(int i=1; i<tool_number_of_browsers; i++){
	    ac = new browser_c();
	    if(!ac){
		program_unstable("Memory allocation failed.");
		return;
	    }
	    ab->rb_insert_after(ac);
	    ab = ac;
	}
	tool_set_target(ac);
    }
    tool_sync_defaults();  // cause it's not done by load.
    browser_c *tmp_browser = tool_find_browser_id(1);
    browser_c *start_browser = tmp_browser;
    do {
	tmp_browser->show();
	tmp_browser = tmp_browser->next_browser;
    } while(tmp_browser != start_browser);
    if (tool_focus_on_startup_flag) {
	tool_set_source(source_browser, TRUE);
    }
    dir_menu_remember_last(source_browser->get_cwd());
    wm_raise_form(); // to get it on top, if it is there.
}

void my_new_handler(){
    fprintf(stderr, "UC internal: Can't allocate more memory !");
    //setbell(2);
    XBell(fl_display, 0);
    exit(-1);
}

static void print_intro_msg(void){
    cerr << "UC - The " << version_os << " Unix Cockpit V" << version_major << ".";
    cerr << version_minor << " (Compiled @ " << version_date << ")." << endl;
    cerr << "Written 1989-2000 by henrik@klagges.com. Distributed under GNU GPL." << endl;
    cerr << "Special Thanks: XForms v0.89 (C) 2000 by TC Zhao and Mark Overmars." << endl;
}

static int uc_xerror_handler(Display *dpy, XErrorEvent *err){
    if(dpy != fl_display){
	M_err("UC: xerror", "displays out of sync");
	return 0;
    }
    if(!err){
	M_err("UC: xerror", "Null error event.\n");
	return 0;
    }
    char error_buf[1024];
    XGetErrorText(dpy, err->error_code, error_buf, sizeof(error_buf));
#ifdef BETA    
    M_err
#else
    M_warn
#endif
    ("UC: X error", "(%s)\n  serial %d\n  major opcode %d\n  minor opcode %d\n  resource %d\n",
	error_buf,
	err->serial,
	(int) err->request_code,
	(int) err->minor_code,
	err->resourceid
    );
    xshell_check_errorevent(err);
    return 0;
}

static int uc_xioerror_handler(Display *){
    cerr << "UC: fatal X I/O error. Sorry. Email Henrik@klagges.com and complain :)\n";
    return 0;
}

extern "C" void fl_set_button_bw(int);

static FL_CMD_OPT ucopt[1];
// = {
/* examples:
    {"-geometry", "*geometry", XrmoptionSepArg, 0},
    {"-altformat", "*altformat", XrmoptionNoArg, "1"},
*/
//};

// Fails: #define Ncopt (sizeof(fdopt)/sizeof(fdopt[0]))
#define Nopt 0

static void init_forms(int &argc, char *argv[]){
    FL_IOPT iopt;
    memset(&iopt, 0, sizeof(FL_IOPT));
    iopt.sharedColormap = TRUE; // doesn't work! Why?
    iopt.vclass = FL_DefaultVisual;
    fl_set_defaults(FL_PDVisual | FL_PDSharedMap, &iopt);
    fl_initialize(&argc, argv, "UC", ucopt, Nopt);
    fl_set_ul_property(TRUE, 1);

    //M_warn("UC:init_forms","DoesSaveUnders(%d)", DoesSaveUnders(fl_screen));
    //cerr << DoesSaveUnders(&fl_screen);
    
    if(XSetErrorHandler(uc_xerror_handler)){
	M_warn("init_forms:","unknown error handler removed.");
    }
    XSetIOErrorHandler(uc_xioerror_handler);
    //fl_set_button_bw(2);
}

static void fork_off(void) {
    switch(fork()) {
    case -1:	exit(1);	// error
    case 0:	return;		// child
    default:	_exit(0);	// parent
    }
}

static void options(int argc, char *argv[]){
    if(argc > 1){
	int c;
	while((c = getopt(argc, argv, "f")) != EOF){
	    switch(c){
	    case 'f':
		fork_off();
		break;
	    default:
		cerr << "\nusage: " << argv[0] << " <-f to fork into background> \n";
		cerr << "Use the F1 and Ctrl-F1 keys to invoke UC's online help.\n\n";
		exit(0);
		break;
	    }
	}
	// strcpy argv[0] "" doesn't work anymore.
    }
}

static void x_server_query(void){
    char *pcServerVendor = XServerVendor(fl_display);
    if (!pcServerVendor) return;
    if (strstr(pcServerVendor, "Sun Microsystems")) {
	sun_keyboard_flag = TRUE;
	status_msg(2, "Looks like a Sun X-Server.");
    }
}

int main(int argc, char *argv[]){
    set_new_handler(&my_new_handler);
    print_intro_msg();
    init_pathnames(); // early !
    
    if (setlocale(LC_ALL, "") == NULL){
	// error
    }
    init_forms(argc, argv);
    options(argc, argv);   

    // bad idea: fl_set_graphics_mode(FALSE, TRUE); looks bad, redraw still bad.

    init_callbacks();
    create_all();
    tool_init();
    x_server_query();
    
    status_msg(1, "loading done.");
    
    fl_qenter(CALLBACK_LOOP_INIT_CMSG, 1);
    
    callback_event_loop();
    return 0;
}
