/*
 * encapsulate all tree colour manipulation.
 */

#ifndef WM_FORMS_AUX_H
#define WM_FORMS_AUX_H

#include <fstream.h>
#include "forms.h"

extern FL_Coord 
    wm_forms_fudge_dx, 
    wm_forms_fudge_dy
;

extern long get_windows_menu(void);

extern int
    wm_visible_flag,
    wm_wx,
    wm_wy,
    wm_ww,
    wm_wh
;

extern void 
    tool_hide          (void),
    tool_iconify       (void),
    tool_show          (void),
    tool_move_relative (int dx, int dy),
    tool_pop           (void),
    tool_push          (void),

    windows_menu_cb    (void),

    wm_compute_fudges  (FL_FORM *form),    // for visible startup form only
    wm_create_the_forms(void),
    wm_save_defaults   (ofstream &ofile),
    wm_close_form      (void),         
    wm_raise_form      (void),
    wm_show_form       (int move_mouse_flag = FALSE),
    wm_sync_defaults   (void)
;

int wm_load_default(
    const char *obj_tok, 
    const char *name_tok, 
    const char *val_tok
);

void wait_configure(Window window, int clicks = 25);

#endif
