/*
 * xshell.h: 
 * declare xshell interface.
 */

#ifndef XSHELL_H
#define XSHELL_H

#include <fstream.h>
#include <X11/Xlib.h>

extern int
    xshell_update_count,	// default 40 eqiv 4/secs
    xshell_wx,
    xshell_wy,
    xshell_ww,
    xshell_wh
;

// pump an ascii string to the xshell. No controls allowed.
int xshell_string (const char *string, int add_newline_flag = FALSE);

// pump a (control) character to the cockpit shell.
int xshell_key(char key, int ctrl_flag, int sync_flag, int check_flag);

extern int xshell_needs_enter_flag;
int xshell_sendevent_callback(XKeyEvent *xev, KeySym keysym);

extern int xshell_visible_flag;

void xshell_cd(const char *dir);
int  xshell_check_event(XEvent *xev = NULL);
int  xshell_show(void);
int  xshell_check_win(Window window);
void xshell_close(void);
void xshell_init(void);   // call before loading defaults.
void xshell_move_relative(int dx, int dy);
void xshell_help_func(void);
void xshell_save_defaults(ofstream &ofile);
void xshell_sync_defaults(void);   // after loading. 
void xshell_sync_title(void);   

void xshell_show_form(void);

Window xshell_get_win(void);  // None if not visible.

int xshell_load_default(
    const char *obj_tok, 
    const char *name_tok, 
    const char *val_tok
);

void xshell_error_handler_cb(FL_OBJECT *, long);
void xshell_send_interrupt(void);
int xshell_check_errorevent(XErrorEvent *err);

#endif	// XSHELL_H

